/**
 * Created by littwin on 03.05.14.
 */
module.exports = function (grunt) {
    var webpack = require("webpack");
    grunt.initConfig({
            pkg: grunt.file.readJSON('package.json'),

            sass: {                              // Task
                dev: {                            // Target
                    options: {                       // Target options
                        style: 'expanded'
                    },
                    files: [{
                        expand: true,
                        cwd: 'wwwsrc/modules/front2/style/',
                        src: ['*.scss'],
                        dest: 'www/modules/front2/www/css',
                        ext: '.css'
                    }]
                },
                prod: {                            // Target
                    options: {                       // Target options
                        style: 'compressed',
                        sourcemap: 'none'
                    },
                    files: [{
                        expand: true,
                        cwd: 'wwwsrc/modules/front2/style/',
                        src: ['*.scss'],
                        dest: 'wwwdist/modules/front2/www/css',
                        ext: '.css'
                    }]
                }
            },
            compress: {
                dev: {
                    options: {
                        mode: 'gzip',
                        level: 8
                    },
                    files: [{
                        expand: true,
                        cwd: 'www/js/',
                        src: ['libraries2-min.js', 'libraries-min.js'],
                        dest: 'www/js/',
                        ext: '.js.gz'
                    }]
                },
                prod: {
                    options: {
                        mode: 'gzip',
                        level: 8
                    },
                    files: [{
                        expand: true,
                        cwd: 'wwwdist/',
                        src: ['js/libraries2-min.js', 'js/libraries-min.js'],
                        dest: 'wwwdist/',
                        ext: '.js.gz'
                    }]
                }
            },

            watch: {
                sass: {
                    files: ['wwwsrc/modules/front2/style/*.scss'],
                    tasks: ['sass:dev'],
                    options: {
                        spawn: false
                    }
                }
            }
        }
    )
    ;

    grunt.loadNpmTasks('grunt-contrib-watch');
    grunt.loadNpmTasks('grunt-contrib-sass');

    grunt.registerTask('default', ['sass:dev', 'sass:prod']);

}
;