var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RepetierServer_1 = require("../RSBinding/RepetierServer");
var DashboardComponent = (function () {
    function DashboardComponent(server) {
        this.server = server;
    }
    DashboardComponent = __decorate([
        core_1.Component({
            selector: 'rs-dashboard',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n    <rs-sideicon *ngIf=\"server.printers?.active?.printing\" title=\"<?php _('Print') ?>\" icon=\"rs rs-print\" link=\"/print-status\"></rs-sideicon>\n    <rs-sideicon *ngIf=\"!server.printers?.active?.printing\" icon=\"rs rs-move-xy\" title=\"<?php _('Move') ?>\" link=\"/move-tool\"></rs-sideicon>\n</side><side>\n    <rs-sideicon icon=\"rs rs-params\" title=\"<?php _('Params.') ?>\" link=\"/params\"></rs-sideicon>\n</side>\n<main>\n    <h1>{{server?.printers?.active?.name}}</h1>\n    <div class=\"content-h1\" rs-drag>\n    <rs-iconlist>\n        <rs-icon icon=\"rs rs-file-gcode\" title=\"<?php _('G-Codes') ?>\" link=\"/gcodes\"></rs-icon>\n        <rs-icon *ngIf=\"server.active?.queue?.length>0\" icon=\"rs rs-printqueue\" title=\"<?php _('Print Queue') ?>\" link=\"/print-queue\"></rs-icon>\n        <rs-icon icon=\"rs rs-move-xy\" title=\"<?php _('Move') ?>\" link=\"/move-tool\"></rs-icon>\n        <rs-icon icon=\"rs rs-printer\" title=\"Printers\" link=\"/printer-list\"></rs-icon>\n        <rs-icon icon=\"fa fa-sitemap\" title=\"<?php _('Network') ?>\" link=\"/network\"></rs-icon>\n        <rs-icon icon=\"rs rs-print\" title=\"<?php _('Print') ?>\" link=\"/print-status\"></rs-icon>\n        <rs-icon icon=\"rs rs-params\" title=\"<?php _('Params.') ?>\" link=\"/params\"></rs-icon>\n        <rs-icon icon=\"rs rs-usbstick\" title=\"<?php _('Import') ?>\" link=\"/import\"></rs-icon>\n        <rs-icon icon=\"rs rs-printer-commands\" title=\"<?php _('Printer Cmds.') ?>\" link=\"/printer-commands\"></rs-icon>\n        <rs-icon icon=\"rs rs-server-commands\" title=\"<?php _('Server Cmds.') ?>\" link=\"/server-commands\"></rs-icon>\n        <rs-icon icon=\"fa fa-wifi\" title=\"WLAN\" link=\"/wlan\"></rs-icon>\n        <rs-icon icon=\"rs rs-move-z\" title=\"<?php _('Z Move') ?>\" link=\"/move-z-tool\"></rs-icon>\n        <rs-icon icon=\"rs rs-extruder\" title=\"<?php _('Extruder') ?>\" link=\"/move-e-tool\"></rs-icon>\n        <rs-icon icon=\"rs rs-chart\" title=\"<?php _('Temp. Graph') ?>\" link=\"/temperatures\"></rs-icon>\n        <rs-icon icon=\"fa fa-language\" title=\"<?php _('Language') ?>\" link=\"/languages\"></rs-icon>\n        <rs-icon icon=\"rs rs-webcam\" title=\"Webcam\" link=\"/webcam\"></rs-icon>\n    </rs-iconlist>\n    </div>\n</main>\n</rs-page>",
            directives: [RSFrontUI_1.RSFRONTUI]
        }), 
        __metadata('design:paramtypes', [RepetierServer_1.RepetierServer])
    ], DashboardComponent);
    return DashboardComponent;
})();
exports.DashboardComponent = DashboardComponent;
//# sourceMappingURL=dashboard.component.js.map