var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RSBinding_1 = require("../RSBinding");
var MoveComponent = (function () {
    function MoveComponent(server) {
        this.server = server;
        this.page = 0;
        this.printer = undefined;
    }
    MoveComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.printers.active;
    };
    MoveComponent.prototype.setXYStep = function (v) {
        this.printer.xyzStepSize = v;
        this.page = 0;
    };
    MoveComponent = __decorate([
        core_1.Component({
            selector: 'rs-move-xy-component',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n    <rs-sideicon title=\"<?php _('Z Move') ?>\" icon=\"rs rs-move-z\" link=\"/move-z-tool\"></rs-sideicon>\n</side>\n<side>\n    <rs-sideicon title=\"<?php _('Extrude') ?>\" icon=\"rs rs-extruder\" link=\"/move-e-tool\"></rs-sideicon>\n</side>\n<main>\n<h1>Move Head</h1>\n<div class=\"centered-grid stacked\" style=\"height:210px\" *ngIf=\"page==0\">\n<div class=\"centered-grid\" style=\"width:100%\">\n    <div class=\"col-3\">\n        X:<span class=\"coordinate\" [innerHTML]=\"printer?.posX|coord:2\"></span>\n    </div>\n    <div class=\"col-3\">\n        Y:<span class=\"coordinate\" [innerHTML]=\"printer?.posY|coord:2\"></span>\n    </div>\n    <div class=\"col-3\">\n        Z:<span class=\"coordinate\" [innerHTML]=\"printer?.posZ|coord:2\"></span>\n    </div>\n</div>\n<div class=\"centered-grid\" style=\"margin-left: 10px;\">\n<!-- 3 x 3 move grid -->\n<div class=\"regular-grid\" style=\"width:190px;height:160px\">\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yUpXLeft')\"><i class=\"rs rs-arrow-h-up-left\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yUp')\"><i class=\"rs rs-arrow-h-up\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yUpXRight')\"><i class=\"rs rs-arrow-h-up-right\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('xLeft')\"><i class=\"rs rs-arrow-h-left\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"accent\" style=\"font-size:14px\">{{printer?.xyzStepSize|fixed:2}}<br>mm</rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('xRight')\"><i class=\"rs rs-arrow-h-right\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yDownXLeft')\"><i class=\"rs rs-arrow-h-down-left\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yDown')\"><i class=\"rs rs-arrow-h-down\"></i></rs-icon-button></div>\n    <div class=\"col-3\"><rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('yDownXRight')\"><i class=\"rs rs-arrow-h-down-right\"></i></rs-icon-button></div>\n</div>\n<div style=\"margin-left:15px;width:50px;height:160px\" class=\"regular-grid stacked\">\n<rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('home')\"><i class=\"fa fa-home\"></i><h3><?php _('Home All') ?></h3></rs-icon-button>\n<rs-icon-button class=\"primary\" (hit)=\"page=1\"><i class=\"rs rs-distance\"></i>\n<h3><?php _('Distance') ?></h3>\n</rs-icon-button>\n<rs-icon-button class=\"primary\" [disabled]=\"printer?.printing\" (hit)=\"server.printers.active.executeNamedFunction('motorsOff')\"><i class=\"rs rs-motor-off\" style=\"font-size: 20px\"></i><h3><?php _('Motors Off') ?></h3></rs-icon-button>\n</div>\n</div>\n</div>\n<div class=\"centered-grid stacked\" style=\"height:210px\" *ngIf=\"page==1\">\n    <div class=\"centered-grid\">\n        <h2><?php _('Select Step Distance') ?></h2>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(0.01)\">0.01 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(0.1)\">0.1 mm</rs-button></div>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(1)\">1 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(10)\">10 mm</rs-button></div>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(25)\">25 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(50)\">50 mm</rs-button></div>\n    </div>\n</div>\n</main>\n</rs-page>",
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer])
    ], MoveComponent);
    return MoveComponent;
})();
exports.MoveComponent = MoveComponent;
var MoveZComponent = (function () {
    function MoveZComponent(server) {
        this.server = server;
        this.page = 0;
        this.printer = undefined;
    }
    MoveZComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.printers.active;
    };
    MoveZComponent.prototype.setXYStep = function (v) {
        this.printer.xyzStepSize = v;
        this.page = 0;
    };
    MoveZComponent = __decorate([
        core_1.Component({
            selector: 'rs-move-z-component',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n    <rs-sideicon title=\"<?php _('XY Move') ?>\" icon=\"rs rs-move-xy\" link=\"/move-tool\"></rs-sideicon>\n</side>\n<side>\n    <rs-sideicon title=\"<?php _('Extrude') ?>\" icon=\"rs rs-extruder\" link=\"/move-e-tool\"></rs-sideicon>\n</side>\n<main>\n<h1><?php _('Z Move') ?></h1>\n<div class=\"centered-grid stacked\" style=\"height:210px\" *ngIf=\"page==0\">\n<div class=\"centered-grid\" style=\"width:100%\">\n    <div class=\"col-3\">\n        X:<span class=\"coordinate\" [innerHTML]=\"printer?.posX|coord:2\"></span>\n    </div>\n    <div class=\"col-3\">\n        Y:<span class=\"coordinate\" [innerHTML]=\"printer?.posY|coord:2\"></span>\n    </div>\n    <div class=\"col-3\">\n        Z:<span class=\"coordinate\" [innerHTML]=\"printer?.posZ|coord:2\"></span>\n    </div>\n</div>\n<div class=\"centered-grid\" style=\"margin-left: 10px;\">\n<!-- 3 x 3 move grid -->\n<div class=\"regular-grid stacked\" style=\"width:190px;height:160px\">\n    <div class=\"col-1\"><rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('zUp')\"><i class=\"rs rs-arrow-h-up\"></i></rs-icon-button></div>\n    <div class=\"col-1\"><rs-icon-button class=\"accent\" style=\"font-size:14px\">{{printer?.xyzStepSize|fixed:2}}<br>mm</rs-icon-button></div>\n    <div class=\"col-1\"><rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('zDown')\"><i class=\"rs rs-arrow-h-down\"></i></rs-icon-button></div>\n</div>\n<div style=\"margin-left:15px;width:50px;height:160px\" class=\"regular-grid stacked\">\n<rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('home')\"><i class=\"fa fa-home\"></i><h3><?php _('Home All') ?></h3></rs-icon-button>\n<rs-icon-button class=\"primary\" (hit)=\"page=1\"><i class=\"rs rs-distance\"></i>\n<h3><?php _('Distance') ?></h3>\n</rs-icon-button>\n<rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('motorsOff')\"><i class=\"rs rs-motor-off\" style=\"font-size: 20px\"></i><h3><?php _('Motors Off') ?></h3></rs-icon-button>\n</div>\n</div>\n</div>\n<div class=\"centered-grid stacked\" style=\"height:210px\" *ngIf=\"page==1\">\n    <div class=\"centered-grid\">\n        <h2><?php _('Select Step Distance') ?></h2>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(0.01)\">0.01 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(0.1)\">0.1 mm</rs-button></div>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(1)\">1 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(10)\">10 mm</rs-button></div>\n    </div>\n    <div class=\"centered-grid w100\">\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(25)\">25 mm</rs-button></div>\n        <div class=\"col-2\"><rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setXYStep(50)\">50 mm</rs-button></div>\n    </div>\n</div>\n</main>\n</rs-page>",
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer])
    ], MoveZComponent);
    return MoveZComponent;
})();
exports.MoveZComponent = MoveZComponent;
var MoveEComponent = (function () {
    function MoveEComponent(server, ui) {
        this.server = server;
        this.ui = ui;
        this.page = 0;
        this.printer = undefined;
    }
    MoveEComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.active;
    };
    MoveEComponent.prototype.setEStep = function (v) {
        this.printer.eStepSize = v;
        this.page = 0;
    };
    MoveEComponent = __decorate([
        core_1.Component({
            selector: 'rs-move-e-component',
            template: "\n<rs-page>\n    <side>\n        <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n    </side>\n    <side>\n        <rs-sideicon title=\"<?php _('XY Move') ?>\" icon=\"rs rs-move-xy\" link=\"/move-tool\"></rs-sideicon>\n    </side>\n    <side>\n        <rs-sideicon title=\"<?php _('Z Move') ?>\" icon=\"rs rs-move-z\" link=\"/move-z-tool\"></rs-sideicon>\n    </side>\n    <main>\n        <h1><?php _('Extrude and Retract') ?></h1>\n        <div class=\"centered-grid stacked margin-leftright\" style=\"height:210px\" *ngIf=\"page==0 && printer?.extruders\">\n            <div class=\"w100\">\n                <rs-button class=\"secondary full\" (hit)=\"ui.selectExtruder()\">\n                    {{printer.extruders[printer.activeExtruderId]?.currentTemp}} |\n                    {{printer.extruders[printer.activeExtruderId]?.tempSet}}\u00B0C\n                    {{printer.extruderName(printer.activeExtruderId)}}\n                </rs-button>\n            </div>\n            <div class=\"centered-grid\">\n                <!-- 3 x 3 move grid -->\n                <div class=\"centered-grid\" style=\"width:190px;height:160px\">\n                    <div class=\"col-2\">\n                        <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('eRetract')\">\n                            <i class=\"rs rs-arrow-h-up\"></i></rs-icon-button>\n                    </div>\n                    <div class=\"col-2\">\n                        <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('eRetractFast')\">\n                            <i class=\"rs rs-arrow-h-double-up\"></i></rs-icon-button>\n                    </div>\n                    <div class=\"col-1\">\n                        <rs-icon-button class=\"accent\" style=\"font-size:14px\">{{printer?.eStepSize|fixed:2}}<br>mm\n                        </rs-icon-button>\n                    </div>\n                    <div class=\"col-2\">\n                        <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('eExtrude')\">\n                            <i class=\"rs rs-arrow-h-down\"></i></rs-icon-button>\n                    </div>\n                    <div class=\"col-2\">\n                        <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('eExtrudeFast')\">\n                            <i class=\"rs rs-arrow-h-double-down\"></i></rs-icon-button>\n                    </div>\n                </div>\n                <div style=\"margin-left:15px;width:50px;height:160px\" class=\"regular-grid stacked\">\n                    <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"ui.setExtruderTemp(printer?.activeExtruderId)\">\n                        <i class=\"rs rs-temperature\"></i>\n                        <h3><?php _('Set Temp.') ?></h3></rs-icon-button>\n                    <rs-icon-button class=\"primary\" (hit)=\"page=1\"><i class=\"rs rs-distance\"></i>\n                        <h3><?php _('Distance') ?></h3>\n                    </rs-icon-button>\n                    <rs-icon-button class=\"primary\" [disabled]=\"!printer?.idle\" (hit)=\"server.printers.active.executeNamedFunction('motorsOff')\">\n                        <i class=\"rs rs-motor-off\" style=\"font-size: 20px\"></i>\n                        <h3><?php _('Motors Off') ?></h3></rs-icon-button>\n                </div>\n            </div>\n        </div>\n        <div class=\"centered-grid stacked\" style=\"height:210px\" *ngIf=\"page==1\">\n            <div class=\"centered-grid\">\n                <h2><?php _('Select Step Distance') ?></h2>\n            </div>\n            <div class=\"centered-grid w100\">\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(0.01)\">0.01 mm</rs-button>\n                </div>\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(0.1)\">0.1 mm</rs-button>\n                </div>\n            </div>\n            <div class=\"centered-grid w100\">\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(1)\">1 mm</rs-button>\n                </div>\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(10)\">10 mm</rs-button>\n                </div>\n            </div>\n            <div class=\"centered-grid w100\">\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(25)\">25 mm</rs-button>\n                </div>\n                <div class=\"col-2\">\n                    <rs-button class=\"primary big\" style=\"width: 100px\" (click)=\"setEStep(50)\">50 mm</rs-button>\n                </div>\n            </div>\n        </div>\n    </main>\n</rs-page>",
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer, RSFrontUI_1.RSUIHelper])
    ], MoveEComponent);
    return MoveEComponent;
})();
exports.MoveEComponent = MoveEComponent;
//# sourceMappingURL=move.component.js.map