/**
 * Created by littwin on 15.05.16.
 */
var core_1 = require('@angular/core');
var RSBinding_1 = require('../RSBinding');
var RSFrontUI_1 = require("../RSFrontUI");
//import { Route, ROUTER_DIRECTIVES, ROUTER_PROVIDERS } from '@angular/router';
var NetworksComponent = (function () {
    function NetworksComponent(server) {
        var _this = this;
        this.server = server;
        this.net = { ipv4: [] };
        this.localEventHandler = function (evt) {
            switch (evt.event) {
                case "connected":
                    _this.updateInterfaces();
                    break;
            }
        };
    }
    NetworksComponent.prototype.updateInterfaces = function () {
        var _this = this;
        this.server.networkInterfaces().then(function (data) {
            _this.net = data;
        }, function () { });
    };
    NetworksComponent.prototype.ngOnInit = function () {
        this.localEventSubscription = this.server.localEvents.subscribe(this.localEventHandler);
        if (this.server.connected)
            this.updateInterfaces();
    };
    NetworksComponent.prototype.ngOnDestroy = function () {
    };
    NetworksComponent = __decorate([
        core_1.Component({
            selector: 'networks',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"Home\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side>\n<side>\n    <rs-sideicon title=\"WLAN\" icon=\"fa fa-rss\" link=\"/print-status\"></rs-sideicon>\n</side>\n<main>\n    <h1 class=\"margin-bottom\"><?php _('Network Interfaces') ?></h1>\n    <div class=\"content-h1\" rs-drag>\n    <div  *ngFor=\"let n of net.ipv4\">\n <h2>{{server.httpType}}://{{n.ip}}:{{net.port}}</h2>\n<div style=\"text-align: center;margin:8px\">\n                    <rs-qrcode [ip]=\"n.ip\" [port]=\"net.port\" margin=\"2\" modSize=\"5\"></rs-qrcode>\n                    </div></div>\n</div>\n</main>\n</rs-page>\n    ",
            providers: [],
            directives: [RSFrontUI_1.RSFRONTUI, RSBinding_1.RSQRCode]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer])
    ], NetworksComponent);
    return NetworksComponent;
})();
exports.NetworksComponent = NetworksComponent;
//# sourceMappingURL=networks.component.js.map