/**
 * Created by littwin on 08.06.16.
 */
var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RSBinding_1 = require("../RSBinding");
var ParamsComponent = (function () {
    function ParamsComponent(server, ui) {
        this.server = server;
        this.ui = ui;
    }
    ParamsComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.printers.active;
    };
    ParamsComponent = __decorate([
        core_1.Component({
            selector: 'rs-params-component',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side>\n<side>\n    <rs-sideicon *ngIf=\"printer?.printing\" title=\"<?php _('Print') ?>\" icon=\"rs rs-print\" link=\"/print-status\"></rs-sideicon>\n</side>\n<side><rs-sideicon title=\"<?php _('Temp.') ?>\" icon=\"rs rs-chart\" link=\"/temperatures\"></rs-sideicon></side>\n<main>\n    <h1><?php _('Printer Status') ?></h1>\n    <div class=\"content-h1 margin-leftright\" *ngIf=\"printer\" rs-drag>\n        <div class=\"value-list\" *ngFor=\"let p of printer.extruders;let idx = index\">\n            <div><i class=\"rs rs-extruder fw\"></i> <span [class.strong]=\"idx==printer.activeExtruderId\">{{printer.extruderName(idx)}}</span></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"ui.setExtruderTemp(idx)\">{{p.currentTemp|fixed:1}} | {{p.tempSet|fixed:0}}\u00B0C</rs-button></div>\n        </div>\n        <div class=\"value-list\" *ngIf=\"printer.config.heatedBed?.installed\">\n            <div><i class=\"rs rs-heated-bed fw\"></i> <?php _('Bed') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"ui.setBedTemp()\">{{printer.heatedBed.currentTemp|fixed:1}} | {{printer.heatedBed.tempSet|fixed:0}}\u00B0C</rs-button></div>\n        </div>\n        <div class=\"value-list\" *ngIf=\"printer.config.heatedBed?.installed\" *ngIf=\"printer.config.general?.fan\">\n            <div><i class=\"rs rs-fan fw\"></i> <?php _('Fan') ?></div>\n            <div class=\"regular-grid\">\n                <rs-switch [(checked)]=\"printer.fanOn\" style=\"margin:auto\"></rs-switch>\n                <rs-button class=\"secondary fixedvalue\" (hit)=\"ui.setFan()\">{{printer.fanPercent|fixed:0}}%</rs-button>\n            </div>\n        </div>\n        <div class=\"value-list\">\n            <div><i class=\"rs rs-speed fw\"></i> <?php _('Speed') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"ui.setSpeed()\">{{printer.speedMultiply}}%</rs-button></div>\n        </div>\n        <div class=\"value-list\">\n            <div><i class=\"rs rs-flow fw\"></i> <?php _('Flow') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"ui.setFlow()\">{{printer.flowMultiply}}%</rs-button></div>\n        </div>\n    </div>\n</main>\n</rs-page>\n    ",
            providers: [],
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer, RSFrontUI_1.RSUIHelper])
    ], ParamsComponent);
    return ParamsComponent;
})();
exports.ParamsComponent = ParamsComponent;
//# sourceMappingURL=params.component.js.map