/**
 * Created by littwin on 07.06.16.
 */
var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RSBinding_1 = require("../RSBinding");
var gcodes_component_1 = require("./gcodes.component");
var PrintQueueComponent = (function () {
    function PrintQueueComponent(server) {
        this.server = server;
        this.page = 0;
    }
    PrintQueueComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.printers.active;
        if (!this.printer)
            return;
        this.group = this.printer.activeGroup;
    };
    PrintQueueComponent.prototype.selectGCode = function (gc) {
        this.printer.activeGCode = gc;
        this.page = 1;
    };
    PrintQueueComponent = __decorate([
        core_1.Component({
            selector: 'print-queue',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n    <!--<rs-sideicon title=\"Back\" icon=\"fa fa-reply\" link=\"/printer-list\"></rs-sideicon>-->\n</side>\n<side>\n    <rs-sideicon title=\"<?php _('Back') ?>\" icon=\"fa fa-reply\" (click)=\"page=0\" *ngIf=\"page>0\"></rs-sideicon>\n</side>\n<main>\n<div *ngIf=\"page==0\">\n<h1><?php _('Print Queue') ?></h1>\n<div class=\"content-h1\" rs-drag>\n    <div class=\"entry-list\">\n    <div class=\"entry left\" *ngFor=\"let f of printer?.queue\" (click)=\"selectGCode(f)\">\n        <div class=\"left\">\n            <img [src]=\"f.imgT\">\n        </div>\n        <h3>{{f.name}}</h3>\n        <p>{{f.printTime|dhms}}</p>\n    </div>\n    </div>\n</div>\n</div>\n<gcode-info *ngIf=\"page==1\"></gcode-info>\n</main>\n</rs-page>\n    ",
            directives: [RSFrontUI_1.RSFRONTUI, gcodes_component_1.GCodeInfo],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer])
    ], PrintQueueComponent);
    return PrintQueueComponent;
})();
exports.PrintQueueComponent = PrintQueueComponent;
//# sourceMappingURL=printqueue.component.js.map