var core_1 = require('@angular/core');
var RSBinding_1 = require("../RSBinding");
var RSFrontUI_1 = require("../RSFrontUI");
var PrintStatusComponent = (function () {
    function PrintStatusComponent(modal, stringKeyboard, server, ui) {
        this.modal = modal;
        this.stringKeyboard = stringKeyboard;
        this.server = server;
        this.ui = ui;
        this.height1 = 100;
        if (window.rsHeight > 300)
            this.height1 = 150;
    }
    PrintStatusComponent.prototype.ngDoCheck = function () {
        this.printer = this.server.printers.active;
    };
    PrintStatusComponent = __decorate([
        core_1.Component({
            selector: 'rs-print-status',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n    <rs-sideicon title=\"<?php _('Temp.') ?>\" icon=\"rs rs-chart\" link=\"/temperatures\"></rs-sideicon>\n</side>\n<side>\n    <rs-sideicon title=\"<?php _('Params') ?>\" icon=\"rs rs-params\" link=\"/params\"></rs-sideicon>\n</side>\n<main style=\"padding:10px\" rs-drag>\n<h1><?php _('Printing:') ?> {{printer?.printJob}}</h1>\n<div class=\"content-h1 margin-leftright15\" rsdrag>\n<div class=\"centered-grid stacked content-h1\">\n<div class=\"regular-grid margin-leftright\" *ngIf=\"printer?.printing\" style=\"width: 100%;\">\n<rs-gauge [width]=\"height1\" [height]=\"height1\" [value]=\"printer?.printDone\" rangeWidth=\"12\" valueWidth=\"12\" divider=\"true\" type=\"primary\">\n<span class=\"text-primary-bg\" style=\"font-size:8px\">ETE</span><br>\n{{printer?.printedTime-printer?.printedTimeComp | hmsShort}}\n<div style=\"height:5px\"></div>\n{{(printer?.stateTime + 1000*(printer?.printedTime-printer?.printedTimeComp)) | date:'shortTime'}}<br>\n<span class=\"text-primary-bg\" style=\"font-size:8px\">ETA</span>\n</rs-gauge>\n<img [src]=\"printer?.printingImage('m')\" style=\"border:1px solid #000;\" [style.height]=\"height1+'px'\">\n</div>\n<div class=\"regular-grid margin-leftright\" style=\"width: 100%;\">\n<div>\n<div class=\"value-list\">\n    <div><i class=\"fa fa-arrow-up\"></i> <?php _('Z Position') ?></div>\n    <div class=\"text-primary-bg\">{{printer?.posZ | fixed:2}} mm</div>\n</div>\n<div class=\"value-list\">\n    <div><i class=\"fa fa-bars\"></i> <?php _('Layer') ?></div>\n    <div class=\"text-primary-bg\">{{printer?.layer}} / {{printer?.ofLayer}}</div>\n</div>\n<div class=\"value-list\" *ngIf=\"printer?.activeExtruder\">\n    <div><i class=\"rs rs-extruder\"></i> <?php _('Extruder') ?> {{printer.activeExtruder.id+1}}&nbsp; </div>\n    <div class=\"text-primary-bg\">{{printer?.activeExtruder.currentTemp}} / {{printer?.activeExtruder.tempSet}}\u00B0C</div>\n</div>\n<div class=\"value-list\" *ngIf=\"printer?.config?.heatedBed?.installed\">\n    <div><i class=\"rs rs-heated-bed\"></i> <?php _('Bed') ?></div>\n    <div class=\"text-primary-bg\">{{printer?.heatedBed?.currentTemp}} / {{printer?.heatedBed?.tempSet}}\u00B0C</div>\n</div>\n</div>\n<div>\n<div class=\"regular-grid stacked\" style=\"height:80px\">\n<div>\n    <rs-button class=\"primary\" (hit)=\"printer.pausePrint()\" *ngIf=\"!printer?.paused\"><i class=\"fa fa-pause\"></i></rs-button>\n    <rs-button class=\"primary\" (hit)=\"printer.unpausePrint()\" *ngIf=\"printer?.paused\"><i class=\"fa fa-play\"></i></rs-button>\n</div>\n<div><rs-button class=\"error\" (hit)=\"ui.stopPrint()\"><i class=\"fa fa-stop\"></i></rs-button></div>\n</div>\n</div>\n</div>\n</div>\n</div>\n\n</main>\n</rs-page>",
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSFrontUI_1.RSModal, RSFrontUI_1.RSStringKeyboard, RSBinding_1.RepetierServer, RSFrontUI_1.RSUIHelper])
    ], PrintStatusComponent);
    return PrintStatusComponent;
})();
exports.PrintStatusComponent = PrintStatusComponent;
//# sourceMappingURL=printstatus.component.js.map