/**
 * Created by littwin on 07.06.16.
 */
var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RSBinding_1 = require("../RSBinding");
var ServerCommandsComponent = (function () {
    function ServerCommandsComponent(server, modal) {
        this.server = server;
        this.modal = modal;
    }
    ServerCommandsComponent.prototype.runCommand = function (cmd) {
        var _this = this;
        if (cmd.confirm) {
            this.modal.confirm("<?php _('Security Question') ?>", cmd.confirm, {}).then(function (res) { return _this.server.runExternalCommand(cmd); }, function () { });
        }
        else {
            this.server.runExternalCommand(cmd);
        }
    };
    ServerCommandsComponent = __decorate([
        core_1.Component({
            selector: 'rs-server-commands',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side><side>\n</side>\n<side>\n</side>\n<main>\n<h1><?php _('Server Commands') ?></h1>\n<div class=\"content-h1\" rs-drag>\n    <div class=\"entry-list\">\n    <div class=\"entry left buttons\" *ngFor=\"let f of server.filteredExternalCommands\" (click)=\"runCommand(f)\">\n            <rs-button class=\"primary left\"><i class=\"fa fa-play\"></i></rs-button>\n        <h3>{{f.name}}</h3>\n    </div>\n    </div>\n</div>\n</main>\n</rs-page>\n    ",
            directives: [RSFrontUI_1.RSFRONTUI],
            pipes: [RSBinding_1.RSPIPES]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer, RSFrontUI_1.RSModal])
    ], ServerCommandsComponent);
    return ServerCommandsComponent;
})();
exports.ServerCommandsComponent = ServerCommandsComponent;
//# sourceMappingURL=server-commands.component.js.map