/**
 * Created by littwin on 07.06.16.
 */
var core_1 = require('@angular/core');
var RSFrontUI_1 = require("../RSFrontUI");
var RSBinding_1 = require("../RSBinding");
var TemperaturesComponent = (function () {
    function TemperaturesComponent(server, select) {
        this.server = server;
        this.select = select;
        this.cur = {};
        this.list = [];
        this.p = {};
    }
    TemperaturesComponent.prototype.updateList = function () {
        if (!this.server.active || !this.server.active.config || !this.server.active.config.general)
            return;
        this.list = [];
        for (var idx in this.server.active.extruders) {
            this.list.push({ id: idx, name: "<?php _('Extruder') ?> " + (parseInt(idx) + 1) });
        }
        if (this.server.active.config.general.heatedBed)
            this.list.push({ id: -1, name: "<?php _('Heated Bed') ?>" });
        if (this.list.length > 0)
            this.cur = this.list[0];
    };
    TemperaturesComponent.prototype.selectExtruder = function () {
        var _this = this;
        this.select.select(this.list, "name", "<?php _('Select Graph') ?>").then(function (data) {
            _this.cur = data;
        });
    };
    TemperaturesComponent.prototype.ngOnInit = function () {
        if (this.list.length == 0)
            this.updateList();
    };
    TemperaturesComponent.prototype.ngDoCheck = function () {
        if (!this.server.active)
            return;
        if (this.list.length == 0)
            this.updateList();
        if (this.cur.id == -1)
            this.p = this.server.active.heatedBed;
        else
            this.p = this.server.active.extruders[this.cur.id];
    };
    TemperaturesComponent = __decorate([
        core_1.Component({
            selector: 'rs-temperatures-component',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side>\n<side><rs-sideicon *ngIf=\"printer?.printing\" title=\"<?php _('Print') ?>\" icon=\"rs rs-print\" link=\"/print-status\"></rs-sideicon></side>\n<side><rs-sideicon title=\"<?php _('Params') ?>\" icon=\"rs rs-params\" link=\"/params\"></rs-sideicon></side>\n<main>\n    <h1><?php _('Temperatures') ?></h1>\n    <div class=\"content-h1\">\n    <div style=\"display: table;width:100%;height:100%;margin:0;padding:0; \">\n        <div style=\"display: table-row;height:1px;\">\n        <div class=\"margin-leftright margin-bottom\">\n            <rs-button (hit)=\"selectExtruder()\" class=\"secondary full\">{{cur.name}}: {{p?.currentTemp|fixed:1}} | {{p?.tempSet|fixed:0}}\u00B0C</rs-button>\n            </div>\n        </div>\n        <div style=\"display: table-row;margin:0;padding:0;\">\n            <rs-temp-graph [extruder]=\"cur.id\"></rs-temp-graph>\n        </div>\n    </div>\n    </div>\n</main>\n</rs-page>\n    ",
            providers: [],
            pipes: [RSBinding_1.RSPIPES],
            directives: [RSFrontUI_1.RSFRONTUI]
        }), 
        __metadata('design:paramtypes', [RSBinding_1.RepetierServer, RSFrontUI_1.RSSelect])
    ], TemperaturesComponent);
    return TemperaturesComponent;
})();
exports.TemperaturesComponent = TemperaturesComponent;
//# sourceMappingURL=temperatures.component.js.map