/**
 * Created by littwin on 09.06.16.
 */
var core_1 = require('@angular/core');
var index_1 = require("../RSFrontUI/index");
var RepetierServer_1 = require("../RSBinding/RepetierServer");
var WLANComponent = (function () {
    function WLANComponent(server, modal, stringKbd) {
        this.server = server;
        this.modal = modal;
        this.stringKbd = stringKbd;
        this.page = 0;
        this.wifi = this.server.wifi;
    }
    WLANComponent.prototype.confAP = function () {
        this.page = 1;
    };
    WLANComponent.prototype.confCon = function () {
        this.page = 0;
    };
    WLANComponent.prototype.changeHostname = function () {
        var _this = this;
        this.stringKbd.getString(this.wifi.hostname, "<?php _('New Hostname') ?>", {}).then(function (newhost) {
            if (_this.wifi.hostname != newhost) {
                _this.wifi.hostname = newhost;
            }
        }, function () { });
    };
    WLANComponent.prototype.changeAPSSID = function () {
        var _this = this;
        this.stringKbd.getString(this.wifi.apSSID, "<?php _('New SSID') ?>", {}).then(function (newssid) {
            if (_this.wifi.apSSID != newssid) {
                _this.wifi.hostname = newssid;
            }
        }, function () { });
    };
    WLANComponent.prototype.changeAPChannel = function () {
    };
    WLANComponent.prototype.changeAPMode = function () {
    };
    WLANComponent = __decorate([
        core_1.Component({
            selector: 'rs-wlan-component',
            template: "\n<rs-page>\n<side>\n    <rs-sideicon title=\"<?php _('Home') ?>\" icon=\"fa fa-home\" link=\"/\"></rs-sideicon>\n</side>\n<side><rs-sideicon title=\"<?php _('Refresh') ?>\" icon=\"fa fa-refresh\" (click)=\"wifi.refreshRouterList()\"></rs-sideicon></side>\n<side>\n    <rs-sideicon *ngIf=\"page==0\" title=\"<?php _('AP') ?>\" icon=\"rs rs-accesspoint\" (click)=\"confAP()\"></rs-sideicon>\n    <rs-sideicon *ngIf=\"page==1\" title=\"<?php _('WLAN') ?>\" icon=\"fa fa-wifi\" (click)=\"confCon()\"></rs-sideicon>\n</side>\n<main>\n    <div *ngIf=\"page==0\">\n    <h1><?php _('WLAN') ?></h1>\n    <div class=\"content-h1 centered-grid\">\n    <div class=\"entry-list\">\n    <div class=\"entry\" *ngFor=\"let r of wifi?.routerList\" (click)=\"server.printers.active=printer\">\n    <div class=\"right\">\n        <div class=\"fa-stack\" style=\"font-size:30px\">\n            <i class=\"rs rs-bars-4 fa-stack-1x\" style=\"color:#606060\"></i>\n            <i class=\"rs rs-bars-{{r.bars}} fa-stack-1x\"></i>\n        </div>\n    </div>\n    <h3 [class.text]=\"!r.active\">{{r.SSID}}</h3>\n    <p><i *ngIf=\"r.secure\" class=\"fa fa-lock\"></i><i *ngIf=\"!r.secure\" class=\"fa fa-unlock\"></i> {{r.rate}} <?php _('Channel') ?>: {{r.channel}}</p>\n    </div>\n    </div>\n    </div>\n    </div>\n    <div *ngIf=\"page==1\">\n        <h1><?php _('Access Point') ?></h1>\n        <div class=\"content-h1 margin-leftright\" *ngIf=\"wifi.manageable\" rs-drag>\n          <div class=\"value-list\">\n            <div>Hostname</div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"changeHostname()\">{{wifi.hostname}}</rs-button></div>\n          </div>\n          <div class=\"value-list\">\n            <div><?php _('SSID') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"changeAPSSID()\">{{wifi.apSSID}}</rs-button></div>\n          </div>\n          <div class=\"value-list\">\n            <div><?php _('Channel') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"changeAPChannel()\">{{wifi.apChannel}}</rs-button></div>\n          </div>\n          <div class=\"value-list\">\n            <div><?php _('Mode') ?></div>\n            <div><rs-button class=\"secondary fixedvalue\" (hit)=\"changeAPMode()\">{{wifi.apModeList[wifi.apMode].n}}</rs-button></div>\n          </div>\n        </div>\n    </div>\n</main>\n</rs-page>\n    ",
            providers: [],
            directives: [index_1.RSFRONTUI]
        }), 
        __metadata('design:paramtypes', [RepetierServer_1.RepetierServer, index_1.RSModal, index_1.RSStringKeyboard])
    ], WLANComponent);
    return WLANComponent;
})();
exports.WLANComponent = WLANComponent;
//# sourceMappingURL=wlan.component.js.map