/**
 * Created by littwin on 08.05.16.
 */
var TemperatureData = (function () {
    function TemperatureData(temp) {
        this.output = temp.O;
        this.time = temp.t;
        this.tempSet = temp.S;
        this.temp = temp.T;
    }
    return TemperatureData;
})();
exports.TemperatureData = TemperatureData;
var Tool = (function () {
    function Tool(id) {
        this.id = id;
        this.error = 0;
        this.tempHistory = [];
    }
    Tool.prototype.dispose = function () {
    };
    Tool.prototype.appendTemperatureEntry = function (temp) {
        var newT = new TemperatureData(temp);
        while (this.tempHistory.length > 0 && this.tempHistory[0].time + 300000 < newT.time) {
            this.tempHistory.splice(0, 1);
        }
        this.tempHistory.push(newT);
    };
    /* { "history": [ { "O": 0, "S": 0, "T": 25.5, "t": 1420570143740 },
    { "O": 0, "S": 0, "T": 25.39999961853027, "t": 1420570144751 }, { "O": 0, "S": 0, "T": 25.5, "t": 1420570145759 }
     ], "output": 0, "tempRead": 25.5, "tempSet": 0 }  */
    Tool.prototype.updateFromState = function (data) {
        if (data.history) {
            for (var _i = 0, _a = data.history; _i < _a.length; _i++) {
                var temp = _a[_i];
                this.appendTemperatureEntry(temp);
            }
        }
        this.currentTemp = data.tempRead;
        this.tempSet = data.tempSet;
        this.output = data.output;
    };
    return Tool;
})();
exports.Tool = Tool;
//# sourceMappingURL=Tool.js.map