/**
 * Created by littwin on 08.05.16.
 */

export class TemperatureData {
    time:number;
    temp:number;
    tempSet:number;
    output:number;
    constructor(temp) {
        this.output = temp.O;
        this.time = temp.t;
        this.tempSet = temp.S;
        this.temp = temp.T;
    }
}

export class Tool {
    currentTemp:number;
    tempSet:number;
    output:number;
    error:number = 0;
    tempHistory:TemperatureData[] = [];

    constructor(public id:number) {
    }

    dispose() {

    }

    appendTemperatureEntry(temp) {
        let newT = new TemperatureData(temp);
        while (this.tempHistory.length > 0 && this.tempHistory[0].time + 300000 < newT.time) {
            this.tempHistory.splice(0, 1);
        }
        this.tempHistory.push(newT);
    }

    /* { "history": [ { "O": 0, "S": 0, "T": 25.5, "t": 1420570143740 },
    { "O": 0, "S": 0, "T": 25.39999961853027, "t": 1420570144751 }, { "O": 0, "S": 0, "T": 25.5, "t": 1420570145759 }
     ], "output": 0, "tempRead": 25.5, "tempSet": 0 }  */
    updateFromState(data) {
        if(data.history) {
            for(let temp of data.history) {
                this.appendTemperatureEntry(temp);
            }
        }
        this.currentTemp = data.tempRead;
        this.tempSet = data.tempSet;
        this.output = data.output;
    }
}