/* (C) 2016 Hot-World GmbH & Co. KG <rlittwin@repetier.com>
 All Rights Reserved

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 It is allowed to use this code to create or use in products connecting to
 Repetier-Server or to use it for own plugins/modules with Repetier-Server.
 This includes free and commercial products.
 Usage for other products is strictly forbidden.
 */

import {Component, Input, Output, ElementRef, EventEmitter, Injectable, NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {Deferred} from "@repetier/binding";
import {RSModal} from "./modal.service"
import {RSModalView} from "./modal-view.component"
import {RSModalHead} from "./modal-head.component"
import {RSModelContent} from "./modal-content.component"
import {RSModelFooter} from "./modal-footer.component"
import {FrontUIModule} from "./../index";

@Component({
    selector: 'rs-gcode-keyboard-modal',
    template: `<div class="rs-string-keyboard-modal">
    <rs-modal-head><h1><span [innerHTML]="head"></span><div class="close" (rsclick)="modal.cancel()"><i class="fa fa-close"></i></div></h1></rs-modal-head>
    <rs-modal-content>
        <div style="padding:2px 5px">
            <div class="input"><span [innerHTML]="valueShow"></span></div>
        </div>
        <div class="error" [innerHTML]="error"></div>
            <div class="keyboard-string">
                <div class="keyboard">
                    <div (rsclick)="key('1')" class="key key-2">
                        <div>1</div>
                    </div>
                    <div (rsclick)="key('2')" class="key key-2">
                        <div>2</div>
                    </div>
                    <div (rsclick)="key('3')" class="key key-2">
                        <div>3</div>
                    </div>
                    <div (rsclick)="key('4')" class="key key-2">
                        <div>4</div>
                    </div>
                    <div (rsclick)="key('5')" class="key key-2">
                        <div>5</div>
                    </div>
                    <div (rsclick)="key('6')" class="key key-2">
                        <div>6</div>
                    </div>
                    <div (rsclick)="key('7')" class="key key-2">
                        <div>7</div>
                    </div>
                    <div (rsclick)="key('8')" class="key key-2">
                        <div>8</div>
                    </div>
                    <div (rsclick)="key('9')" class="key key-2">
                        <div>9</div>
                    </div>
                    <div (rsclick)="key('0')" class="key key-2">
                        <div>0</div>
                    </div>
                </div>
                <div class="keyboard">
                    <div (rsclick)="key('Q')" class="key key-2">
                        <div>Q</div>
                    </div>
                    <div (rsclick)="key('W')" class="key key-2">
                        <div>W</div>
                    </div>
                    <div (rsclick)="key('E')" class="key key-2">
                        <div>E</div>
                    </div>
                    <div (rsclick)="key('R')" class="key key-2">
                        <div>R</div>
                    </div>
                    <div (rsclick)="key('T')" class="key key-2">
                        <div>T</div>
                    </div>
                    <div (rsclick)="key('Y')" class="key key-2">
                        <div>Y</div>
                    </div>
                    <div (rsclick)="key('U')" class="key key-2">
                        <div>U</div>
                    </div>
                    <div (rsclick)="key('I')" class="key key-2">
                        <div>I</div>
                    </div>
                    <div (rsclick)="key('O')" class="key key-2">
                        <div>O</div>
                    </div>
                    <div (rsclick)="key('P')" class="key key-2">
                        <div>P</div>
                    </div>
                </div>
                <div class="keyboard">
                    <div (rsclick)="key('A')" class="key key-2">
                        <div>A</div>
                    </div>
                    <div (rsclick)="key('S')" class="key key-2">
                        <div>S</div>
                    </div>
                    <div (rsclick)="key('D')" class="key key-2">
                        <div>D</div>
                    </div>
                    <div (rsclick)="key('F')" class="key key-2">
                        <div>F</div>
                    </div>
                    <div (rsclick)="key('G')" class="key key-2">
                        <div>G</div>
                    </div>
                    <div (rsclick)="key('H')" class="key key-2">
                        <div>H</div>
                    </div>
                    <div (rsclick)="key('J')" class="key key-2">
                        <div>J</div>
                    </div>
                    <div (rsclick)="key('K')" class="key key-2">
                        <div>K</div>
                    </div>
                    <div (rsclick)="key('L')" class="key key-2">
                        <div>L</div>
                    </div>
                    <div (rsclick)="key('-')" class="key key-2">
                        <div>-</div>
                    </div>
                </div>
                <div class="keyboard">
                    <div (rsclick)="del()" class="key key-2">
                        <div class="rs rs-backspace"></div>
                    </div>
                    <div (rsclick)="key('Z')" class="key key-2">
                        <div>Z</div>
                    </div>
                    <div (rsclick)="key('X')" class="key key-2">
                        <div>X</div>
                    </div>
                    <div (rsclick)="key('C')" class="key key-2">
                        <div>C</div>
                    </div>
                    <div (rsclick)="key('V')" class="key key-2">
                        <div>V</div>
                    </div>
                    <div (rsclick)="key('B')" class="key key-2">
                        <div>B</div>
                    </div>
                    <div (rsclick)="key('N')" class="key key-2">
                        <div>N</div>
                    </div>
                    <div (rsclick)="key('M')" class="key key-2">
                        <div>M</div>
                    </div>
                    <div (rsclick)="key('.')" class="key key-2">
                        <div>.</div>
                    </div>
                    <div (rsclick)="send()" class="key key-2" [class.disabled]="hasError">
                        <div class="fa fa-level-down fa-rotate-90"></div>
                    </div>
                </div>
            </div>
    </rs-modal-content>
</div>`,
    host: {
        class: ''
    }
})
export class RSGCodeKeyboardModal {
    value: string = "";
    valueShow: string = "";
    head: string = "";
    error: string = "&nbsp;";
    page: number = 1; // 0 = a-z, 1 = A-Z, 2 = numbers/symbols
    options: any = {};
    hasError: boolean = false;

    constructor(public modal: RSModalView) {
        this.options = this.modal.data;
        this.value = this.modal.data.defaultValue;
        this.head = this.modal.data.head;
        this.update();
    }

    update() {
        this.valueShow = this.value.split(" ").join("&nbsp;");
        if (this.valueShow.length == 0)
            this.valueShow = "&nbsp;";
        this.error = "&nbsp;";
        this.hasError = false;
        if (this.options.minLength && this.value.length < this.options.minLength) {
            this.hasError = true;
            this.error = "<?php _('Min. length is @ chars!') ?>".replace("@", this.options.minLength);
        }
        if (this.options.maxLength && this.value.length > this.options.maxLength) {
            this.hasError = true;
            this.error = "<?php _('Max. length is @ chars!') ?>".replace("@", this.options.maxLength);
        }
    }

    key(k) {
        if (k >= 'A' && k <= 'Z') {
            if (this.value.length > 0)
                this.value += " ";
        }
        this.value += k;
        this.update();
    }

    del() {
        if (this.value.length > 0)
            this.value = this.value.substr(0, this.value.length - 1).trim();
        this.update();
    }

    send() {
        if (this.hasError === false)
            this.modal.close(this.value);
    }
}

@Injectable()
export class RSGCodeKeyboard {
    constructor(public modal: RSModal) {
    }

    getString(oldValue: string, head: string, options?: any): Promise<any> {
        if (!options)
            options = {};
        options.defaultValue = oldValue;
        options.head = head;
        options.modalClass = "modal-noborder";
        return this.modal.show(RSGCodeKeyboardModal, options);
    }
}