/**
 * @license Angular v2.0.1
 * (c) 2010-2016 Google, Inc. https://angular.io/
 * License: MIT
 */
!function(global,factory){"object"==typeof exports&&"undefined"!=typeof module?factory(exports,require("rxjs/Subject"),require("rxjs/Observable")):"function"==typeof define&&define.amd?define(["exports","rxjs/Subject","rxjs/Observable"],factory):factory((global.ng=global.ng||{},global.ng.core=global.ng.core||{}),global.Rx,global.Rx)}(this,function(exports,rxjs_Subject,rxjs_Observable){"use strict";function scheduleMicroTask(fn){Zone.current.scheduleMicroTask("scheduleMicrotask",fn)}function getTypeNameForDebugging(type){return type.name?type.name:typeof type}function isPresent(obj){return void 0!==obj&&null!==obj}function isBlank(obj){return void 0===obj||null===obj}function isString(obj){return"string"==typeof obj}function isFunction(obj){return"function"==typeof obj}function isArray(obj){return Array.isArray(obj)}function stringify(token){if("string"==typeof token)return token;if(void 0===token||null===token)return""+token;if(token.overriddenName)return token.overriddenName;if(token.name)return token.name;var res=token.toString(),newLineIndex=res.indexOf("\n");return newLineIndex===-1?res:res.substring(0,newLineIndex)}function looseIdentical(a,b){return a===b||"number"==typeof a&&"number"==typeof b&&isNaN(a)&&isNaN(b)}function getMapKey(value){return value}function isJsObject(o){return null!==o&&("function"==typeof o||"object"==typeof o)}function print(obj){console.log(obj)}function warn(obj){console.warn(obj)}function getSymbolIterator(){if(isBlank(_symbolIterator))if(isPresent(globalScope.Symbol)&&isPresent(Symbol.iterator))_symbolIterator=Symbol.iterator;else for(var keys=Object.getOwnPropertyNames(Map.prototype),i=0;i<keys.length;++i){var key=keys[i];"entries"!==key&&"size"!==key&&Map.prototype[key]===Map.prototype.entries&&(_symbolIterator=key)}return _symbolIterator}function isPrimitive(obj){return!isJsObject(obj)}function extractAnnotation(annotation){return isFunction(annotation)&&annotation.hasOwnProperty("annotation")&&(annotation=annotation.annotation),annotation}function applyParams(fnOrArray,key){if(fnOrArray===Object||fnOrArray===String||fnOrArray===Function||fnOrArray===Number||fnOrArray===Array)throw new Error("Can not use native "+stringify(fnOrArray)+" as constructor");if(isFunction(fnOrArray))return fnOrArray;if(fnOrArray instanceof Array){var annotations=fnOrArray,annoLength=annotations.length-1,fn=fnOrArray[annoLength];if(!isFunction(fn))throw new Error("Last position of Class method array must be Function in key "+key+" was '"+stringify(fn)+"'");if(annoLength!=fn.length)throw new Error("Number of annotations ("+annoLength+") does not match number of arguments ("+fn.length+") in the function: "+stringify(fn));for(var paramsAnnotations=[],i=0,ii=annotations.length-1;i<ii;i++){var paramAnnotations=[];paramsAnnotations.push(paramAnnotations);var annotation=annotations[i];if(annotation instanceof Array)for(var j=0;j<annotation.length;j++)paramAnnotations.push(extractAnnotation(annotation[j]));else isFunction(annotation)?paramAnnotations.push(extractAnnotation(annotation)):paramAnnotations.push(annotation)}return Reflect.defineMetadata("parameters",paramsAnnotations,fn),fn}throw new Error("Only Function or Array is supported in Class definition for key '"+key+"' is '"+stringify(fnOrArray)+"'")}function Class(clsDef){var constructor=applyParams(clsDef.hasOwnProperty("constructor")?clsDef.constructor:void 0,"constructor"),proto=constructor.prototype;if(clsDef.hasOwnProperty("extends")){if(!isFunction(clsDef.extends))throw new Error("Class definition 'extends' property must be a constructor function was: "+stringify(clsDef.extends));constructor.prototype=proto=Object.create(clsDef.extends.prototype)}for(var key in clsDef)"extends"!=key&&"prototype"!=key&&clsDef.hasOwnProperty(key)&&(proto[key]=applyParams(clsDef[key],key));this&&this.annotations instanceof Array&&Reflect.defineMetadata("annotations",this.annotations,constructor);var constructorName=constructor.name;return constructorName&&"constructor"!==constructorName||(constructor.overriddenName="class"+_nextClassId++),constructor}function makeDecorator(name,props,parentClass,chainFn){function DecoratorFactory(objOrType){if(!Reflect||!Reflect.getMetadata)throw"reflect-metadata shim is required when using class decorators";if(this instanceof DecoratorFactory)return metaCtor.call(this,objOrType),this;var annotationInstance_1=new DecoratorFactory(objOrType),chainAnnotation=isFunction(this)&&this.annotations instanceof Array?this.annotations:[];chainAnnotation.push(annotationInstance_1);var TypeDecorator=function(cls){var annotations=Reflect.getOwnMetadata("annotations",cls)||[];return annotations.push(annotationInstance_1),Reflect.defineMetadata("annotations",annotations,cls),cls};return TypeDecorator.annotations=chainAnnotation,TypeDecorator.Class=Class,chainFn&&chainFn(TypeDecorator),TypeDecorator}void 0===chainFn&&(chainFn=null);var metaCtor=makeMetadataCtor([props]);return parentClass&&(DecoratorFactory.prototype=Object.create(parentClass.prototype)),DecoratorFactory.prototype.toString=function(){return"@"+name},DecoratorFactory.annotationCls=DecoratorFactory,DecoratorFactory}function makeMetadataCtor(props){function ctor(){for(var _this=this,args=[],_i=0;_i<arguments.length;_i++)args[_i-0]=arguments[_i];props.forEach(function(prop,i){var argVal=args[i];if(Array.isArray(prop)){var val=argVal&&void 0!==argVal?argVal:prop[1];_this[prop[0]]=val}else for(var propName in prop){var val=argVal&&void 0!==argVal[propName]?argVal[propName]:prop[propName];_this[propName]=val}})}return ctor}function makeParamDecorator(name,props,parentClass){function ParamDecoratorFactory(){function ParamDecorator(cls,unusedKey,index){for(var parameters=Reflect.getMetadata("parameters",cls)||[];parameters.length<=index;)parameters.push(null);parameters[index]=parameters[index]||[];var annotationsForParam=parameters[index];return annotationsForParam.push(annotationInstance),Reflect.defineMetadata("parameters",parameters,cls),cls}for(var args=[],_i=0;_i<arguments.length;_i++)args[_i-0]=arguments[_i];if(this instanceof ParamDecoratorFactory)return metaCtor.apply(this,args),this;var annotationInstance=new((_a=ParamDecoratorFactory).bind.apply(_a,[void 0].concat(args)));return ParamDecorator.annotation=annotationInstance,ParamDecorator;var _a}var metaCtor=makeMetadataCtor(props);return parentClass&&(ParamDecoratorFactory.prototype=Object.create(parentClass.prototype)),ParamDecoratorFactory.prototype.toString=function(){return"@"+name},ParamDecoratorFactory.annotationCls=ParamDecoratorFactory,ParamDecoratorFactory}function makePropDecorator(name,props,parentClass){function PropDecoratorFactory(){for(var args=[],_i=0;_i<arguments.length;_i++)args[_i-0]=arguments[_i];if(this instanceof PropDecoratorFactory)return metaCtor.apply(this,args),this;var decoratorInstance=new((_a=PropDecoratorFactory).bind.apply(_a,[void 0].concat(args)));return function(target,name){var meta=Reflect.getOwnMetadata("propMetadata",target.constructor)||{};meta[name]=meta[name]||[],meta[name].unshift(decoratorInstance),Reflect.defineMetadata("propMetadata",meta,target.constructor)};var _a}var metaCtor=makeMetadataCtor(props);return parentClass&&(PropDecoratorFactory.prototype=Object.create(parentClass.prototype)),PropDecoratorFactory.prototype.toString=function(){return"@"+name},PropDecoratorFactory.annotationCls=PropDecoratorFactory,PropDecoratorFactory}function isDefaultChangeDetectionStrategy(changeDetectionStrategy){return isBlank(changeDetectionStrategy)||changeDetectionStrategy===exports.ChangeDetectionStrategy.Default}function forwardRef(forwardRefFn){return forwardRefFn.__forward_ref__=forwardRef,forwardRefFn.toString=function(){return stringify(this())},forwardRefFn}function resolveForwardRef(type){return isFunction(type)&&type.hasOwnProperty("__forward_ref__")&&type.__forward_ref__===forwardRef?type():type}function unimplemented(){throw new Error("unimplemented")}function _flattenArray(source,target){if(isPresent(source))for(var i=0;i<source.length;i++){var item=source[i];isArray(item)?_flattenArray(item,target):target.push(item)}return target}function isListLikeIterable(obj){return!!isJsObject(obj)&&(isArray(obj)||!(obj instanceof Map)&&getSymbolIterator()in obj)}function areIterablesEqual(a,b,comparator){for(var iterator1=a[getSymbolIterator()](),iterator2=b[getSymbolIterator()]();;){var item1=iterator1.next(),item2=iterator2.next();if(item1.done&&item2.done)return!0;if(item1.done||item2.done)return!1;if(!comparator(item1.value,item2.value))return!1}}function iterateListLike(obj,fn){if(isArray(obj))for(var i=0;i<obj.length;i++)fn(obj[i]);else for(var item,iterator=obj[getSymbolIterator()]();!(item=iterator.next()).done;)fn(item.value)}function findFirstClosedCycle(keys){for(var res=[],i=0;i<keys.length;++i){if(ListWrapper.contains(res,keys[i]))return res.push(keys[i]),res;res.push(keys[i])}return res}function constructResolvingPath(keys){if(keys.length>1){var reversed=findFirstClosedCycle(ListWrapper.reversed(keys)),tokenStrs=reversed.map(function(k){return stringify(k.token)});return" ("+tokenStrs.join(" -> ")+")"}return""}function convertTsickleDecoratorIntoMetadata(decoratorInvocations){return decoratorInvocations?decoratorInvocations.map(function(decoratorInvocation){var decoratorType=decoratorInvocation.type,annotationCls=decoratorType.annotationCls,annotationArgs=decoratorInvocation.args?decoratorInvocation.args:[];return new(annotationCls.bind.apply(annotationCls,[void 0].concat(annotationArgs)))}):[]}function _mergeMaps(target,config){StringMapWrapper.forEach(config,function(v,k){return target.set(k,v)})}function resolveReflectiveFactory(provider){var factoryFn,resolvedDeps;if(isPresent(provider.useClass)){var useClass=resolveForwardRef(provider.useClass);factoryFn=reflector.factory(useClass),resolvedDeps=_dependenciesFor(useClass)}else isPresent(provider.useExisting)?(factoryFn=function(aliasInstance){return aliasInstance},resolvedDeps=[ReflectiveDependency.fromKey(ReflectiveKey.get(provider.useExisting))]):isPresent(provider.useFactory)?(factoryFn=provider.useFactory,resolvedDeps=constructDependencies(provider.useFactory,provider.deps)):(factoryFn=function(){return provider.useValue},resolvedDeps=_EMPTY_LIST);return new ResolvedReflectiveFactory(factoryFn,resolvedDeps)}function resolveReflectiveProvider(provider){return new ResolvedReflectiveProvider_(ReflectiveKey.get(provider.provide),[resolveReflectiveFactory(provider)],provider.multi)}function resolveReflectiveProviders(providers){var normalized=_normalizeProviders(providers,[]),resolved=normalized.map(resolveReflectiveProvider);return MapWrapper.values(mergeResolvedReflectiveProviders(resolved,new Map))}function mergeResolvedReflectiveProviders(providers,normalizedProvidersMap){for(var i=0;i<providers.length;i++){var provider=providers[i],existing=normalizedProvidersMap.get(provider.key.id);if(isPresent(existing)){if(provider.multiProvider!==existing.multiProvider)throw new MixingMultiProvidersWithRegularProvidersError(existing,provider);if(provider.multiProvider)for(var j=0;j<provider.resolvedFactories.length;j++)existing.resolvedFactories.push(provider.resolvedFactories[j]);else normalizedProvidersMap.set(provider.key.id,provider)}else{var resolvedProvider;resolvedProvider=provider.multiProvider?new ResolvedReflectiveProvider_(provider.key,ListWrapper.clone(provider.resolvedFactories),provider.multiProvider):provider,normalizedProvidersMap.set(provider.key.id,resolvedProvider)}}return normalizedProvidersMap}function _normalizeProviders(providers,res){return providers.forEach(function(b){if(b instanceof Type)res.push({provide:b,useClass:b});else if(b&&"object"==typeof b&&void 0!==b.provide)res.push(b);else{if(!(b instanceof Array))throw new InvalidProviderError(b);_normalizeProviders(b,res)}}),res}function constructDependencies(typeOrFunc,dependencies){if(isBlank(dependencies))return _dependenciesFor(typeOrFunc);var params=dependencies.map(function(t){return[t]});return dependencies.map(function(t){return _extractToken(typeOrFunc,t,params)})}function _dependenciesFor(typeOrFunc){var params=reflector.parameters(typeOrFunc);if(isBlank(params))return[];if(params.some(isBlank))throw new NoAnnotationError(typeOrFunc,params);return params.map(function(p){return _extractToken(typeOrFunc,p,params)})}function _extractToken(typeOrFunc,metadata,params){var depProps=[],token=null,optional=!1;if(!isArray(metadata))return metadata instanceof Inject?_createDependency(metadata.token,optional,null,null,depProps):_createDependency(metadata,optional,null,null,depProps);for(var lowerBoundVisibility=null,upperBoundVisibility=null,i=0;i<metadata.length;++i){var paramMetadata=metadata[i];paramMetadata instanceof Type?token=paramMetadata:paramMetadata instanceof Inject?token=paramMetadata.token:paramMetadata instanceof Optional?optional=!0:paramMetadata instanceof Self?upperBoundVisibility=paramMetadata:paramMetadata instanceof Host?upperBoundVisibility=paramMetadata:paramMetadata instanceof SkipSelf&&(lowerBoundVisibility=paramMetadata)}if(token=resolveForwardRef(token),isPresent(token))return _createDependency(token,optional,lowerBoundVisibility,upperBoundVisibility,depProps);throw new NoAnnotationError(typeOrFunc,params)}function _createDependency(token,optional,lowerBoundVisibility,upperBoundVisibility,depProps){return new ReflectiveDependency(ReflectiveKey.get(token),optional,lowerBoundVisibility,upperBoundVisibility,depProps)}function _mapProviders(injector,fn){for(var res=new Array(injector._proto.numberOfProviders),i=0;i<injector._proto.numberOfProviders;++i)res[i]=fn(injector._proto.getProviderAtIndex(i));return res}/**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
function isPromise(obj){return!!obj&&"function"==typeof obj.then}function _appIdRandomProviderFactory(){return""+_randomChar()+_randomChar()+_randomChar()}function _randomChar(){return StringWrapper.fromCharCode(97+Math.floor(25*Math.random()))}function _throwError(){throw new Error("Runtime compiler is not loaded")}function getPreviousIndex(item,addRemoveOffset,moveOffsets){var previousIndex=item.previousIndex;if(null===previousIndex)return previousIndex;var moveOffset=0;return moveOffsets&&previousIndex<moveOffsets.length&&(moveOffset=moveOffsets[previousIndex]),previousIndex+addRemoveOffset+moveOffset}function devModeEqual(a,b){return isListLikeIterable(a)&&isListLikeIterable(b)?areIterablesEqual(a,b,devModeEqual):!(isListLikeIterable(a)||isPrimitive(a)||isListLikeIterable(b)||isPrimitive(b))||looseIdentical(a,b)}function detectWTF(){var wtf=global$1.wtf;return!(!wtf||!(trace=wtf.trace))&&(events=trace.events,!0)}function createScope(signature,flags){return void 0===flags&&(flags=null),events.createScope(signature,flags)}function leave(scope,returnValue){return trace.leaveScope(scope,returnValue),returnValue}function startTimeRange(rangeType,action){return trace.beginTimeRange(rangeType,action)}function endTimeRange(range){trace.endTimeRange(range)}function noopScope(arg0,arg1){return null}function flattenNestedViewRenderNodes(nodes){return _flattenNestedViewRenderNodes(nodes,[])}function _flattenNestedViewRenderNodes(nodes,renderNodes){for(var i=0;i<nodes.length;i++){var node=nodes[i];if(node instanceof AppElement){var appEl=node;if(renderNodes.push(appEl.nativeElement),isPresent(appEl.nestedViews))for(var k=0;k<appEl.nestedViews.length;k++)_flattenNestedViewRenderNodes(appEl.nestedViews[k].rootNodesOrAppElements,renderNodes)}else renderNodes.push(node)}return renderNodes}function ensureSlotCount(projectableNodes,expectedSlotCount){var res;if(isBlank(projectableNodes))res=EMPTY_ARR;else if(projectableNodes.length<expectedSlotCount){var givenSlotCount=projectableNodes.length;res=new Array(expectedSlotCount);for(var i=0;i<expectedSlotCount;i++)res[i]=i<givenSlotCount?projectableNodes[i]:EMPTY_ARR}else res=projectableNodes;return res}function interpolate(valueCount,c0,a1,c1,a2,c2,a3,c3,a4,c4,a5,c5,a6,c6,a7,c7,a8,c8,a9,c9){switch(valueCount){case 1:return c0+_toStringWithNull(a1)+c1;case 2:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2;case 3:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3;case 4:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4;case 5:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4+_toStringWithNull(a5)+c5;case 6:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4+_toStringWithNull(a5)+c5+_toStringWithNull(a6)+c6;case 7:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4+_toStringWithNull(a5)+c5+_toStringWithNull(a6)+c6+_toStringWithNull(a7)+c7;case 8:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4+_toStringWithNull(a5)+c5+_toStringWithNull(a6)+c6+_toStringWithNull(a7)+c7+_toStringWithNull(a8)+c8;case 9:return c0+_toStringWithNull(a1)+c1+_toStringWithNull(a2)+c2+_toStringWithNull(a3)+c3+_toStringWithNull(a4)+c4+_toStringWithNull(a5)+c5+_toStringWithNull(a6)+c6+_toStringWithNull(a7)+c7+_toStringWithNull(a8)+c8+_toStringWithNull(a9)+c9;default:throw new Error("Does not support more than 9 expressions")}}function _toStringWithNull(v){return null!=v?v.toString():""}function checkBinding(throwOnChange,oldValue,newValue){if(throwOnChange){if(!devModeEqual(oldValue,newValue))throw new ExpressionChangedAfterItHasBeenCheckedError(oldValue,newValue);return!1}return!looseIdentical(oldValue,newValue)}function castByValue(input,value){return input}function pureProxy1(fn){var result,v0=UNINITIALIZED;return function(p0){return looseIdentical(v0,p0)||(v0=p0,result=fn(p0)),result}}function pureProxy2(fn){var result,v0=UNINITIALIZED,v1=UNINITIALIZED;return function(p0,p1){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)||(v0=p0,v1=p1,result=fn(p0,p1)),result}}function pureProxy3(fn){var result,v0=UNINITIALIZED,v1=UNINITIALIZED,v2=UNINITIALIZED;return function(p0,p1,p2){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)||(v0=p0,v1=p1,v2=p2,result=fn(p0,p1,p2)),result}}function pureProxy4(fn){var result,v0,v1,v2,v3;return v0=v1=v2=v3=UNINITIALIZED,function(p0,p1,p2,p3){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)||(v0=p0,v1=p1,v2=p2,v3=p3,result=fn(p0,p1,p2,p3)),result}}function pureProxy5(fn){var result,v0,v1,v2,v3,v4;return v0=v1=v2=v3=v4=UNINITIALIZED,function(p0,p1,p2,p3,p4){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,result=fn(p0,p1,p2,p3,p4)),result}}function pureProxy6(fn){var result,v0,v1,v2,v3,v4,v5;return v0=v1=v2=v3=v4=v5=UNINITIALIZED,function(p0,p1,p2,p3,p4,p5){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)&&looseIdentical(v5,p5)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,v5=p5,result=fn(p0,p1,p2,p3,p4,p5)),result}}function pureProxy7(fn){var result,v0,v1,v2,v3,v4,v5,v6;return v0=v1=v2=v3=v4=v5=v6=UNINITIALIZED,function(p0,p1,p2,p3,p4,p5,p6){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)&&looseIdentical(v5,p5)&&looseIdentical(v6,p6)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,v5=p5,v6=p6,result=fn(p0,p1,p2,p3,p4,p5,p6)),result}}function pureProxy8(fn){var result,v0,v1,v2,v3,v4,v5,v6,v7;return v0=v1=v2=v3=v4=v5=v6=v7=UNINITIALIZED,function(p0,p1,p2,p3,p4,p5,p6,p7){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)&&looseIdentical(v5,p5)&&looseIdentical(v6,p6)&&looseIdentical(v7,p7)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,v5=p5,v6=p6,v7=p7,result=fn(p0,p1,p2,p3,p4,p5,p6,p7)),result}}function pureProxy9(fn){var result,v0,v1,v2,v3,v4,v5,v6,v7,v8;return v0=v1=v2=v3=v4=v5=v6=v7=v8=UNINITIALIZED,function(p0,p1,p2,p3,p4,p5,p6,p7,p8){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)&&looseIdentical(v5,p5)&&looseIdentical(v6,p6)&&looseIdentical(v7,p7)&&looseIdentical(v8,p8)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,v5=p5,v6=p6,v7=p7,v8=p8,result=fn(p0,p1,p2,p3,p4,p5,p6,p7,p8)),result}}function pureProxy10(fn){var result,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;return v0=v1=v2=v3=v4=v5=v6=v7=v8=v9=UNINITIALIZED,function(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9){return looseIdentical(v0,p0)&&looseIdentical(v1,p1)&&looseIdentical(v2,p2)&&looseIdentical(v3,p3)&&looseIdentical(v4,p4)&&looseIdentical(v5,p5)&&looseIdentical(v6,p6)&&looseIdentical(v7,p7)&&looseIdentical(v8,p8)&&looseIdentical(v9,p9)||(v0=p0,v1=p1,v2=p2,v3=p3,v4=p4,v5=p5,v6=p6,v7=p7,v8=p8,v9=p9,result=fn(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)),result}}function setTestabilityGetter(getter){_testabilityGetter=getter}function enableProdMode(){if(_runModeLocked)throw new Error("Cannot enable prod mode after platform setup.");_devMode=!1}function isDevMode(){return _runModeLocked=!0,_devMode}function createPlatform(injector){if(_platform&&!_platform.destroyed)throw new Error("There can be only one platform. Destroy the previous one to create a new one.");_platform=injector.get(PlatformRef);var inits=injector.get(PLATFORM_INITIALIZER,null);return inits&&inits.forEach(function(init){return init()}),_platform}function createPlatformFactory(parentPlaformFactory,name,providers){void 0===providers&&(providers=[]);var marker=new OpaqueToken("Platform: "+name);return function(extraProviders){return void 0===extraProviders&&(extraProviders=[]),getPlatform()||(parentPlaformFactory?parentPlaformFactory(providers.concat(extraProviders).concat({provide:marker,useValue:!0})):createPlatform(ReflectiveInjector.resolveAndCreate(providers.concat(extraProviders).concat({provide:marker,useValue:!0})))),assertPlatform(marker)}}function assertPlatform(requiredToken){var platform=getPlatform();if(!platform)throw new Error("No platform exists!");if(!platform.injector.get(requiredToken,null))throw new Error("A platform with a different configuration has been created. Please destroy it first.");return platform}function destroyPlatform(){_platform&&!_platform.destroyed&&_platform.destroy()}function getPlatform(){return _platform&&!_platform.destroyed?_platform:null}function _callAndReportToErrorHandler(errorHandler,callback){try{var result=callback();return isPromise(result)?result.catch(function(e){throw errorHandler.handleError(e),e}):result}catch(e){throw errorHandler.handleError(e),e}}function registerModuleFactory(id,factory){var existing=moduleFactories.get(id);if(existing)throw new Error("Duplicate module registered for "+id+" - "+existing.moduleType.name+" vs "+factory.moduleType.name);moduleFactories.set(id,factory)}function getModuleFactory(id){var factory=moduleFactories.get(id);if(!factory)throw new Error("No module with ID "+id+" loaded");return factory}function checkNotEmpty(value,modulePath,exportName){if(!value)throw new Error("Cannot find '"+exportName+"' in '"+modulePath+"'");return value}function queueAnimation(player){_queuedAnimations.push(player)}function triggerQueuedAnimations(){for(var i=0;i<_queuedAnimations.length;i++){var player=_queuedAnimations[i];player.play()}_queuedAnimations=[]}function asNativeElements(debugEls){return debugEls.map(function(el){return el.nativeElement})}function _queryElementChildren(element,predicate,matches){element.childNodes.forEach(function(node){node instanceof DebugElement&&(predicate(node)&&matches.push(node),_queryElementChildren(node,predicate,matches))})}function _queryNodeChildren(parentNode,predicate,matches){parentNode instanceof DebugElement&&parentNode.childNodes.forEach(function(node){predicate(node)&&matches.push(node),node instanceof DebugElement&&_queryNodeChildren(node,predicate,matches)})}function getDebugNode(nativeNode){return _nativeNodeToDebugNode.get(nativeNode)}function indexDebugNode(node){_nativeNodeToDebugNode.set(node.nativeNode,node)}function removeDebugNodeFromIndex(node){_nativeNodeToDebugNode.delete(node.nativeNode)}function _reflector(){return reflector}function _iterableDiffersFactory(){return defaultIterableDiffers}function _keyValueDiffersFactory(){return defaultKeyValueDiffers}function animate(timing,styles){void 0===styles&&(styles=null);var stylesEntry=styles;if(!isPresent(stylesEntry)){var EMPTY_STYLE={};stylesEntry=new AnimationStyleMetadata([EMPTY_STYLE],1)}return new AnimationAnimateMetadata(timing,stylesEntry)}function group(steps){return new AnimationGroupMetadata(steps)}function sequence(steps){return new AnimationSequenceMetadata(steps)}function style(tokens){var input,offset=null;return isString(tokens)?input=[tokens]:(input=isArray(tokens)?tokens:[tokens],input.forEach(function(entry){var entryOffset=entry.offset;isPresent(entryOffset)&&(offset=null==offset?parseFloat(entryOffset):offset)})),new AnimationStyleMetadata(input,offset)}function state(stateNameExpr,styles){return new AnimationStateDeclarationMetadata(stateNameExpr,styles)}function keyframes(steps){return new AnimationKeyframesSequenceMetadata(steps)}function transition(stateChangeExpr,steps){var animationData=isArray(steps)?new AnimationSequenceMetadata(steps):steps;return new AnimationStateTransitionMetadata(stateChangeExpr,animationData)}function trigger(name,animation){return new AnimationEntryMetadata(name,animation)}function prepareFinalAnimationStyles(previousStyles,newStyles,nullValue){void 0===nullValue&&(nullValue=null);var finalStyles={};return StringMapWrapper.forEach(newStyles,function(value,prop){finalStyles[prop]=value==AUTO_STYLE?nullValue:value.toString()}),StringMapWrapper.forEach(previousStyles,function(value,prop){isPresent(finalStyles[prop])||(finalStyles[prop]=nullValue)}),finalStyles}function balanceAnimationKeyframes(collectedStyles,finalStateStyles,keyframes){var limit=keyframes.length-1,firstKeyframe=keyframes[0],flatenedFirstKeyframeStyles=flattenStyles(firstKeyframe.styles.styles),extraFirstKeyframeStyles={},hasExtraFirstStyles=!1;StringMapWrapper.forEach(collectedStyles,function(value,prop){flatenedFirstKeyframeStyles[prop]||(flatenedFirstKeyframeStyles[prop]=value,extraFirstKeyframeStyles[prop]=value,hasExtraFirstStyles=!0)});var keyframeCollectedStyles=StringMapWrapper.merge({},flatenedFirstKeyframeStyles),finalKeyframe=keyframes[limit];ListWrapper.insert(finalKeyframe.styles.styles,0,finalStateStyles);var flatenedFinalKeyframeStyles=flattenStyles(finalKeyframe.styles.styles),extraFinalKeyframeStyles={},hasExtraFinalStyles=!1;return StringMapWrapper.forEach(keyframeCollectedStyles,function(value,prop){isPresent(flatenedFinalKeyframeStyles[prop])||(extraFinalKeyframeStyles[prop]=AUTO_STYLE,hasExtraFinalStyles=!0)}),hasExtraFinalStyles&&finalKeyframe.styles.styles.push(extraFinalKeyframeStyles),StringMapWrapper.forEach(flatenedFinalKeyframeStyles,function(value,prop){isPresent(flatenedFirstKeyframeStyles[prop])||(extraFirstKeyframeStyles[prop]=AUTO_STYLE,hasExtraFirstStyles=!0)}),hasExtraFirstStyles&&firstKeyframe.styles.styles.push(extraFirstKeyframeStyles),keyframes}function clearStyles(styles){var finalStyles={};return StringMapWrapper.keys(styles).forEach(function(key){finalStyles[key]=null}),finalStyles}function collectAndResolveStyles(collection,styles){return styles.map(function(entry){var stylesObj={};return StringMapWrapper.forEach(entry,function(value,prop){value==FILL_STYLE_FLAG&&(value=collection[prop],isPresent(value)||(value=AUTO_STYLE)),collection[prop]=value,stylesObj[prop]=value}),stylesObj})}function renderStyles(element,renderer,styles){StringMapWrapper.forEach(styles,function(value,prop){renderer.setElementStyle(element,prop,value)})}function flattenStyles(styles){var finalStyles={};return styles.forEach(function(entry){StringMapWrapper.forEach(entry,function(value,prop){finalStyles[prop]=value})}),finalStyles}function _findLastRenderNode(node){var lastNode;if(node instanceof AppElement){var appEl=node;if(lastNode=appEl.nativeElement,isPresent(appEl.nestedViews))for(var i=appEl.nestedViews.length-1;i>=0;i--){var nestedView=appEl.nestedViews[i];nestedView.rootNodesOrAppElements.length>0&&(lastNode=_findLastRenderNode(nestedView.rootNodesOrAppElements[nestedView.rootNodesOrAppElements.length-1]))}}else lastNode=node;return lastNode}/**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
var globalScope;globalScope="undefined"==typeof window?"undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope?self:global:window;var global$1=globalScope,Math=global$1.Math;global$1.assert=function(condition){};var StringWrapper=function(){function StringWrapper(){}return StringWrapper.fromCharCode=function(code){return String.fromCharCode(code)},StringWrapper.charCodeAt=function(s,index){return s.charCodeAt(index)},StringWrapper.split=function(s,regExp){return s.split(regExp)},StringWrapper.equals=function(s,s2){return s===s2},StringWrapper.stripLeft=function(s,charVal){if(s&&s.length){for(var pos=0,i=0;i<s.length&&s[i]==charVal;i++)pos++;s=s.substring(pos)}return s},StringWrapper.stripRight=function(s,charVal){if(s&&s.length){for(var pos=s.length,i=s.length-1;i>=0&&s[i]==charVal;i--)pos--;s=s.substring(0,pos)}return s},StringWrapper.replace=function(s,from,replace){return s.replace(from,replace)},StringWrapper.replaceAll=function(s,from,replace){return s.replace(from,replace)},StringWrapper.slice=function(s,from,to){return void 0===from&&(from=0),void 0===to&&(to=null),s.slice(from,null===to?void 0:to)},StringWrapper.replaceAllMapped=function(s,from,cb){return s.replace(from,function(){for(var matches=[],_i=0;_i<arguments.length;_i++)matches[_i-0]=arguments[_i];return matches.splice(-2,2),cb(matches)})},StringWrapper.contains=function(s,substr){return s.indexOf(substr)!=-1},StringWrapper.compare=function(a,b){return a<b?-1:a>b?1:0},StringWrapper}(),_symbolIterator=(function(){function NumberWrapper(){}return NumberWrapper.toFixed=function(n,fractionDigits){return n.toFixed(fractionDigits)},NumberWrapper.equal=function(a,b){return a===b},NumberWrapper.parseIntAutoRadix=function(text){var result=parseInt(text);if(isNaN(result))throw new Error("Invalid integer literal when parsing "+text);return result},NumberWrapper.parseInt=function(text,radix){if(10==radix){if(/^(\-|\+)?[0-9]+$/.test(text))return parseInt(text,radix)}else if(16==radix){if(/^(\-|\+)?[0-9ABCDEFabcdef]+$/.test(text))return parseInt(text,radix)}else{var result=parseInt(text,radix);if(!isNaN(result))return result}throw new Error("Invalid integer literal when parsing "+text+" in base "+radix)},Object.defineProperty(NumberWrapper,"NaN",{get:function(){return NaN},enumerable:!0,configurable:!0}),NumberWrapper.isNumeric=function(value){return!isNaN(value-parseFloat(value))},NumberWrapper.isNaN=function(value){return isNaN(value)},NumberWrapper.isInteger=function(value){return Number.isInteger(value)},NumberWrapper}(),null),_nextClassId=0,Reflect=global$1.Reflect,Inject=makeParamDecorator("Inject",[["token",void 0]]),Optional=makeParamDecorator("Optional",[]),Injectable=makeParamDecorator("Injectable",[]),Self=makeParamDecorator("Self",[]),SkipSelf=makeParamDecorator("SkipSelf",[]),Host=makeParamDecorator("Host",[]),OpaqueToken=function(){function OpaqueToken(_desc){this._desc=_desc}return OpaqueToken.prototype.toString=function(){return"Token "+this._desc},OpaqueToken.decorators=[{type:Injectable}],OpaqueToken.ctorParameters=[null],OpaqueToken}(),ANALYZE_FOR_ENTRY_COMPONENTS=new OpaqueToken("AnalyzeForEntryComponents"),Attribute=makeParamDecorator("Attribute",[["attributeName",void 0]]),Query=function(){function Query(){}return Query}(),ContentChildren=makePropDecorator("ContentChildren",[["selector",void 0],{first:!1,isViewQuery:!1,descendants:!1,read:void 0}],Query),ContentChild=makePropDecorator("ContentChild",[["selector",void 0],{first:!0,isViewQuery:!1,descendants:!0,read:void 0}],Query),ViewChildren=makePropDecorator("ViewChildren",[["selector",void 0],{first:!1,isViewQuery:!0,descendants:!0,read:void 0}],Query),ViewChild=makePropDecorator("ViewChild",[["selector",void 0],{first:!0,isViewQuery:!0,descendants:!0,read:void 0}],Query);exports.ChangeDetectionStrategy,function(ChangeDetectionStrategy){ChangeDetectionStrategy[ChangeDetectionStrategy.OnPush=0]="OnPush",ChangeDetectionStrategy[ChangeDetectionStrategy.Default=1]="Default"}(exports.ChangeDetectionStrategy||(exports.ChangeDetectionStrategy={}));var ChangeDetectorStatus;!function(ChangeDetectorStatus){ChangeDetectorStatus[ChangeDetectorStatus.CheckOnce=0]="CheckOnce",ChangeDetectorStatus[ChangeDetectorStatus.Checked=1]="Checked",ChangeDetectorStatus[ChangeDetectorStatus.CheckAlways=2]="CheckAlways",ChangeDetectorStatus[ChangeDetectorStatus.Detached=3]="Detached",ChangeDetectorStatus[ChangeDetectorStatus.Errored=4]="Errored",ChangeDetectorStatus[ChangeDetectorStatus.Destroyed=5]="Destroyed"}(ChangeDetectorStatus||(ChangeDetectorStatus={}));var LifecycleHooks,CHANGE_DETECTION_STRATEGY_VALUES=[exports.ChangeDetectionStrategy.OnPush,exports.ChangeDetectionStrategy.Default],Directive=makeDecorator("Directive",{selector:void 0,inputs:void 0,outputs:void 0,host:void 0,providers:void 0,exportAs:void 0,queries:void 0}),Component=makeDecorator("Component",{selector:void 0,inputs:void 0,outputs:void 0,host:void 0,exportAs:void 0,moduleId:void 0,providers:void 0,viewProviders:void 0,changeDetection:exports.ChangeDetectionStrategy.Default,queries:void 0,templateUrl:void 0,template:void 0,styleUrls:void 0,styles:void 0,animations:void 0,encapsulation:void 0,interpolation:void 0,entryComponents:void 0},Directive),Pipe=makeDecorator("Pipe",{name:void 0,pure:!0}),Input=makePropDecorator("Input",[["bindingPropertyName",void 0]]),Output=makePropDecorator("Output",[["bindingPropertyName",void 0]]),HostBinding=makePropDecorator("HostBinding",[["hostPropertyName",void 0]]),HostListener=makePropDecorator("HostListener",[["eventName",void 0],["args",[]]]);!function(LifecycleHooks){LifecycleHooks[LifecycleHooks.OnInit=0]="OnInit",LifecycleHooks[LifecycleHooks.OnDestroy=1]="OnDestroy",LifecycleHooks[LifecycleHooks.DoCheck=2]="DoCheck",LifecycleHooks[LifecycleHooks.OnChanges=3]="OnChanges",LifecycleHooks[LifecycleHooks.AfterContentInit=4]="AfterContentInit",LifecycleHooks[LifecycleHooks.AfterContentChecked=5]="AfterContentChecked",LifecycleHooks[LifecycleHooks.AfterViewInit=6]="AfterViewInit",LifecycleHooks[LifecycleHooks.AfterViewChecked=7]="AfterViewChecked"}(LifecycleHooks||(LifecycleHooks={}));var LIFECYCLE_HOOKS_VALUES=[LifecycleHooks.OnInit,LifecycleHooks.OnDestroy,LifecycleHooks.DoCheck,LifecycleHooks.OnChanges,LifecycleHooks.AfterContentInit,LifecycleHooks.AfterContentChecked,LifecycleHooks.AfterViewInit,LifecycleHooks.AfterViewChecked],OnChanges=function(){function OnChanges(){}return OnChanges}(),OnInit=function(){function OnInit(){}return OnInit}(),DoCheck=function(){function DoCheck(){}return DoCheck}(),OnDestroy=function(){function OnDestroy(){}return OnDestroy}(),AfterContentInit=function(){function AfterContentInit(){}return AfterContentInit}(),AfterContentChecked=function(){function AfterContentChecked(){}return AfterContentChecked}(),AfterViewInit=function(){function AfterViewInit(){}return AfterViewInit}(),AfterViewChecked=function(){function AfterViewChecked(){}return AfterViewChecked}(),CUSTOM_ELEMENTS_SCHEMA={name:"custom-elements"},NO_ERRORS_SCHEMA={name:"no-errors-schema"},NgModule=makeDecorator("NgModule",{providers:void 0,declarations:void 0,imports:void 0,exports:void 0,entryComponents:void 0,bootstrap:void 0,schemas:void 0,id:void 0});/**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
exports.ViewEncapsulation,function(ViewEncapsulation){ViewEncapsulation[ViewEncapsulation.Emulated=0]="Emulated",ViewEncapsulation[ViewEncapsulation.Native=1]="Native",ViewEncapsulation[ViewEncapsulation.None=2]="None"}(exports.ViewEncapsulation||(exports.ViewEncapsulation={}));var VIEW_ENCAPSULATION_VALUES=[exports.ViewEncapsulation.Emulated,exports.ViewEncapsulation.Native,exports.ViewEncapsulation.None],ViewMetadata=function(){function ViewMetadata(_a){var _b=void 0===_a?{}:_a,templateUrl=_b.templateUrl,template=_b.template,encapsulation=_b.encapsulation,styles=_b.styles,styleUrls=_b.styleUrls,animations=_b.animations,interpolation=_b.interpolation;this.templateUrl=templateUrl,this.template=template,this.styleUrls=styleUrls,this.styles=styles,this.encapsulation=encapsulation,this.animations=animations,this.interpolation=interpolation}return ViewMetadata}(),__extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},BaseError=function(_super){function BaseError(message){var nativeError=_super.call(this,message);this._nativeError=nativeError}return __extends(BaseError,_super),Object.defineProperty(BaseError.prototype,"message",{get:function(){return this._nativeError.message},set:function(message){this._nativeError.message=message},enumerable:!0,configurable:!0}),Object.defineProperty(BaseError.prototype,"name",{get:function(){return this._nativeError.name},enumerable:!0,configurable:!0}),Object.defineProperty(BaseError.prototype,"stack",{get:function(){return this._nativeError.stack},set:function(value){this._nativeError.stack=value},enumerable:!0,configurable:!0}),BaseError.prototype.toString=function(){return this._nativeError.toString()},BaseError}(Error),WrappedError=function(_super){function WrappedError(message,error){_super.call(this,message+" caused by: "+(error instanceof Error?error.message:error)),this.originalError=error}return __extends(WrappedError,_super),Object.defineProperty(WrappedError.prototype,"stack",{get:function(){return(this.originalError instanceof Error?this.originalError:this._nativeError).stack},enumerable:!0,configurable:!0}),WrappedError}(BaseError),_THROW_IF_NOT_FOUND=new Object,THROW_IF_NOT_FOUND=_THROW_IF_NOT_FOUND,_NullInjector=function(){function _NullInjector(){}return _NullInjector.prototype.get=function(token,notFoundValue){if(void 0===notFoundValue&&(notFoundValue=_THROW_IF_NOT_FOUND),notFoundValue===_THROW_IF_NOT_FOUND)throw new Error("No provider for "+stringify(token)+"!");return notFoundValue},_NullInjector}(),Injector=function(){function Injector(){}return Injector.prototype.get=function(token,notFoundValue){return unimplemented()},Injector.THROW_IF_NOT_FOUND=_THROW_IF_NOT_FOUND,Injector.NULL=new _NullInjector,Injector}(),createMapFromPairs=function(){try{if(1===new Map([[1,2]]).size)return function(pairs){return new Map(pairs)}}catch(e){}return function(pairs){for(var map=new Map,i=0;i<pairs.length;i++){var pair=pairs[i];map.set(pair[0],pair[1])}return map}}(),_arrayFromMap=(function(){return(new Map).keys().next?function(m){for(var k,keyIterator=m.keys();!(k=keyIterator.next()).done;)m.set(k.value,null)}:function(m){m.forEach(function(v,k){m.set(k,null)})}}(),function(){try{if((new Map).values().next)return function(m,getValues){return getValues?Array.from(m.values()):Array.from(m.keys())}}catch(e){}return function(m,getValues){var res=new Array(m.size),i=0;return m.forEach(function(v,k){res[i]=getValues?v:k,i++}),res}}()),MapWrapper=function(){function MapWrapper(){}return MapWrapper.createFromStringMap=function(stringMap){var result=new Map;for(var prop in stringMap)result.set(prop,stringMap[prop]);return result},MapWrapper.toStringMap=function(m){var r={};return m.forEach(function(v,k){return r[k]=v}),r},MapWrapper.createFromPairs=function(pairs){return createMapFromPairs(pairs)},MapWrapper.iterable=function(m){return m},MapWrapper.keys=function(m){return _arrayFromMap(m,!1)},MapWrapper.values=function(m){return _arrayFromMap(m,!0)},MapWrapper}(),StringMapWrapper=function(){function StringMapWrapper(){}return StringMapWrapper.get=function(map,key){return map.hasOwnProperty(key)?map[key]:void 0},StringMapWrapper.set=function(map,key,value){map[key]=value},StringMapWrapper.keys=function(map){return Object.keys(map)},StringMapWrapper.values=function(map){return Object.keys(map).map(function(k){return map[k]})},StringMapWrapper.isEmpty=function(map){for(var prop in map)return!1;return!0},StringMapWrapper.forEach=function(map,callback){for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var k=_a[_i];callback(map[k],k)}},StringMapWrapper.merge=function(m1,m2){for(var m={},_i=0,_a=Object.keys(m1);_i<_a.length;_i++){var k=_a[_i];m[k]=m1[k]}for(var _b=0,_c=Object.keys(m2);_b<_c.length;_b++){var k=_c[_b];m[k]=m2[k]}return m},StringMapWrapper.equals=function(m1,m2){var k1=Object.keys(m1),k2=Object.keys(m2);if(k1.length!=k2.length)return!1;for(var i=0;i<k1.length;i++){var key=k1[i];if(m1[key]!==m2[key])return!1}return!0},StringMapWrapper}(),ListWrapper=function(){function ListWrapper(){}return ListWrapper.createFixedSize=function(size){return new Array(size)},ListWrapper.createGrowableSize=function(size){return new Array(size)},ListWrapper.clone=function(array){return array.slice(0)},ListWrapper.forEachWithIndex=function(array,fn){for(var i=0;i<array.length;i++)fn(array[i],i)},ListWrapper.first=function(array){return array?array[0]:null},ListWrapper.last=function(array){return array&&0!=array.length?array[array.length-1]:null},ListWrapper.indexOf=function(array,value,startIndex){return void 0===startIndex&&(startIndex=0),array.indexOf(value,startIndex)},ListWrapper.contains=function(list,el){return list.indexOf(el)!==-1},ListWrapper.reversed=function(array){var a=ListWrapper.clone(array);return a.reverse()},ListWrapper.concat=function(a,b){return a.concat(b)},ListWrapper.insert=function(list,index,value){list.splice(index,0,value)},ListWrapper.removeAt=function(list,index){var res=list[index];return list.splice(index,1),res},ListWrapper.removeAll=function(list,items){for(var i=0;i<items.length;++i){var index=list.indexOf(items[i]);list.splice(index,1)}},ListWrapper.remove=function(list,el){var index=list.indexOf(el);return index>-1&&(list.splice(index,1),!0)},ListWrapper.clear=function(list){list.length=0},ListWrapper.isEmpty=function(list){return 0==list.length},ListWrapper.fill=function(list,value,start,end){void 0===start&&(start=0),void 0===end&&(end=null),list.fill(value,start,null===end?list.length:end)},ListWrapper.equals=function(a,b){if(a.length!=b.length)return!1;for(var i=0;i<a.length;++i)if(a[i]!==b[i])return!1;return!0},ListWrapper.slice=function(l,from,to){return void 0===from&&(from=0),void 0===to&&(to=null),l.slice(from,null===to?void 0:to)},ListWrapper.splice=function(l,from,length){return l.splice(from,length)},ListWrapper.sort=function(l,compareFn){isPresent(compareFn)?l.sort(compareFn):l.sort()},ListWrapper.toString=function(l){return l.toString()},ListWrapper.toJSON=function(l){return JSON.stringify(l)},ListWrapper.maximum=function(list,predicate){if(0==list.length)return null;for(var solution=null,maxValue=-(1/0),index=0;index<list.length;index++){var candidate=list[index];if(!isBlank(candidate)){var candidateValue=predicate(candidate);candidateValue>maxValue&&(solution=candidate,maxValue=candidateValue)}}return solution},ListWrapper.flatten=function(list){var target=[];return _flattenArray(list,target),target},ListWrapper.addAll=function(list,source){for(var i=0;i<source.length;i++)list.push(source[i])},ListWrapper}(),createSetFromList=function(){var test=new Set([1,2,3]);return 3===test.size?function(lst){return new Set(lst)}:function(lst){var res=new Set(lst);if(res.size!==lst.length)for(var i=0;i<lst.length;i++)res.add(lst[i]);return res}}(),SetWrapper=function(){function SetWrapper(){}return SetWrapper.createFromList=function(lst){return createSetFromList(lst)},SetWrapper.has=function(s,key){return s.has(key)},SetWrapper.delete=function(m,k){m.delete(k)},SetWrapper}(),__extends$1=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},AbstractProviderError=function(_super){function AbstractProviderError(injector,key,constructResolvingMessage){_super.call(this,"DI Error"),this.keys=[key],this.injectors=[injector],this.constructResolvingMessage=constructResolvingMessage,this.message=this.constructResolvingMessage(this.keys)}return __extends$1(AbstractProviderError,_super),AbstractProviderError.prototype.addKey=function(injector,key){this.injectors.push(injector),this.keys.push(key),this.message=this.constructResolvingMessage(this.keys)},AbstractProviderError}(BaseError),NoProviderError=function(_super){function NoProviderError(injector,key){_super.call(this,injector,key,function(keys){var first=stringify(ListWrapper.first(keys).token);return"No provider for "+first+"!"+constructResolvingPath(keys)})}return __extends$1(NoProviderError,_super),NoProviderError}(AbstractProviderError),CyclicDependencyError=function(_super){function CyclicDependencyError(injector,key){_super.call(this,injector,key,function(keys){return"Cannot instantiate cyclic dependency!"+constructResolvingPath(keys)})}return __extends$1(CyclicDependencyError,_super),CyclicDependencyError}(AbstractProviderError),InstantiationError=function(_super){function InstantiationError(injector,originalException,originalStack,key){_super.call(this,"DI Error",originalException),this.keys=[key],this.injectors=[injector]}return __extends$1(InstantiationError,_super),InstantiationError.prototype.addKey=function(injector,key){this.injectors.push(injector),this.keys.push(key)},Object.defineProperty(InstantiationError.prototype,"message",{get:function(){var first=stringify(ListWrapper.first(this.keys).token);return this.originalError.message+": Error during instantiation of "+first+"!"+constructResolvingPath(this.keys)+"."},enumerable:!0,configurable:!0}),Object.defineProperty(InstantiationError.prototype,"causeKey",{get:function(){return this.keys[0]},enumerable:!0,configurable:!0}),InstantiationError}(WrappedError),InvalidProviderError=function(_super){function InvalidProviderError(provider){_super.call(this,"Invalid provider - only instances of Provider and Type are allowed, got: "+provider)}return __extends$1(InvalidProviderError,_super),InvalidProviderError}(BaseError),NoAnnotationError=function(_super){function NoAnnotationError(typeOrFunc,params){_super.call(this,NoAnnotationError._genMessage(typeOrFunc,params))}return __extends$1(NoAnnotationError,_super),NoAnnotationError._genMessage=function(typeOrFunc,params){for(var signature=[],i=0,ii=params.length;i<ii;i++){var parameter=params[i];isBlank(parameter)||0==parameter.length?signature.push("?"):signature.push(parameter.map(stringify).join(" "))}return"Cannot resolve all parameters for '"+stringify(typeOrFunc)+"'("+signature.join(", ")+"). Make sure that all the parameters are decorated with Inject or have valid type annotations and that '"+stringify(typeOrFunc)+"' is decorated with Injectable."},NoAnnotationError}(BaseError),OutOfBoundsError=function(_super){function OutOfBoundsError(index){_super.call(this,"Index "+index+" is out-of-bounds.")}return __extends$1(OutOfBoundsError,_super),OutOfBoundsError}(BaseError),MixingMultiProvidersWithRegularProvidersError=function(_super){function MixingMultiProvidersWithRegularProvidersError(provider1,provider2){_super.call(this,"Cannot mix multi providers and regular providers, got: "+provider1.toString()+" "+provider2.toString())}return __extends$1(MixingMultiProvidersWithRegularProvidersError,_super),MixingMultiProvidersWithRegularProvidersError}(BaseError),ReflectiveKey=function(){function ReflectiveKey(token,id){if(this.token=token,this.id=id,isBlank(token))throw new Error("Token must be defined!")}return Object.defineProperty(ReflectiveKey.prototype,"displayName",{get:function(){return stringify(this.token)},enumerable:!0,configurable:!0}),ReflectiveKey.get=function(token){return _globalKeyRegistry.get(resolveForwardRef(token))},Object.defineProperty(ReflectiveKey,"numberOfKeys",{get:function(){return _globalKeyRegistry.numberOfKeys},enumerable:!0,configurable:!0}),ReflectiveKey}(),KeyRegistry=function(){function KeyRegistry(){this._allKeys=new Map}return KeyRegistry.prototype.get=function(token){if(token instanceof ReflectiveKey)return token;if(this._allKeys.has(token))return this._allKeys.get(token);var newKey=new ReflectiveKey(token,ReflectiveKey.numberOfKeys);return this._allKeys.set(token,newKey),newKey},Object.defineProperty(KeyRegistry.prototype,"numberOfKeys",{get:function(){return this._allKeys.size},enumerable:!0,configurable:!0}),KeyRegistry}(),_globalKeyRegistry=new KeyRegistry,Type=Function,ReflectionCapabilities=function(){function ReflectionCapabilities(reflect){this._reflect=reflect||global$1.Reflect}return ReflectionCapabilities.prototype.isReflectionEnabled=function(){return!0},ReflectionCapabilities.prototype.factory=function(t){var prototype=t.prototype;return function(){for(var args=[],_i=0;_i<arguments.length;_i++)args[_i-0]=arguments[_i];var instance=Object.create(prototype);return t.apply(instance,args),instance}},ReflectionCapabilities.prototype._zipTypesAndAnnotations=function(paramTypes,paramAnnotations){var result;result="undefined"==typeof paramTypes?new Array(paramAnnotations.length):new Array(paramTypes.length);for(var i=0;i<result.length;i++)"undefined"==typeof paramTypes?result[i]=[]:paramTypes[i]!=Object?result[i]=[paramTypes[i]]:result[i]=[],isPresent(paramAnnotations)&&isPresent(paramAnnotations[i])&&(result[i]=result[i].concat(paramAnnotations[i]));return result},ReflectionCapabilities.prototype.parameters=function(typeOrFunc){if(isPresent(typeOrFunc.parameters))return typeOrFunc.parameters;if(isPresent(typeOrFunc.ctorParameters)){var ctorParameters=typeOrFunc.ctorParameters,paramTypes_1=ctorParameters.map(function(ctorParam){return ctorParam&&ctorParam.type}),paramAnnotations_1=ctorParameters.map(function(ctorParam){return ctorParam&&convertTsickleDecoratorIntoMetadata(ctorParam.decorators)});return this._zipTypesAndAnnotations(paramTypes_1,paramAnnotations_1)}if(isPresent(this._reflect)&&isPresent(this._reflect.getMetadata)){var paramAnnotations=this._reflect.getMetadata("parameters",typeOrFunc),paramTypes=this._reflect.getMetadata("design:paramtypes",typeOrFunc);if(isPresent(paramTypes)||isPresent(paramAnnotations))return this._zipTypesAndAnnotations(paramTypes,paramAnnotations)}var parameters=new Array(typeOrFunc.length);return parameters.fill(void 0),parameters},ReflectionCapabilities.prototype.annotations=function(typeOrFunc){if(isPresent(typeOrFunc.annotations)){var annotations=typeOrFunc.annotations;return isFunction(annotations)&&annotations.annotations&&(annotations=annotations.annotations),annotations}if(isPresent(typeOrFunc.decorators))return convertTsickleDecoratorIntoMetadata(typeOrFunc.decorators);if(isPresent(this._reflect)&&isPresent(this._reflect.getMetadata)){var annotations=this._reflect.getMetadata("annotations",typeOrFunc);if(isPresent(annotations))return annotations}return[]},ReflectionCapabilities.prototype.propMetadata=function(typeOrFunc){if(isPresent(typeOrFunc.propMetadata)){var propMetadata=typeOrFunc.propMetadata;return isFunction(propMetadata)&&propMetadata.propMetadata&&(propMetadata=propMetadata.propMetadata),propMetadata}if(isPresent(typeOrFunc.propDecorators)){var propDecorators_1=typeOrFunc.propDecorators,propMetadata_1={};return Object.keys(propDecorators_1).forEach(function(prop){propMetadata_1[prop]=convertTsickleDecoratorIntoMetadata(propDecorators_1[prop])}),propMetadata_1}if(isPresent(this._reflect)&&isPresent(this._reflect.getMetadata)){var propMetadata=this._reflect.getMetadata("propMetadata",typeOrFunc);if(isPresent(propMetadata))return propMetadata}return{}},ReflectionCapabilities.prototype.interfaces=function(type){return[]},ReflectionCapabilities.prototype.hasLifecycleHook=function(type,lcInterface,lcProperty){if(!(type instanceof Type))return!1;var proto=type.prototype;return!!proto[lcProperty]},ReflectionCapabilities.prototype.getter=function(name){return new Function("o","return o."+name+";")},ReflectionCapabilities.prototype.setter=function(name){return new Function("o","v","return o."+name+" = v;")},ReflectionCapabilities.prototype.method=function(name){var functionBody="if (!o."+name+") throw new Error('\""+name+"\" is undefined');\n        return o."+name+".apply(o, args);";return new Function("o","args",functionBody)},ReflectionCapabilities.prototype.importUri=function(type){return"object"==typeof type&&type.filePath?type.filePath:"./"+stringify(type)},ReflectionCapabilities.prototype.resolveIdentifier=function(name,moduleUrl,runtime){return runtime},ReflectionCapabilities.prototype.resolveEnum=function(enumIdentifier,name){return enumIdentifier[name]},ReflectionCapabilities}(),ReflectorReader=function(){function ReflectorReader(){}return ReflectorReader}(),__extends$2=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},Reflector=function(_super){function Reflector(reflectionCapabilities){_super.call(this),this.reflectionCapabilities=reflectionCapabilities,this._injectableInfo=new Map,this._getters=new Map,this._setters=new Map,this._methods=new Map,this._usedKeys=null}return __extends$2(Reflector,_super),Reflector.prototype.updateCapabilities=function(caps){this.reflectionCapabilities=caps},Reflector.prototype.isReflectionEnabled=function(){return this.reflectionCapabilities.isReflectionEnabled()},Reflector.prototype.trackUsage=function(){this._usedKeys=new Set},Reflector.prototype.listUnusedKeys=function(){var _this=this;if(null==this._usedKeys)throw new Error("Usage tracking is disabled");var allTypes=MapWrapper.keys(this._injectableInfo);return allTypes.filter(function(key){return!SetWrapper.has(_this._usedKeys,key)})},Reflector.prototype.registerFunction=function(func,funcInfo){this._injectableInfo.set(func,funcInfo)},Reflector.prototype.registerType=function(type,typeInfo){this._injectableInfo.set(type,typeInfo)},Reflector.prototype.registerGetters=function(getters){_mergeMaps(this._getters,getters)},Reflector.prototype.registerSetters=function(setters){_mergeMaps(this._setters,setters)},Reflector.prototype.registerMethods=function(methods){_mergeMaps(this._methods,methods)},Reflector.prototype.factory=function(type){if(this._containsReflectionInfo(type)){var res=this._getReflectionInfo(type).factory;return isPresent(res)?res:null}return this.reflectionCapabilities.factory(type)},Reflector.prototype.parameters=function(typeOrFunc){if(this._injectableInfo.has(typeOrFunc)){var res=this._getReflectionInfo(typeOrFunc).parameters;return isPresent(res)?res:[]}return this.reflectionCapabilities.parameters(typeOrFunc)},Reflector.prototype.annotations=function(typeOrFunc){if(this._injectableInfo.has(typeOrFunc)){var res=this._getReflectionInfo(typeOrFunc).annotations;return isPresent(res)?res:[]}return this.reflectionCapabilities.annotations(typeOrFunc)},Reflector.prototype.propMetadata=function(typeOrFunc){if(this._injectableInfo.has(typeOrFunc)){var res=this._getReflectionInfo(typeOrFunc).propMetadata;return isPresent(res)?res:{}}return this.reflectionCapabilities.propMetadata(typeOrFunc)},Reflector.prototype.interfaces=function(type){if(this._injectableInfo.has(type)){var res=this._getReflectionInfo(type).interfaces;return isPresent(res)?res:[]}return this.reflectionCapabilities.interfaces(type)},Reflector.prototype.hasLifecycleHook=function(type,lcInterface,lcProperty){var interfaces=this.interfaces(type);return interfaces.indexOf(lcInterface)!==-1||this.reflectionCapabilities.hasLifecycleHook(type,lcInterface,lcProperty)},Reflector.prototype.getter=function(name){return this._getters.has(name)?this._getters.get(name):this.reflectionCapabilities.getter(name)},Reflector.prototype.setter=function(name){return this._setters.has(name)?this._setters.get(name):this.reflectionCapabilities.setter(name)},Reflector.prototype.method=function(name){return this._methods.has(name)?this._methods.get(name):this.reflectionCapabilities.method(name)},Reflector.prototype._getReflectionInfo=function(typeOrFunc){return isPresent(this._usedKeys)&&this._usedKeys.add(typeOrFunc),this._injectableInfo.get(typeOrFunc)},Reflector.prototype._containsReflectionInfo=function(typeOrFunc){return this._injectableInfo.has(typeOrFunc)},Reflector.prototype.importUri=function(type){return this.reflectionCapabilities.importUri(type)},Reflector.prototype.resolveIdentifier=function(name,moduleUrl,runtime){return this.reflectionCapabilities.resolveIdentifier(name,moduleUrl,runtime)},Reflector.prototype.resolveEnum=function(identifier,name){return this.reflectionCapabilities.resolveEnum(identifier,name)},Reflector}(ReflectorReader),reflector=new Reflector(new ReflectionCapabilities),ReflectiveDependency=function(){function ReflectiveDependency(key,optional,lowerBoundVisibility,upperBoundVisibility,properties){this.key=key,this.optional=optional,this.lowerBoundVisibility=lowerBoundVisibility,this.upperBoundVisibility=upperBoundVisibility,this.properties=properties}return ReflectiveDependency.fromKey=function(key){return new ReflectiveDependency(key,(!1),null,null,[])},ReflectiveDependency}(),_EMPTY_LIST=[],ResolvedReflectiveProvider_=function(){function ResolvedReflectiveProvider_(key,resolvedFactories,multiProvider){this.key=key,this.resolvedFactories=resolvedFactories,this.multiProvider=multiProvider}return Object.defineProperty(ResolvedReflectiveProvider_.prototype,"resolvedFactory",{get:function(){return this.resolvedFactories[0]},enumerable:!0,configurable:!0}),ResolvedReflectiveProvider_}(),ResolvedReflectiveFactory=function(){function ResolvedReflectiveFactory(factory,dependencies){this.factory=factory,this.dependencies=dependencies}return ResolvedReflectiveFactory}(),_MAX_CONSTRUCTION_COUNTER=10,UNDEFINED=new Object,ReflectiveProtoInjectorInlineStrategy=function(){function ReflectiveProtoInjectorInlineStrategy(protoEI,providers){this.provider0=null,this.provider1=null,this.provider2=null,this.provider3=null,this.provider4=null,this.provider5=null,this.provider6=null,this.provider7=null,this.provider8=null,this.provider9=null,this.keyId0=null,this.keyId1=null,this.keyId2=null,this.keyId3=null,this.keyId4=null,this.keyId5=null,this.keyId6=null,this.keyId7=null,this.keyId8=null,this.keyId9=null;var length=providers.length;length>0&&(this.provider0=providers[0],this.keyId0=providers[0].key.id),length>1&&(this.provider1=providers[1],this.keyId1=providers[1].key.id),length>2&&(this.provider2=providers[2],this.keyId2=providers[2].key.id),length>3&&(this.provider3=providers[3],this.keyId3=providers[3].key.id),length>4&&(this.provider4=providers[4],this.keyId4=providers[4].key.id),length>5&&(this.provider5=providers[5],this.keyId5=providers[5].key.id),length>6&&(this.provider6=providers[6],this.keyId6=providers[6].key.id),length>7&&(this.provider7=providers[7],this.keyId7=providers[7].key.id),length>8&&(this.provider8=providers[8],this.keyId8=providers[8].key.id),length>9&&(this.provider9=providers[9],this.keyId9=providers[9].key.id)}return ReflectiveProtoInjectorInlineStrategy.prototype.getProviderAtIndex=function(index){if(0==index)return this.provider0;if(1==index)return this.provider1;if(2==index)return this.provider2;if(3==index)return this.provider3;if(4==index)return this.provider4;if(5==index)return this.provider5;if(6==index)return this.provider6;if(7==index)return this.provider7;if(8==index)return this.provider8;if(9==index)return this.provider9;throw new OutOfBoundsError(index)},ReflectiveProtoInjectorInlineStrategy.prototype.createInjectorStrategy=function(injector){return new ReflectiveInjectorInlineStrategy(injector,this)},ReflectiveProtoInjectorInlineStrategy}(),ReflectiveProtoInjectorDynamicStrategy=function(){function ReflectiveProtoInjectorDynamicStrategy(protoInj,providers){this.providers=providers;var len=providers.length;this.keyIds=new Array(len);for(var i=0;i<len;i++)this.keyIds[i]=providers[i].key.id}return ReflectiveProtoInjectorDynamicStrategy.prototype.getProviderAtIndex=function(index){if(index<0||index>=this.providers.length)throw new OutOfBoundsError(index);return this.providers[index]},ReflectiveProtoInjectorDynamicStrategy.prototype.createInjectorStrategy=function(ei){return new ReflectiveInjectorDynamicStrategy(this,ei)},ReflectiveProtoInjectorDynamicStrategy}(),ReflectiveProtoInjector=function(){function ReflectiveProtoInjector(providers){this.numberOfProviders=providers.length,this._strategy=providers.length>_MAX_CONSTRUCTION_COUNTER?new ReflectiveProtoInjectorDynamicStrategy(this,providers):new ReflectiveProtoInjectorInlineStrategy(this,providers)}return ReflectiveProtoInjector.fromResolvedProviders=function(providers){return new ReflectiveProtoInjector(providers)},ReflectiveProtoInjector.prototype.getProviderAtIndex=function(index){return this._strategy.getProviderAtIndex(index)},ReflectiveProtoInjector}(),ReflectiveInjectorInlineStrategy=function(){function ReflectiveInjectorInlineStrategy(injector,protoStrategy){this.injector=injector,this.protoStrategy=protoStrategy,this.obj0=UNDEFINED,this.obj1=UNDEFINED,this.obj2=UNDEFINED,this.obj3=UNDEFINED,this.obj4=UNDEFINED,this.obj5=UNDEFINED,this.obj6=UNDEFINED,this.obj7=UNDEFINED,this.obj8=UNDEFINED,this.obj9=UNDEFINED}return ReflectiveInjectorInlineStrategy.prototype.resetConstructionCounter=function(){this.injector._constructionCounter=0},ReflectiveInjectorInlineStrategy.prototype.instantiateProvider=function(provider){return this.injector._new(provider)},ReflectiveInjectorInlineStrategy.prototype.getObjByKeyId=function(keyId){var p=this.protoStrategy,inj=this.injector;return p.keyId0===keyId?(this.obj0===UNDEFINED&&(this.obj0=inj._new(p.provider0)),this.obj0):p.keyId1===keyId?(this.obj1===UNDEFINED&&(this.obj1=inj._new(p.provider1)),this.obj1):p.keyId2===keyId?(this.obj2===UNDEFINED&&(this.obj2=inj._new(p.provider2)),this.obj2):p.keyId3===keyId?(this.obj3===UNDEFINED&&(this.obj3=inj._new(p.provider3)),this.obj3):p.keyId4===keyId?(this.obj4===UNDEFINED&&(this.obj4=inj._new(p.provider4)),this.obj4):p.keyId5===keyId?(this.obj5===UNDEFINED&&(this.obj5=inj._new(p.provider5)),this.obj5):p.keyId6===keyId?(this.obj6===UNDEFINED&&(this.obj6=inj._new(p.provider6)),this.obj6):p.keyId7===keyId?(this.obj7===UNDEFINED&&(this.obj7=inj._new(p.provider7)),this.obj7):p.keyId8===keyId?(this.obj8===UNDEFINED&&(this.obj8=inj._new(p.provider8)),this.obj8):p.keyId9===keyId?(this.obj9===UNDEFINED&&(this.obj9=inj._new(p.provider9)),this.obj9):UNDEFINED},ReflectiveInjectorInlineStrategy.prototype.getObjAtIndex=function(index){if(0==index)return this.obj0;if(1==index)return this.obj1;if(2==index)return this.obj2;if(3==index)return this.obj3;if(4==index)return this.obj4;if(5==index)return this.obj5;if(6==index)return this.obj6;if(7==index)return this.obj7;if(8==index)return this.obj8;if(9==index)return this.obj9;throw new OutOfBoundsError(index)},ReflectiveInjectorInlineStrategy.prototype.getMaxNumberOfObjects=function(){return _MAX_CONSTRUCTION_COUNTER},ReflectiveInjectorInlineStrategy}(),ReflectiveInjectorDynamicStrategy=function(){function ReflectiveInjectorDynamicStrategy(protoStrategy,injector){this.protoStrategy=protoStrategy,this.injector=injector,this.objs=new Array(protoStrategy.providers.length),ListWrapper.fill(this.objs,UNDEFINED)}return ReflectiveInjectorDynamicStrategy.prototype.resetConstructionCounter=function(){this.injector._constructionCounter=0},ReflectiveInjectorDynamicStrategy.prototype.instantiateProvider=function(provider){return this.injector._new(provider)},ReflectiveInjectorDynamicStrategy.prototype.getObjByKeyId=function(keyId){for(var p=this.protoStrategy,i=0;i<p.keyIds.length;i++)if(p.keyIds[i]===keyId)return this.objs[i]===UNDEFINED&&(this.objs[i]=this.injector._new(p.providers[i])),this.objs[i];return UNDEFINED},ReflectiveInjectorDynamicStrategy.prototype.getObjAtIndex=function(index){if(index<0||index>=this.objs.length)throw new OutOfBoundsError(index);return this.objs[index]},ReflectiveInjectorDynamicStrategy.prototype.getMaxNumberOfObjects=function(){return this.objs.length},ReflectiveInjectorDynamicStrategy}(),ReflectiveInjector=function(){function ReflectiveInjector(){}return ReflectiveInjector.resolve=function(providers){return resolveReflectiveProviders(providers)},ReflectiveInjector.resolveAndCreate=function(providers,parent){void 0===parent&&(parent=null);var ResolvedReflectiveProviders=ReflectiveInjector.resolve(providers);return ReflectiveInjector.fromResolvedProviders(ResolvedReflectiveProviders,parent)},ReflectiveInjector.fromResolvedProviders=function(providers,parent){return void 0===parent&&(parent=null),new ReflectiveInjector_(ReflectiveProtoInjector.fromResolvedProviders(providers),parent)},Object.defineProperty(ReflectiveInjector.prototype,"parent",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),ReflectiveInjector.prototype.resolveAndCreateChild=function(providers){return unimplemented()},ReflectiveInjector.prototype.createChildFromResolved=function(providers){return unimplemented()},ReflectiveInjector.prototype.resolveAndInstantiate=function(provider){return unimplemented()},ReflectiveInjector.prototype.instantiateResolved=function(provider){return unimplemented()},ReflectiveInjector}(),ReflectiveInjector_=function(){function ReflectiveInjector_(_proto,_parent){void 0===_parent&&(_parent=null),this._constructionCounter=0,this._proto=_proto,this._parent=_parent,this._strategy=_proto._strategy.createInjectorStrategy(this)}return ReflectiveInjector_.prototype.get=function(token,notFoundValue){return void 0===notFoundValue&&(notFoundValue=THROW_IF_NOT_FOUND),this._getByKey(ReflectiveKey.get(token),null,null,notFoundValue)},ReflectiveInjector_.prototype.getAt=function(index){return this._strategy.getObjAtIndex(index)},Object.defineProperty(ReflectiveInjector_.prototype,"parent",{get:function(){return this._parent},enumerable:!0,configurable:!0}),Object.defineProperty(ReflectiveInjector_.prototype,"internalStrategy",{get:function(){return this._strategy},enumerable:!0,configurable:!0}),ReflectiveInjector_.prototype.resolveAndCreateChild=function(providers){var ResolvedReflectiveProviders=ReflectiveInjector.resolve(providers);return this.createChildFromResolved(ResolvedReflectiveProviders)},ReflectiveInjector_.prototype.createChildFromResolved=function(providers){var proto=new ReflectiveProtoInjector(providers),inj=new ReflectiveInjector_(proto);return inj._parent=this,inj},ReflectiveInjector_.prototype.resolveAndInstantiate=function(provider){return this.instantiateResolved(ReflectiveInjector.resolve([provider])[0])},ReflectiveInjector_.prototype.instantiateResolved=function(provider){return this._instantiateProvider(provider)},ReflectiveInjector_.prototype._new=function(provider){if(this._constructionCounter++>this._strategy.getMaxNumberOfObjects())throw new CyclicDependencyError(this,provider.key);return this._instantiateProvider(provider)},ReflectiveInjector_.prototype._instantiateProvider=function(provider){if(provider.multiProvider){for(var res=new Array(provider.resolvedFactories.length),i=0;i<provider.resolvedFactories.length;++i)res[i]=this._instantiate(provider,provider.resolvedFactories[i]);return res}return this._instantiate(provider,provider.resolvedFactories[0])},ReflectiveInjector_.prototype._instantiate=function(provider,ResolvedReflectiveFactory){var d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,d17,d18,d19,factory=ResolvedReflectiveFactory.factory,deps=ResolvedReflectiveFactory.dependencies,length=deps.length;try{d0=length>0?this._getByReflectiveDependency(provider,deps[0]):null,
d1=length>1?this._getByReflectiveDependency(provider,deps[1]):null,d2=length>2?this._getByReflectiveDependency(provider,deps[2]):null,d3=length>3?this._getByReflectiveDependency(provider,deps[3]):null,d4=length>4?this._getByReflectiveDependency(provider,deps[4]):null,d5=length>5?this._getByReflectiveDependency(provider,deps[5]):null,d6=length>6?this._getByReflectiveDependency(provider,deps[6]):null,d7=length>7?this._getByReflectiveDependency(provider,deps[7]):null,d8=length>8?this._getByReflectiveDependency(provider,deps[8]):null,d9=length>9?this._getByReflectiveDependency(provider,deps[9]):null,d10=length>10?this._getByReflectiveDependency(provider,deps[10]):null,d11=length>11?this._getByReflectiveDependency(provider,deps[11]):null,d12=length>12?this._getByReflectiveDependency(provider,deps[12]):null,d13=length>13?this._getByReflectiveDependency(provider,deps[13]):null,d14=length>14?this._getByReflectiveDependency(provider,deps[14]):null,d15=length>15?this._getByReflectiveDependency(provider,deps[15]):null,d16=length>16?this._getByReflectiveDependency(provider,deps[16]):null,d17=length>17?this._getByReflectiveDependency(provider,deps[17]):null,d18=length>18?this._getByReflectiveDependency(provider,deps[18]):null,d19=length>19?this._getByReflectiveDependency(provider,deps[19]):null}catch(e){throw(e instanceof AbstractProviderError||e instanceof InstantiationError)&&e.addKey(this,provider.key),e}var obj;try{switch(length){case 0:obj=factory();break;case 1:obj=factory(d0);break;case 2:obj=factory(d0,d1);break;case 3:obj=factory(d0,d1,d2);break;case 4:obj=factory(d0,d1,d2,d3);break;case 5:obj=factory(d0,d1,d2,d3,d4);break;case 6:obj=factory(d0,d1,d2,d3,d4,d5);break;case 7:obj=factory(d0,d1,d2,d3,d4,d5,d6);break;case 8:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7);break;case 9:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8);break;case 10:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9);break;case 11:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10);break;case 12:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11);break;case 13:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12);break;case 14:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13);break;case 15:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14);break;case 16:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15);break;case 17:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16);break;case 18:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,d17);break;case 19:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,d17,d18);break;case 20:obj=factory(d0,d1,d2,d3,d4,d5,d6,d7,d8,d9,d10,d11,d12,d13,d14,d15,d16,d17,d18,d19);break;default:throw new Error("Cannot instantiate '"+provider.key.displayName+"' because it has more than 20 dependencies")}}catch(e){throw new InstantiationError(this,e,e.stack,provider.key)}return obj},ReflectiveInjector_.prototype._getByReflectiveDependency=function(provider,dep){return this._getByKey(dep.key,dep.lowerBoundVisibility,dep.upperBoundVisibility,dep.optional?null:THROW_IF_NOT_FOUND)},ReflectiveInjector_.prototype._getByKey=function(key,lowerBoundVisibility,upperBoundVisibility,notFoundValue){return key===INJECTOR_KEY?this:upperBoundVisibility instanceof Self?this._getByKeySelf(key,notFoundValue):this._getByKeyDefault(key,notFoundValue,lowerBoundVisibility)},ReflectiveInjector_.prototype._throwOrNull=function(key,notFoundValue){if(notFoundValue!==THROW_IF_NOT_FOUND)return notFoundValue;throw new NoProviderError(this,key)},ReflectiveInjector_.prototype._getByKeySelf=function(key,notFoundValue){var obj=this._strategy.getObjByKeyId(key.id);return obj!==UNDEFINED?obj:this._throwOrNull(key,notFoundValue)},ReflectiveInjector_.prototype._getByKeyDefault=function(key,notFoundValue,lowerBoundVisibility){var inj;for(inj=lowerBoundVisibility instanceof SkipSelf?this._parent:this;inj instanceof ReflectiveInjector_;){var inj_=inj,obj=inj_._strategy.getObjByKeyId(key.id);if(obj!==UNDEFINED)return obj;inj=inj_._parent}return null!==inj?inj.get(key.token,notFoundValue):this._throwOrNull(key,notFoundValue)},Object.defineProperty(ReflectiveInjector_.prototype,"displayName",{get:function(){var providers=_mapProviders(this,function(b){return' "'+b.key.displayName+'" '}).join(", ");return"ReflectiveInjector(providers: ["+providers+"])"},enumerable:!0,configurable:!0}),ReflectiveInjector_.prototype.toString=function(){return this.displayName},ReflectiveInjector_}(),INJECTOR_KEY=ReflectiveKey.get(Injector),ErrorHandler=function(){function ErrorHandler(rethrowError){void 0===rethrowError&&(rethrowError=!0),this._console=console,this.rethrowError=rethrowError}return ErrorHandler.prototype.handleError=function(error){var originalError=this._findOriginalError(error),originalStack=this._findOriginalStack(error),context=this._findContext(error);if(this._console.error("EXCEPTION: "+this._extractMessage(error)),originalError&&this._console.error("ORIGINAL EXCEPTION: "+this._extractMessage(originalError)),originalStack&&(this._console.error("ORIGINAL STACKTRACE:"),this._console.error(originalStack)),context&&(this._console.error("ERROR CONTEXT:"),this._console.error(context)),this.rethrowError)throw error},ErrorHandler.prototype._extractMessage=function(error){return error instanceof Error?error.message:error.toString()},ErrorHandler.prototype._findContext=function(error){return error?error.context?error.context:this._findContext(error.originalError):null},ErrorHandler.prototype._findOriginalError=function(error){for(var e=error.originalError;e&&e.originalError;)e=e.originalError;return e},ErrorHandler.prototype._findOriginalStack=function(error){if(!(error instanceof Error))return null;for(var e=error,stack=e.stack;e instanceof Error&&e.originalError;)e=e.originalError,e instanceof Error&&e.stack&&(stack=e.stack);return stack},ErrorHandler}(),APP_INITIALIZER=new OpaqueToken("Application Initializer"),ApplicationInitStatus=function(){function ApplicationInitStatus(appInits){var _this=this;this._done=!1;var asyncInitPromises=[];if(appInits)for(var i=0;i<appInits.length;i++){var initResult=appInits[i]();isPromise(initResult)&&asyncInitPromises.push(initResult)}this._donePromise=Promise.all(asyncInitPromises).then(function(){_this._done=!0}),0===asyncInitPromises.length&&(this._done=!0)}return Object.defineProperty(ApplicationInitStatus.prototype,"done",{get:function(){return this._done},enumerable:!0,configurable:!0}),Object.defineProperty(ApplicationInitStatus.prototype,"donePromise",{get:function(){return this._donePromise},enumerable:!0,configurable:!0}),ApplicationInitStatus.decorators=[{type:Injectable}],ApplicationInitStatus.ctorParameters=[{type:Array,decorators:[{type:Inject,args:[APP_INITIALIZER]},{type:Optional}]}],ApplicationInitStatus}(),APP_ID=new OpaqueToken("AppId"),APP_ID_RANDOM_PROVIDER={provide:APP_ID,useFactory:_appIdRandomProviderFactory,deps:[]},PLATFORM_INITIALIZER=new OpaqueToken("Platform Initializer"),APP_BOOTSTRAP_LISTENER=new OpaqueToken("appBootstrapListener"),PACKAGE_ROOT_URL=new OpaqueToken("Application Packages Root URL"),Console=function(){function Console(){}return Console.prototype.log=function(message){print(message)},Console.prototype.warn=function(message){warn(message)},Console.decorators=[{type:Injectable}],Console.ctorParameters=[],Console}(),__extends$4=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ComponentStillLoadingError=function(_super){function ComponentStillLoadingError(compType){_super.call(this,"Can't compile synchronously as "+stringify(compType)+" is still being loaded!"),this.compType=compType}return __extends$4(ComponentStillLoadingError,_super),ComponentStillLoadingError}(BaseError),ModuleWithComponentFactories=function(){function ModuleWithComponentFactories(ngModuleFactory,componentFactories){this.ngModuleFactory=ngModuleFactory,this.componentFactories=componentFactories}return ModuleWithComponentFactories}(),Compiler=function(){function Compiler(){}return Compiler.prototype.compileModuleSync=function(moduleType){throw _throwError()},Compiler.prototype.compileModuleAsync=function(moduleType){throw _throwError()},Compiler.prototype.compileModuleAndAllComponentsSync=function(moduleType){throw _throwError()},Compiler.prototype.compileModuleAndAllComponentsAsync=function(moduleType){throw _throwError()},Compiler.prototype.clearCache=function(){},Compiler.prototype.clearCacheFor=function(type){},Compiler}(),COMPILER_OPTIONS=new OpaqueToken("compilerOptions"),CompilerFactory=function(){function CompilerFactory(){}return CompilerFactory}(),DefaultIterableDifferFactory=function(){function DefaultIterableDifferFactory(){}return DefaultIterableDifferFactory.prototype.supports=function(obj){return isListLikeIterable(obj)},DefaultIterableDifferFactory.prototype.create=function(cdRef,trackByFn){return new DefaultIterableDiffer(trackByFn)},DefaultIterableDifferFactory}(),trackByIdentity=function(index,item){return item},DefaultIterableDiffer=function(){function DefaultIterableDiffer(_trackByFn){this._trackByFn=_trackByFn,this._length=null,this._collection=null,this._linkedRecords=null,this._unlinkedRecords=null,this._previousItHead=null,this._itHead=null,this._itTail=null,this._additionsHead=null,this._additionsTail=null,this._movesHead=null,this._movesTail=null,this._removalsHead=null,this._removalsTail=null,this._identityChangesHead=null,this._identityChangesTail=null,this._trackByFn=isPresent(this._trackByFn)?this._trackByFn:trackByIdentity}return Object.defineProperty(DefaultIterableDiffer.prototype,"collection",{get:function(){return this._collection},enumerable:!0,configurable:!0}),Object.defineProperty(DefaultIterableDiffer.prototype,"length",{get:function(){return this._length},enumerable:!0,configurable:!0}),DefaultIterableDiffer.prototype.forEachItem=function(fn){var record;for(record=this._itHead;null!==record;record=record._next)fn(record)},DefaultIterableDiffer.prototype.forEachOperation=function(fn){for(var nextIt=this._itHead,nextRemove=this._removalsHead,addRemoveOffset=0,moveOffsets=null;nextIt||nextRemove;){var record=!nextRemove||nextIt&&nextIt.currentIndex<getPreviousIndex(nextRemove,addRemoveOffset,moveOffsets)?nextIt:nextRemove,adjPreviousIndex=getPreviousIndex(record,addRemoveOffset,moveOffsets),currentIndex=record.currentIndex;if(record===nextRemove)addRemoveOffset--,nextRemove=nextRemove._nextRemoved;else if(nextIt=nextIt._next,null==record.previousIndex)addRemoveOffset++;else{moveOffsets||(moveOffsets=[]);var localMovePreviousIndex=adjPreviousIndex-addRemoveOffset,localCurrentIndex=currentIndex-addRemoveOffset;if(localMovePreviousIndex!=localCurrentIndex){for(var i=0;i<localMovePreviousIndex;i++){var offset=i<moveOffsets.length?moveOffsets[i]:moveOffsets[i]=0,index=offset+i;localCurrentIndex<=index&&index<localMovePreviousIndex&&(moveOffsets[i]=offset+1)}var previousIndex=record.previousIndex;moveOffsets[previousIndex]=localCurrentIndex-localMovePreviousIndex}}adjPreviousIndex!==currentIndex&&fn(record,adjPreviousIndex,currentIndex)}},DefaultIterableDiffer.prototype.forEachPreviousItem=function(fn){var record;for(record=this._previousItHead;null!==record;record=record._nextPrevious)fn(record)},DefaultIterableDiffer.prototype.forEachAddedItem=function(fn){var record;for(record=this._additionsHead;null!==record;record=record._nextAdded)fn(record)},DefaultIterableDiffer.prototype.forEachMovedItem=function(fn){var record;for(record=this._movesHead;null!==record;record=record._nextMoved)fn(record)},DefaultIterableDiffer.prototype.forEachRemovedItem=function(fn){var record;for(record=this._removalsHead;null!==record;record=record._nextRemoved)fn(record)},DefaultIterableDiffer.prototype.forEachIdentityChange=function(fn){var record;for(record=this._identityChangesHead;null!==record;record=record._nextIdentityChange)fn(record)},DefaultIterableDiffer.prototype.diff=function(collection){if(isBlank(collection)&&(collection=[]),!isListLikeIterable(collection))throw new Error("Error trying to diff '"+collection+"'");return this.check(collection)?this:null},DefaultIterableDiffer.prototype.onDestroy=function(){},DefaultIterableDiffer.prototype.check=function(collection){var _this=this;this._reset();var index,item,itemTrackBy,record=this._itHead,mayBeDirty=!1;if(isArray(collection)){var list=collection;for(this._length=collection.length,index=0;index<this._length;index++)item=list[index],itemTrackBy=this._trackByFn(index,item),null!==record&&looseIdentical(record.trackById,itemTrackBy)?(mayBeDirty&&(record=this._verifyReinsertion(record,item,itemTrackBy,index)),looseIdentical(record.item,item)||this._addIdentityChange(record,item)):(record=this._mismatch(record,item,itemTrackBy,index),mayBeDirty=!0),record=record._next}else index=0,iterateListLike(collection,function(item){itemTrackBy=_this._trackByFn(index,item),null!==record&&looseIdentical(record.trackById,itemTrackBy)?(mayBeDirty&&(record=_this._verifyReinsertion(record,item,itemTrackBy,index)),looseIdentical(record.item,item)||_this._addIdentityChange(record,item)):(record=_this._mismatch(record,item,itemTrackBy,index),mayBeDirty=!0),record=record._next,index++}),this._length=index;return this._truncate(record),this._collection=collection,this.isDirty},Object.defineProperty(DefaultIterableDiffer.prototype,"isDirty",{get:function(){return null!==this._additionsHead||null!==this._movesHead||null!==this._removalsHead||null!==this._identityChangesHead},enumerable:!0,configurable:!0}),DefaultIterableDiffer.prototype._reset=function(){if(this.isDirty){var record,nextRecord;for(record=this._previousItHead=this._itHead;null!==record;record=record._next)record._nextPrevious=record._next;for(record=this._additionsHead;null!==record;record=record._nextAdded)record.previousIndex=record.currentIndex;for(this._additionsHead=this._additionsTail=null,record=this._movesHead;null!==record;record=nextRecord)record.previousIndex=record.currentIndex,nextRecord=record._nextMoved;this._movesHead=this._movesTail=null,this._removalsHead=this._removalsTail=null,this._identityChangesHead=this._identityChangesTail=null}},DefaultIterableDiffer.prototype._mismatch=function(record,item,itemTrackBy,index){var previousRecord;return null===record?previousRecord=this._itTail:(previousRecord=record._prev,this._remove(record)),record=null===this._linkedRecords?null:this._linkedRecords.get(itemTrackBy,index),null!==record?(looseIdentical(record.item,item)||this._addIdentityChange(record,item),this._moveAfter(record,previousRecord,index)):(record=null===this._unlinkedRecords?null:this._unlinkedRecords.get(itemTrackBy),null!==record?(looseIdentical(record.item,item)||this._addIdentityChange(record,item),this._reinsertAfter(record,previousRecord,index)):record=this._addAfter(new CollectionChangeRecord(item,itemTrackBy),previousRecord,index)),record},DefaultIterableDiffer.prototype._verifyReinsertion=function(record,item,itemTrackBy,index){var reinsertRecord=null===this._unlinkedRecords?null:this._unlinkedRecords.get(itemTrackBy);return null!==reinsertRecord?record=this._reinsertAfter(reinsertRecord,record._prev,index):record.currentIndex!=index&&(record.currentIndex=index,this._addToMoves(record,index)),record},DefaultIterableDiffer.prototype._truncate=function(record){for(;null!==record;){var nextRecord=record._next;this._addToRemovals(this._unlink(record)),record=nextRecord}null!==this._unlinkedRecords&&this._unlinkedRecords.clear(),null!==this._additionsTail&&(this._additionsTail._nextAdded=null),null!==this._movesTail&&(this._movesTail._nextMoved=null),null!==this._itTail&&(this._itTail._next=null),null!==this._removalsTail&&(this._removalsTail._nextRemoved=null),null!==this._identityChangesTail&&(this._identityChangesTail._nextIdentityChange=null)},DefaultIterableDiffer.prototype._reinsertAfter=function(record,prevRecord,index){null!==this._unlinkedRecords&&this._unlinkedRecords.remove(record);var prev=record._prevRemoved,next=record._nextRemoved;return null===prev?this._removalsHead=next:prev._nextRemoved=next,null===next?this._removalsTail=prev:next._prevRemoved=prev,this._insertAfter(record,prevRecord,index),this._addToMoves(record,index),record},DefaultIterableDiffer.prototype._moveAfter=function(record,prevRecord,index){return this._unlink(record),this._insertAfter(record,prevRecord,index),this._addToMoves(record,index),record},DefaultIterableDiffer.prototype._addAfter=function(record,prevRecord,index){return this._insertAfter(record,prevRecord,index),null===this._additionsTail?this._additionsTail=this._additionsHead=record:this._additionsTail=this._additionsTail._nextAdded=record,record},DefaultIterableDiffer.prototype._insertAfter=function(record,prevRecord,index){var next=null===prevRecord?this._itHead:prevRecord._next;return record._next=next,record._prev=prevRecord,null===next?this._itTail=record:next._prev=record,null===prevRecord?this._itHead=record:prevRecord._next=record,null===this._linkedRecords&&(this._linkedRecords=new _DuplicateMap),this._linkedRecords.put(record),record.currentIndex=index,record},DefaultIterableDiffer.prototype._remove=function(record){return this._addToRemovals(this._unlink(record))},DefaultIterableDiffer.prototype._unlink=function(record){null!==this._linkedRecords&&this._linkedRecords.remove(record);var prev=record._prev,next=record._next;return null===prev?this._itHead=next:prev._next=next,null===next?this._itTail=prev:next._prev=prev,record},DefaultIterableDiffer.prototype._addToMoves=function(record,toIndex){return record.previousIndex===toIndex?record:(null===this._movesTail?this._movesTail=this._movesHead=record:this._movesTail=this._movesTail._nextMoved=record,record)},DefaultIterableDiffer.prototype._addToRemovals=function(record){return null===this._unlinkedRecords&&(this._unlinkedRecords=new _DuplicateMap),this._unlinkedRecords.put(record),record.currentIndex=null,record._nextRemoved=null,null===this._removalsTail?(this._removalsTail=this._removalsHead=record,record._prevRemoved=null):(record._prevRemoved=this._removalsTail,this._removalsTail=this._removalsTail._nextRemoved=record),record},DefaultIterableDiffer.prototype._addIdentityChange=function(record,item){return record.item=item,null===this._identityChangesTail?this._identityChangesTail=this._identityChangesHead=record:this._identityChangesTail=this._identityChangesTail._nextIdentityChange=record,record},DefaultIterableDiffer.prototype.toString=function(){var list=[];this.forEachItem(function(record){return list.push(record)});var previous=[];this.forEachPreviousItem(function(record){return previous.push(record)});var additions=[];this.forEachAddedItem(function(record){return additions.push(record)});var moves=[];this.forEachMovedItem(function(record){return moves.push(record)});var removals=[];this.forEachRemovedItem(function(record){return removals.push(record)});var identityChanges=[];return this.forEachIdentityChange(function(record){return identityChanges.push(record)}),"collection: "+list.join(", ")+"\nprevious: "+previous.join(", ")+"\nadditions: "+additions.join(", ")+"\nmoves: "+moves.join(", ")+"\nremovals: "+removals.join(", ")+"\nidentityChanges: "+identityChanges.join(", ")+"\n"},DefaultIterableDiffer}(),CollectionChangeRecord=function(){function CollectionChangeRecord(item,trackById){this.item=item,this.trackById=trackById,this.currentIndex=null,this.previousIndex=null,this._nextPrevious=null,this._prev=null,this._next=null,this._prevDup=null,this._nextDup=null,this._prevRemoved=null,this._nextRemoved=null,this._nextAdded=null,this._nextMoved=null,this._nextIdentityChange=null}return CollectionChangeRecord.prototype.toString=function(){return this.previousIndex===this.currentIndex?stringify(this.item):stringify(this.item)+"["+stringify(this.previousIndex)+"->"+stringify(this.currentIndex)+"]"},CollectionChangeRecord}(),_DuplicateItemRecordList=function(){function _DuplicateItemRecordList(){this._head=null,this._tail=null}return _DuplicateItemRecordList.prototype.add=function(record){null===this._head?(this._head=this._tail=record,record._nextDup=null,record._prevDup=null):(this._tail._nextDup=record,record._prevDup=this._tail,record._nextDup=null,this._tail=record)},_DuplicateItemRecordList.prototype.get=function(trackById,afterIndex){var record;for(record=this._head;null!==record;record=record._nextDup)if((null===afterIndex||afterIndex<record.currentIndex)&&looseIdentical(record.trackById,trackById))return record;return null},_DuplicateItemRecordList.prototype.remove=function(record){var prev=record._prevDup,next=record._nextDup;return null===prev?this._head=next:prev._nextDup=next,null===next?this._tail=prev:next._prevDup=prev,null===this._head},_DuplicateItemRecordList}(),_DuplicateMap=function(){function _DuplicateMap(){this.map=new Map}return _DuplicateMap.prototype.put=function(record){var key=getMapKey(record.trackById),duplicates=this.map.get(key);isPresent(duplicates)||(duplicates=new _DuplicateItemRecordList,this.map.set(key,duplicates)),duplicates.add(record)},_DuplicateMap.prototype.get=function(trackById,afterIndex){void 0===afterIndex&&(afterIndex=null);var key=getMapKey(trackById),recordList=this.map.get(key);return isBlank(recordList)?null:recordList.get(trackById,afterIndex)},_DuplicateMap.prototype.remove=function(record){var key=getMapKey(record.trackById),recordList=this.map.get(key);return recordList.remove(record)&&this.map.delete(key),record},Object.defineProperty(_DuplicateMap.prototype,"isEmpty",{get:function(){return 0===this.map.size},enumerable:!0,configurable:!0}),_DuplicateMap.prototype.clear=function(){this.map.clear()},_DuplicateMap.prototype.toString=function(){return"_DuplicateMap("+stringify(this.map)+")"},_DuplicateMap}(),DefaultKeyValueDifferFactory=function(){function DefaultKeyValueDifferFactory(){}return DefaultKeyValueDifferFactory.prototype.supports=function(obj){return obj instanceof Map||isJsObject(obj)},DefaultKeyValueDifferFactory.prototype.create=function(cdRef){return new DefaultKeyValueDiffer},DefaultKeyValueDifferFactory}(),DefaultKeyValueDiffer=function(){function DefaultKeyValueDiffer(){this._records=new Map,this._mapHead=null,this._previousMapHead=null,this._changesHead=null,this._changesTail=null,this._additionsHead=null,this._additionsTail=null,this._removalsHead=null,this._removalsTail=null}return Object.defineProperty(DefaultKeyValueDiffer.prototype,"isDirty",{get:function(){return null!==this._additionsHead||null!==this._changesHead||null!==this._removalsHead},enumerable:!0,configurable:!0}),DefaultKeyValueDiffer.prototype.forEachItem=function(fn){var record;for(record=this._mapHead;null!==record;record=record._next)fn(record)},DefaultKeyValueDiffer.prototype.forEachPreviousItem=function(fn){var record;for(record=this._previousMapHead;null!==record;record=record._nextPrevious)fn(record)},DefaultKeyValueDiffer.prototype.forEachChangedItem=function(fn){var record;for(record=this._changesHead;null!==record;record=record._nextChanged)fn(record)},DefaultKeyValueDiffer.prototype.forEachAddedItem=function(fn){var record;for(record=this._additionsHead;null!==record;record=record._nextAdded)fn(record)},DefaultKeyValueDiffer.prototype.forEachRemovedItem=function(fn){var record;for(record=this._removalsHead;null!==record;record=record._nextRemoved)fn(record)},DefaultKeyValueDiffer.prototype.diff=function(map){if(map){if(!(map instanceof Map||isJsObject(map)))throw new Error("Error trying to diff '"+map+"'")}else map=new Map;return this.check(map)?this:null},DefaultKeyValueDiffer.prototype.onDestroy=function(){},DefaultKeyValueDiffer.prototype.check=function(map){var _this=this;this._reset();var records=this._records,oldSeqRecord=this._mapHead,lastOldSeqRecord=null,lastNewSeqRecord=null,seqChanged=!1;return this._forEach(map,function(value,key){var newSeqRecord;oldSeqRecord&&key===oldSeqRecord.key?(newSeqRecord=oldSeqRecord,_this._maybeAddToChanges(newSeqRecord,value)):(seqChanged=!0,null!==oldSeqRecord&&(_this._removeFromSeq(lastOldSeqRecord,oldSeqRecord),_this._addToRemovals(oldSeqRecord)),records.has(key)?(newSeqRecord=records.get(key),_this._maybeAddToChanges(newSeqRecord,value)):(newSeqRecord=new KeyValueChangeRecord(key),records.set(key,newSeqRecord),newSeqRecord.currentValue=value,_this._addToAdditions(newSeqRecord))),seqChanged&&(_this._isInRemovals(newSeqRecord)&&_this._removeFromRemovals(newSeqRecord),null==lastNewSeqRecord?_this._mapHead=newSeqRecord:lastNewSeqRecord._next=newSeqRecord),lastOldSeqRecord=oldSeqRecord,lastNewSeqRecord=newSeqRecord,oldSeqRecord=oldSeqRecord&&oldSeqRecord._next}),this._truncate(lastOldSeqRecord,oldSeqRecord),this.isDirty},DefaultKeyValueDiffer.prototype._reset=function(){if(this.isDirty){var record=void 0;for(record=this._previousMapHead=this._mapHead;null!==record;record=record._next)record._nextPrevious=record._next;for(record=this._changesHead;null!==record;record=record._nextChanged)record.previousValue=record.currentValue;for(record=this._additionsHead;null!=record;record=record._nextAdded)record.previousValue=record.currentValue;this._changesHead=this._changesTail=null,this._additionsHead=this._additionsTail=null,this._removalsHead=this._removalsTail=null}},DefaultKeyValueDiffer.prototype._truncate=function(lastRecord,record){for(;null!==record;){null===lastRecord?this._mapHead=null:lastRecord._next=null;var nextRecord=record._next;this._addToRemovals(record),lastRecord=record,record=nextRecord}for(var rec=this._removalsHead;null!==rec;rec=rec._nextRemoved)rec.previousValue=rec.currentValue,rec.currentValue=null,this._records.delete(rec.key)},DefaultKeyValueDiffer.prototype._maybeAddToChanges=function(record,newValue){looseIdentical(newValue,record.currentValue)||(record.previousValue=record.currentValue,record.currentValue=newValue,this._addToChanges(record))},DefaultKeyValueDiffer.prototype._isInRemovals=function(record){return record===this._removalsHead||null!==record._nextRemoved||null!==record._prevRemoved},DefaultKeyValueDiffer.prototype._addToRemovals=function(record){null===this._removalsHead?this._removalsHead=this._removalsTail=record:(this._removalsTail._nextRemoved=record,record._prevRemoved=this._removalsTail,this._removalsTail=record)},DefaultKeyValueDiffer.prototype._removeFromSeq=function(prev,record){var next=record._next;null===prev?this._mapHead=next:prev._next=next,record._next=null},DefaultKeyValueDiffer.prototype._removeFromRemovals=function(record){var prev=record._prevRemoved,next=record._nextRemoved;null===prev?this._removalsHead=next:prev._nextRemoved=next,null===next?this._removalsTail=prev:next._prevRemoved=prev,record._prevRemoved=record._nextRemoved=null},DefaultKeyValueDiffer.prototype._addToAdditions=function(record){null===this._additionsHead?this._additionsHead=this._additionsTail=record:(this._additionsTail._nextAdded=record,this._additionsTail=record)},DefaultKeyValueDiffer.prototype._addToChanges=function(record){null===this._changesHead?this._changesHead=this._changesTail=record:(this._changesTail._nextChanged=record,this._changesTail=record)},DefaultKeyValueDiffer.prototype.toString=function(){var record,items=[],previous=[],changes=[],additions=[],removals=[];for(record=this._mapHead;null!==record;record=record._next)items.push(stringify(record));for(record=this._previousMapHead;null!==record;record=record._nextPrevious)previous.push(stringify(record));for(record=this._changesHead;null!==record;record=record._nextChanged)changes.push(stringify(record));for(record=this._additionsHead;null!==record;record=record._nextAdded)additions.push(stringify(record));for(record=this._removalsHead;null!==record;record=record._nextRemoved)removals.push(stringify(record));return"map: "+items.join(", ")+"\nprevious: "+previous.join(", ")+"\nadditions: "+additions.join(", ")+"\nchanges: "+changes.join(", ")+"\nremovals: "+removals.join(", ")+"\n"},DefaultKeyValueDiffer.prototype._forEach=function(obj,fn){obj instanceof Map?obj.forEach(fn):StringMapWrapper.forEach(obj,fn)},DefaultKeyValueDiffer}(),KeyValueChangeRecord=function(){function KeyValueChangeRecord(key){this.key=key,this.previousValue=null,this.currentValue=null,this._nextPrevious=null,this._next=null,this._nextAdded=null,this._nextRemoved=null,this._prevRemoved=null,this._nextChanged=null}return KeyValueChangeRecord.prototype.toString=function(){return looseIdentical(this.previousValue,this.currentValue)?stringify(this.key):stringify(this.key)+"["+stringify(this.previousValue)+"->"+stringify(this.currentValue)+"]"},KeyValueChangeRecord}(),IterableDiffers=function(){function IterableDiffers(factories){this.factories=factories}return IterableDiffers.create=function(factories,parent){if(isPresent(parent)){var copied=ListWrapper.clone(parent.factories);return factories=factories.concat(copied),new IterableDiffers(factories)}return new IterableDiffers(factories)},IterableDiffers.extend=function(factories){return{provide:IterableDiffers,useFactory:function(parent){if(isBlank(parent))throw new Error("Cannot extend IterableDiffers without a parent injector");return IterableDiffers.create(factories,parent)},deps:[[IterableDiffers,new SkipSelf,new Optional]]}},IterableDiffers.prototype.find=function(iterable){var factory=this.factories.find(function(f){return f.supports(iterable)});if(isPresent(factory))return factory;throw new Error("Cannot find a differ supporting object '"+iterable+"' of type '"+getTypeNameForDebugging(iterable)+"'")},IterableDiffers}(),KeyValueDiffers=function(){function KeyValueDiffers(factories){this.factories=factories}return KeyValueDiffers.create=function(factories,parent){if(isPresent(parent)){var copied=ListWrapper.clone(parent.factories);return factories=factories.concat(copied),new KeyValueDiffers(factories)}return new KeyValueDiffers(factories)},KeyValueDiffers.extend=function(factories){return{provide:KeyValueDiffers,useFactory:function(parent){if(isBlank(parent))throw new Error("Cannot extend KeyValueDiffers without a parent injector");return KeyValueDiffers.create(factories,parent)},deps:[[KeyValueDiffers,new SkipSelf,new Optional]]}},KeyValueDiffers.prototype.find=function(kv){var factory=this.factories.find(function(f){return f.supports(kv)});if(isPresent(factory))return factory;throw new Error("Cannot find a differ supporting object '"+kv+"'")},KeyValueDiffers}(),UNINITIALIZED={toString:function(){return"CD_INIT_VALUE"}},WrappedValue=function(){function WrappedValue(wrapped){this.wrapped=wrapped}return WrappedValue.wrap=function(value){return new WrappedValue(value)},WrappedValue}(),ValueUnwrapper=function(){function ValueUnwrapper(){this.hasWrappedValue=!1}return ValueUnwrapper.prototype.unwrap=function(value){return value instanceof WrappedValue?(this.hasWrappedValue=!0,value.wrapped):value},ValueUnwrapper.prototype.reset=function(){this.hasWrappedValue=!1},ValueUnwrapper}(),SimpleChange=function(){function SimpleChange(previousValue,currentValue){this.previousValue=previousValue,this.currentValue=currentValue}return SimpleChange.prototype.isFirstChange=function(){return this.previousValue===UNINITIALIZED},SimpleChange}(),ChangeDetectorRef=function(){function ChangeDetectorRef(){}return ChangeDetectorRef}(),keyValDiff=[new DefaultKeyValueDifferFactory],iterableDiff=[new DefaultIterableDifferFactory],defaultIterableDiffers=new IterableDiffers(iterableDiff),defaultKeyValueDiffers=new KeyValueDiffers(keyValDiff),RenderComponentType=function(){function RenderComponentType(id,templateUrl,slotCount,encapsulation,styles,animations){this.id=id,this.templateUrl=templateUrl,this.slotCount=slotCount,this.encapsulation=encapsulation,this.styles=styles,this.animations=animations}return RenderComponentType}(),RenderDebugInfo=function(){function RenderDebugInfo(){}return Object.defineProperty(RenderDebugInfo.prototype,"injector",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(RenderDebugInfo.prototype,"component",{
get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(RenderDebugInfo.prototype,"providerTokens",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(RenderDebugInfo.prototype,"references",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(RenderDebugInfo.prototype,"context",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(RenderDebugInfo.prototype,"source",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),RenderDebugInfo}(),Renderer=function(){function Renderer(){}return Renderer}(),RootRenderer=function(){function RootRenderer(){}return RootRenderer}();/**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
exports.SecurityContext,function(SecurityContext){SecurityContext[SecurityContext.NONE=0]="NONE",SecurityContext[SecurityContext.HTML=1]="HTML",SecurityContext[SecurityContext.STYLE=2]="STYLE",SecurityContext[SecurityContext.SCRIPT=3]="SCRIPT",SecurityContext[SecurityContext.URL=4]="URL",SecurityContext[SecurityContext.RESOURCE_URL=5]="RESOURCE_URL"}(exports.SecurityContext||(exports.SecurityContext={}));var trace,events,ViewType,Sanitizer=function(){function Sanitizer(){}return Sanitizer}(),ElementRef=function(){function ElementRef(nativeElement){this.nativeElement=nativeElement}return ElementRef}(),wtfEnabled=detectWTF(),wtfCreateScope=wtfEnabled?createScope:function(signature,flags){return noopScope},wtfLeave=wtfEnabled?leave:function(s,r){return r},wtfStartTimeRange=wtfEnabled?startTimeRange:function(rangeType,action){return null},wtfEndTimeRange=wtfEnabled?endTimeRange:function(r){return null},ViewContainerRef=function(){function ViewContainerRef(){}return Object.defineProperty(ViewContainerRef.prototype,"element",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef.prototype,"injector",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef.prototype,"parentInjector",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef.prototype,"length",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),ViewContainerRef}(),ViewContainerRef_=function(){function ViewContainerRef_(_element){this._element=_element,this._createComponentInContainerScope=wtfCreateScope("ViewContainerRef#createComponent()"),this._insertScope=wtfCreateScope("ViewContainerRef#insert()"),this._removeScope=wtfCreateScope("ViewContainerRef#remove()"),this._detachScope=wtfCreateScope("ViewContainerRef#detach()")}return ViewContainerRef_.prototype.get=function(index){return this._element.nestedViews[index].ref},Object.defineProperty(ViewContainerRef_.prototype,"length",{get:function(){var views=this._element.nestedViews;return isPresent(views)?views.length:0},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef_.prototype,"element",{get:function(){return this._element.elementRef},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef_.prototype,"injector",{get:function(){return this._element.injector},enumerable:!0,configurable:!0}),Object.defineProperty(ViewContainerRef_.prototype,"parentInjector",{get:function(){return this._element.parentInjector},enumerable:!0,configurable:!0}),ViewContainerRef_.prototype.createEmbeddedView=function(templateRef,context,index){void 0===context&&(context=null),void 0===index&&(index=-1);var viewRef=templateRef.createEmbeddedView(context);return this.insert(viewRef,index),viewRef},ViewContainerRef_.prototype.createComponent=function(componentFactory,index,injector,projectableNodes){void 0===index&&(index=-1),void 0===injector&&(injector=null),void 0===projectableNodes&&(projectableNodes=null);var s=this._createComponentInContainerScope(),contextInjector=isPresent(injector)?injector:this._element.parentInjector,componentRef=componentFactory.create(contextInjector,projectableNodes);return this.insert(componentRef.hostView,index),wtfLeave(s,componentRef)},ViewContainerRef_.prototype.insert=function(viewRef,index){void 0===index&&(index=-1);var s=this._insertScope();index==-1&&(index=this.length);var viewRef_=viewRef;return this._element.attachView(viewRef_.internalView,index),wtfLeave(s,viewRef_)},ViewContainerRef_.prototype.move=function(viewRef,currentIndex){var s=this._insertScope();if(currentIndex!=-1){var viewRef_=viewRef;return this._element.moveView(viewRef_.internalView,currentIndex),wtfLeave(s,viewRef_)}},ViewContainerRef_.prototype.indexOf=function(viewRef){return ListWrapper.indexOf(this._element.nestedViews,viewRef.internalView)},ViewContainerRef_.prototype.remove=function(index){void 0===index&&(index=-1);var s=this._removeScope();index==-1&&(index=this.length-1);var view=this._element.detachView(index);view.destroy(),wtfLeave(s)},ViewContainerRef_.prototype.detach=function(index){void 0===index&&(index=-1);var s=this._detachScope();index==-1&&(index=this.length-1);var view=this._element.detachView(index);return wtfLeave(s,view.ref)},ViewContainerRef_.prototype.clear=function(){for(var i=this.length-1;i>=0;i--)this.remove(i)},ViewContainerRef_}();!function(ViewType){ViewType[ViewType.HOST=0]="HOST",ViewType[ViewType.COMPONENT=1]="COMPONENT",ViewType[ViewType.EMBEDDED=2]="EMBEDDED"}(ViewType||(ViewType={}));var _platform,AppElement=function(){function AppElement(index,parentIndex,parentView,nativeElement){this.index=index,this.parentIndex=parentIndex,this.parentView=parentView,this.nativeElement=nativeElement,this.nestedViews=null,this.componentView=null}return Object.defineProperty(AppElement.prototype,"elementRef",{get:function(){return new ElementRef(this.nativeElement)},enumerable:!0,configurable:!0}),Object.defineProperty(AppElement.prototype,"vcRef",{get:function(){return new ViewContainerRef_(this)},enumerable:!0,configurable:!0}),AppElement.prototype.initComponent=function(component,componentConstructorViewQueries,view){this.component=component,this.componentConstructorViewQueries=componentConstructorViewQueries,this.componentView=view},Object.defineProperty(AppElement.prototype,"parentInjector",{get:function(){return this.parentView.injector(this.parentIndex)},enumerable:!0,configurable:!0}),Object.defineProperty(AppElement.prototype,"injector",{get:function(){return this.parentView.injector(this.index)},enumerable:!0,configurable:!0}),AppElement.prototype.mapNestedViews=function(nestedViewClass,callback){var result=[];return isPresent(this.nestedViews)&&this.nestedViews.forEach(function(nestedView){nestedView.clazz===nestedViewClass&&result.push(callback(nestedView))}),result},AppElement.prototype.moveView=function(view,currentIndex){var previousIndex=this.nestedViews.indexOf(view);if(view.type===ViewType.COMPONENT)throw new Error("Component views can't be moved!");var nestedViews=this.nestedViews;null==nestedViews&&(nestedViews=[],this.nestedViews=nestedViews),ListWrapper.removeAt(nestedViews,previousIndex),ListWrapper.insert(nestedViews,currentIndex,view);var refRenderNode;if(currentIndex>0){var prevView=nestedViews[currentIndex-1];refRenderNode=prevView.lastRootNode}else refRenderNode=this.nativeElement;isPresent(refRenderNode)&&view.renderer.attachViewAfter(refRenderNode,view.flatRootNodes),view.markContentChildAsMoved(this)},AppElement.prototype.attachView=function(view,viewIndex){if(view.type===ViewType.COMPONENT)throw new Error("Component views can't be moved!");var nestedViews=this.nestedViews;null==nestedViews&&(nestedViews=[],this.nestedViews=nestedViews),ListWrapper.insert(nestedViews,viewIndex,view);var refRenderNode;if(viewIndex>0){var prevView=nestedViews[viewIndex-1];refRenderNode=prevView.lastRootNode}else refRenderNode=this.nativeElement;isPresent(refRenderNode)&&view.renderer.attachViewAfter(refRenderNode,view.flatRootNodes),view.addToContentChildren(this)},AppElement.prototype.detachView=function(viewIndex){var view=ListWrapper.removeAt(this.nestedViews,viewIndex);if(view.type===ViewType.COMPONENT)throw new Error("Component views can't be moved!");return view.detach(),view.removeFromContentChildren(this),view},AppElement}(),__extends$6=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ExpressionChangedAfterItHasBeenCheckedError=function(_super){function ExpressionChangedAfterItHasBeenCheckedError(oldValue,currValue){var msg="Expression has changed after it was checked. Previous value: '"+oldValue+"'. Current value: '"+currValue+"'.";oldValue===UNINITIALIZED&&(msg+=" It seems like the view has been created after its parent and its children have been dirty checked. Has it been created in a change detection hook ?"),_super.call(this,msg)}return __extends$6(ExpressionChangedAfterItHasBeenCheckedError,_super),ExpressionChangedAfterItHasBeenCheckedError}(BaseError),ViewWrappedError=function(_super){function ViewWrappedError(originalError,context){_super.call(this,"Error in "+context.source,originalError),this.context=context}return __extends$6(ViewWrappedError,_super),ViewWrappedError}(WrappedError),ViewDestroyedError=function(_super){function ViewDestroyedError(details){_super.call(this,"Attempt to use a destroyed view: "+details)}return __extends$6(ViewDestroyedError,_super),ViewDestroyedError}(BaseError),ViewUtils=function(){function ViewUtils(_renderer,_appId,sanitizer){this._renderer=_renderer,this._appId=_appId,this._nextCompTypeId=0,this.sanitizer=sanitizer}return ViewUtils.prototype.createRenderComponentType=function(templateUrl,slotCount,encapsulation,styles,animations){return new RenderComponentType(this._appId+"-"+this._nextCompTypeId++,templateUrl,slotCount,encapsulation,styles,animations)},ViewUtils.prototype.renderComponent=function(renderComponentType){return this._renderer.renderComponent(renderComponentType)},ViewUtils.decorators=[{type:Injectable}],ViewUtils.ctorParameters=[{type:RootRenderer},{type:void 0,decorators:[{type:Inject,args:[APP_ID]}]},{type:Sanitizer}],ViewUtils}(),EMPTY_ARR=[],MAX_INTERPOLATION_VALUES=9,EMPTY_ARRAY=[],EMPTY_MAP={},__extends$5=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ComponentRef=function(){function ComponentRef(){}return Object.defineProperty(ComponentRef.prototype,"location",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef.prototype,"injector",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef.prototype,"instance",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef.prototype,"hostView",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef.prototype,"changeDetectorRef",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef.prototype,"componentType",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),ComponentRef}(),ComponentRef_=function(_super){function ComponentRef_(_hostElement,_componentType){_super.call(this),this._hostElement=_hostElement,this._componentType=_componentType}return __extends$5(ComponentRef_,_super),Object.defineProperty(ComponentRef_.prototype,"location",{get:function(){return this._hostElement.elementRef},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef_.prototype,"injector",{get:function(){return this._hostElement.injector},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef_.prototype,"instance",{get:function(){return this._hostElement.component},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef_.prototype,"hostView",{get:function(){return this._hostElement.parentView.ref},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef_.prototype,"changeDetectorRef",{get:function(){return this._hostElement.parentView.ref},enumerable:!0,configurable:!0}),Object.defineProperty(ComponentRef_.prototype,"componentType",{get:function(){return this._componentType},enumerable:!0,configurable:!0}),ComponentRef_.prototype.destroy=function(){this._hostElement.parentView.destroy()},ComponentRef_.prototype.onDestroy=function(callback){this.hostView.onDestroy(callback)},ComponentRef_}(ComponentRef),EMPTY_CONTEXT=new Object,ComponentFactory=function(){function ComponentFactory(selector,_viewFactory,_componentType){this.selector=selector,this._viewFactory=_viewFactory,this._componentType=_componentType}return Object.defineProperty(ComponentFactory.prototype,"componentType",{get:function(){return this._componentType},enumerable:!0,configurable:!0}),ComponentFactory.prototype.create=function(injector,projectableNodes,rootSelectorOrNode){void 0===projectableNodes&&(projectableNodes=null),void 0===rootSelectorOrNode&&(rootSelectorOrNode=null);var vu=injector.get(ViewUtils);isBlank(projectableNodes)&&(projectableNodes=[]);var hostView=this._viewFactory(vu,injector,null),hostElement=hostView.create(EMPTY_CONTEXT,projectableNodes,rootSelectorOrNode);return new ComponentRef_(hostElement,this._componentType)},ComponentFactory}(),__extends$7=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},NoComponentFactoryError=function(_super){function NoComponentFactoryError(component){_super.call(this,"No component factory found for "+stringify(component)),this.component=component}return __extends$7(NoComponentFactoryError,_super),NoComponentFactoryError}(BaseError),_NullComponentFactoryResolver=function(){function _NullComponentFactoryResolver(){}return _NullComponentFactoryResolver.prototype.resolveComponentFactory=function(component){throw new NoComponentFactoryError(component)},_NullComponentFactoryResolver}(),ComponentFactoryResolver=function(){function ComponentFactoryResolver(){}return ComponentFactoryResolver.NULL=new _NullComponentFactoryResolver,ComponentFactoryResolver}(),CodegenComponentFactoryResolver=function(){function CodegenComponentFactoryResolver(factories,_parent){this._parent=_parent,this._factories=new Map;for(var i=0;i<factories.length;i++){var factory=factories[i];this._factories.set(factory.componentType,factory)}}return CodegenComponentFactoryResolver.prototype.resolveComponentFactory=function(component){var result=this._factories.get(component);return result||(result=this._parent.resolveComponentFactory(component)),result},CodegenComponentFactoryResolver}(),__extends$8=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},EventEmitter=function(_super){function EventEmitter(isAsync){void 0===isAsync&&(isAsync=!1),_super.call(this),this.__isAsync=isAsync}return __extends$8(EventEmitter,_super),EventEmitter.prototype.emit=function(value){_super.prototype.next.call(this,value)},EventEmitter.prototype.subscribe=function(generatorOrNext,error,complete){var schedulerFn,errorFn=function(err){return null},completeFn=function(){return null};return generatorOrNext&&"object"==typeof generatorOrNext?(schedulerFn=this.__isAsync?function(value){setTimeout(function(){return generatorOrNext.next(value)})}:function(value){generatorOrNext.next(value)},generatorOrNext.error&&(errorFn=this.__isAsync?function(err){setTimeout(function(){return generatorOrNext.error(err)})}:function(err){generatorOrNext.error(err)}),generatorOrNext.complete&&(completeFn=this.__isAsync?function(){setTimeout(function(){return generatorOrNext.complete()})}:function(){generatorOrNext.complete()})):(schedulerFn=this.__isAsync?function(value){setTimeout(function(){return generatorOrNext(value)})}:function(value){generatorOrNext(value)},error&&(errorFn=this.__isAsync?function(err){setTimeout(function(){return error(err)})}:function(err){error(err)}),complete&&(completeFn=this.__isAsync?function(){setTimeout(function(){return complete()})}:function(){complete()})),_super.prototype.subscribe.call(this,schedulerFn,errorFn,completeFn)},EventEmitter}(rxjs_Subject.Subject),NgZoneImpl=function(){function NgZoneImpl(_a){var _this=this,trace=_a.trace,onEnter=_a.onEnter,onLeave=_a.onLeave,setMicrotask=_a.setMicrotask,setMacrotask=_a.setMacrotask,onError=_a.onError;if(this.onEnter=onEnter,this.onLeave=onLeave,this.setMicrotask=setMicrotask,this.setMacrotask=setMacrotask,this.onError=onError,"undefined"==typeof Zone)throw new Error("Angular requires Zone.js prolyfill.");Zone.assertZonePatched(),this.outer=this.inner=Zone.current,Zone.wtfZoneSpec&&(this.inner=this.inner.fork(Zone.wtfZoneSpec)),trace&&Zone.longStackTraceZoneSpec&&(this.inner=this.inner.fork(Zone.longStackTraceZoneSpec)),this.inner=this.inner.fork({name:"angular",properties:{isAngularZone:!0},onInvokeTask:function(delegate,current,target,task,applyThis,applyArgs){try{return _this.onEnter(),delegate.invokeTask(target,task,applyThis,applyArgs)}finally{_this.onLeave()}},onInvoke:function(delegate,current,target,callback,applyThis,applyArgs,source){try{return _this.onEnter(),delegate.invoke(target,callback,applyThis,applyArgs,source)}finally{_this.onLeave()}},onHasTask:function(delegate,current,target,hasTaskState){delegate.hasTask(target,hasTaskState),current===target&&("microTask"==hasTaskState.change?_this.setMicrotask(hasTaskState.microTask):"macroTask"==hasTaskState.change&&_this.setMacrotask(hasTaskState.macroTask))},onHandleError:function(delegate,current,target,error){return delegate.handleError(target,error),_this.onError(error),!1}})}return NgZoneImpl.isInAngularZone=function(){return Zone.current.get("isAngularZone")===!0},NgZoneImpl.prototype.runInner=function(fn){return this.inner.run(fn)},NgZoneImpl.prototype.runInnerGuarded=function(fn){return this.inner.runGuarded(fn)},NgZoneImpl.prototype.runOuter=function(fn){return this.outer.run(fn)},NgZoneImpl}(),NgZone=function(){function NgZone(_a){var _this=this,_b=_a.enableLongStackTrace,enableLongStackTrace=void 0!==_b&&_b;this._hasPendingMicrotasks=!1,this._hasPendingMacrotasks=!1,this._isStable=!0,this._nesting=0,this._onUnstable=new EventEmitter((!1)),this._onMicrotaskEmpty=new EventEmitter((!1)),this._onStable=new EventEmitter((!1)),this._onErrorEvents=new EventEmitter((!1)),this._zoneImpl=new NgZoneImpl({trace:enableLongStackTrace,onEnter:function(){_this._nesting++,_this._isStable&&(_this._isStable=!1,_this._onUnstable.emit(null))},onLeave:function(){_this._nesting--,_this._checkStable()},setMicrotask:function(hasMicrotasks){_this._hasPendingMicrotasks=hasMicrotasks,_this._checkStable()},setMacrotask:function(hasMacrotasks){_this._hasPendingMacrotasks=hasMacrotasks},onError:function(error){return _this._onErrorEvents.emit(error)}})}return NgZone.isInAngularZone=function(){return NgZoneImpl.isInAngularZone()},NgZone.assertInAngularZone=function(){if(!NgZoneImpl.isInAngularZone())throw new Error("Expected to be in Angular Zone, but it is not!")},NgZone.assertNotInAngularZone=function(){if(NgZoneImpl.isInAngularZone())throw new Error("Expected to not be in Angular Zone, but it is!")},NgZone.prototype._checkStable=function(){var _this=this;if(0==this._nesting&&!this._hasPendingMicrotasks&&!this._isStable)try{this._nesting++,this._onMicrotaskEmpty.emit(null)}finally{if(this._nesting--,!this._hasPendingMicrotasks)try{this.runOutsideAngular(function(){return _this._onStable.emit(null)})}finally{this._isStable=!0}}},Object.defineProperty(NgZone.prototype,"onUnstable",{get:function(){return this._onUnstable},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"onMicrotaskEmpty",{get:function(){return this._onMicrotaskEmpty},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"onStable",{get:function(){return this._onStable},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"onError",{get:function(){return this._onErrorEvents},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"isStable",{get:function(){return this._isStable},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"hasPendingMicrotasks",{get:function(){return this._hasPendingMicrotasks},enumerable:!0,configurable:!0}),Object.defineProperty(NgZone.prototype,"hasPendingMacrotasks",{get:function(){return this._hasPendingMacrotasks},enumerable:!0,configurable:!0}),NgZone.prototype.run=function(fn){return this._zoneImpl.runInner(fn)},NgZone.prototype.runGuarded=function(fn){return this._zoneImpl.runInnerGuarded(fn)},NgZone.prototype.runOutsideAngular=function(fn){return this._zoneImpl.runOuter(fn)},NgZone}(),Testability=function(){function Testability(_ngZone){this._ngZone=_ngZone,this._pendingCount=0,this._isZoneStable=!0,this._didWork=!1,this._callbacks=[],this._watchAngularEvents()}return Testability.prototype._watchAngularEvents=function(){var _this=this;this._ngZone.onUnstable.subscribe({next:function(){_this._didWork=!0,_this._isZoneStable=!1}}),this._ngZone.runOutsideAngular(function(){_this._ngZone.onStable.subscribe({next:function(){NgZone.assertNotInAngularZone(),scheduleMicroTask(function(){_this._isZoneStable=!0,_this._runCallbacksIfReady()})}})})},Testability.prototype.increasePendingRequestCount=function(){return this._pendingCount+=1,this._didWork=!0,this._pendingCount},Testability.prototype.decreasePendingRequestCount=function(){if(this._pendingCount-=1,this._pendingCount<0)throw new Error("pending async requests below zero");return this._runCallbacksIfReady(),this._pendingCount},Testability.prototype.isStable=function(){return this._isZoneStable&&0==this._pendingCount&&!this._ngZone.hasPendingMacrotasks},Testability.prototype._runCallbacksIfReady=function(){var _this=this;this.isStable()?scheduleMicroTask(function(){for(;0!==_this._callbacks.length;)_this._callbacks.pop()(_this._didWork);_this._didWork=!1}):this._didWork=!0},Testability.prototype.whenStable=function(callback){this._callbacks.push(callback),this._runCallbacksIfReady()},Testability.prototype.getPendingRequestCount=function(){return this._pendingCount},Testability.prototype.findBindings=function(using,provider,exactMatch){return[]},Testability.prototype.findProviders=function(using,provider,exactMatch){return[]},Testability.decorators=[{type:Injectable}],Testability.ctorParameters=[{type:NgZone}],Testability}(),TestabilityRegistry=function(){function TestabilityRegistry(){this._applications=new Map,_testabilityGetter.addToWindow(this)}return TestabilityRegistry.prototype.registerApplication=function(token,testability){this._applications.set(token,testability)},TestabilityRegistry.prototype.getTestability=function(elem){return this._applications.get(elem)},TestabilityRegistry.prototype.getAllTestabilities=function(){return MapWrapper.values(this._applications)},TestabilityRegistry.prototype.getAllRootElements=function(){return MapWrapper.keys(this._applications)},TestabilityRegistry.prototype.findTestabilityInTree=function(elem,findInAncestors){return void 0===findInAncestors&&(findInAncestors=!0),_testabilityGetter.findTestabilityInTree(this,elem,findInAncestors)},TestabilityRegistry.decorators=[{type:Injectable}],TestabilityRegistry.ctorParameters=[],TestabilityRegistry}(),_NoopGetTestability=function(){function _NoopGetTestability(){}return _NoopGetTestability.prototype.addToWindow=function(registry){},_NoopGetTestability.prototype.findTestabilityInTree=function(registry,elem,findInAncestors){return null},_NoopGetTestability}(),_testabilityGetter=new _NoopGetTestability,__extends$3=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_devMode=!0,_runModeLocked=!1,PlatformRef=function(){function PlatformRef(){}return PlatformRef.prototype.bootstrapModuleFactory=function(moduleFactory){throw unimplemented()},PlatformRef.prototype.bootstrapModule=function(moduleType,compilerOptions){throw void 0===compilerOptions&&(compilerOptions=[]),unimplemented()},Object.defineProperty(PlatformRef.prototype,"injector",{get:function(){throw unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(PlatformRef.prototype,"destroyed",{get:function(){throw unimplemented()},enumerable:!0,configurable:!0}),PlatformRef}(),PlatformRef_=function(_super){function PlatformRef_(_injector){_super.call(this),this._injector=_injector,this._modules=[],this._destroyListeners=[],this._destroyed=!1}return __extends$3(PlatformRef_,_super),PlatformRef_.prototype.onDestroy=function(callback){this._destroyListeners.push(callback)},Object.defineProperty(PlatformRef_.prototype,"injector",{get:function(){return this._injector},enumerable:!0,configurable:!0}),Object.defineProperty(PlatformRef_.prototype,"destroyed",{get:function(){return this._destroyed},enumerable:!0,configurable:!0}),PlatformRef_.prototype.destroy=function(){if(this._destroyed)throw new Error("The platform has already been destroyed!");this._modules.slice().forEach(function(module){return module.destroy()}),this._destroyListeners.forEach(function(listener){return listener()}),this._destroyed=!0},PlatformRef_.prototype.bootstrapModuleFactory=function(moduleFactory){return this._bootstrapModuleFactoryWithZone(moduleFactory,null)},PlatformRef_.prototype._bootstrapModuleFactoryWithZone=function(moduleFactory,ngZone){var _this=this;return ngZone||(ngZone=new NgZone({enableLongStackTrace:isDevMode()})),ngZone.run(function(){var ngZoneInjector=ReflectiveInjector.resolveAndCreate([{provide:NgZone,useValue:ngZone}],_this.injector),moduleRef=moduleFactory.create(ngZoneInjector),exceptionHandler=moduleRef.injector.get(ErrorHandler,null);if(!exceptionHandler)throw new Error("No ErrorHandler. Is platform module (BrowserModule) included?");return moduleRef.onDestroy(function(){return ListWrapper.remove(_this._modules,moduleRef)}),ngZone.onError.subscribe({next:function(error){exceptionHandler.handleError(error)}}),_callAndReportToErrorHandler(exceptionHandler,function(){var initStatus=moduleRef.injector.get(ApplicationInitStatus);return initStatus.donePromise.then(function(){return _this._moduleDoBootstrap(moduleRef),moduleRef})})})},PlatformRef_.prototype.bootstrapModule=function(moduleType,compilerOptions){return void 0===compilerOptions&&(compilerOptions=[]),this._bootstrapModuleWithZone(moduleType,compilerOptions,null)},PlatformRef_.prototype._bootstrapModuleWithZone=function(moduleType,compilerOptions,ngZone,componentFactoryCallback){var _this=this;void 0===compilerOptions&&(compilerOptions=[]);var compilerFactory=this.injector.get(CompilerFactory),compiler=compilerFactory.createCompiler(Array.isArray(compilerOptions)?compilerOptions:[compilerOptions]);return componentFactoryCallback?compiler.compileModuleAndAllComponentsAsync(moduleType).then(function(_a){var ngModuleFactory=_a.ngModuleFactory,componentFactories=_a.componentFactories;return componentFactoryCallback(componentFactories),_this._bootstrapModuleFactoryWithZone(ngModuleFactory,ngZone)}):compiler.compileModuleAsync(moduleType).then(function(moduleFactory){return _this._bootstrapModuleFactoryWithZone(moduleFactory,ngZone)})},PlatformRef_.prototype._moduleDoBootstrap=function(moduleRef){var appRef=moduleRef.injector.get(ApplicationRef);if(moduleRef.bootstrapFactories.length>0)moduleRef.bootstrapFactories.forEach(function(compFactory){return appRef.bootstrap(compFactory)});else{if(!moduleRef.instance.ngDoBootstrap)throw new Error("The module "+stringify(moduleRef.instance.constructor)+' was bootstrapped, but it does not declare "@NgModule.bootstrap" components nor a "ngDoBootstrap" method. Please define one of these.');moduleRef.instance.ngDoBootstrap(appRef)}},PlatformRef_.decorators=[{type:Injectable}],PlatformRef_.ctorParameters=[{type:Injector}],PlatformRef_}(PlatformRef),ApplicationRef=function(){function ApplicationRef(){}return Object.defineProperty(ApplicationRef.prototype,"componentTypes",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(ApplicationRef.prototype,"components",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),ApplicationRef}(),ApplicationRef_=function(_super){function ApplicationRef_(_zone,_console,_injector,_exceptionHandler,_componentFactoryResolver,_initStatus,_testabilityRegistry,_testability){var _this=this;_super.call(this),this._zone=_zone,this._console=_console,this._injector=_injector,this._exceptionHandler=_exceptionHandler,this._componentFactoryResolver=_componentFactoryResolver,this._initStatus=_initStatus,this._testabilityRegistry=_testabilityRegistry,this._testability=_testability,this._bootstrapListeners=[],this._rootComponents=[],this._rootComponentTypes=[],this._changeDetectorRefs=[],this._runningTick=!1,this._enforceNoNewChanges=!1,this._enforceNoNewChanges=isDevMode(),this._zone.onMicrotaskEmpty.subscribe({next:function(){_this._zone.run(function(){_this.tick()})}})}return __extends$3(ApplicationRef_,_super),ApplicationRef_.prototype.registerChangeDetector=function(changeDetector){this._changeDetectorRefs.push(changeDetector)},ApplicationRef_.prototype.unregisterChangeDetector=function(changeDetector){ListWrapper.remove(this._changeDetectorRefs,changeDetector)},ApplicationRef_.prototype.bootstrap=function(componentOrFactory){var _this=this;if(!this._initStatus.done)throw new Error("Cannot bootstrap as there are still asynchronous initializers running. Bootstrap components in the `ngDoBootstrap` method of the root module.");var componentFactory;componentFactory=componentOrFactory instanceof ComponentFactory?componentOrFactory:this._componentFactoryResolver.resolveComponentFactory(componentOrFactory),this._rootComponentTypes.push(componentFactory.componentType);var compRef=componentFactory.create(this._injector,[],componentFactory.selector);compRef.onDestroy(function(){_this._unloadComponent(compRef)});var testability=compRef.injector.get(Testability,null);return testability&&compRef.injector.get(TestabilityRegistry).registerApplication(compRef.location.nativeElement,testability),this._loadComponent(compRef),isDevMode()&&this._console.log("Angular 2 is running in the development mode. Call enableProdMode() to enable the production mode."),compRef},ApplicationRef_.prototype._loadComponent=function(componentRef){this._changeDetectorRefs.push(componentRef.changeDetectorRef),this.tick(),this._rootComponents.push(componentRef);var listeners=this._injector.get(APP_BOOTSTRAP_LISTENER,[]).concat(this._bootstrapListeners);listeners.forEach(function(listener){return listener(componentRef)})},ApplicationRef_.prototype._unloadComponent=function(componentRef){this._rootComponents.indexOf(componentRef)!=-1&&(this.unregisterChangeDetector(componentRef.changeDetectorRef),ListWrapper.remove(this._rootComponents,componentRef))},ApplicationRef_.prototype.tick=function(){if(this._runningTick)throw new Error("ApplicationRef.tick is called recursively");var scope=ApplicationRef_._tickScope();try{this._runningTick=!0,this._changeDetectorRefs.forEach(function(detector){return detector.detectChanges()}),this._enforceNoNewChanges&&this._changeDetectorRefs.forEach(function(detector){return detector.checkNoChanges()})}finally{this._runningTick=!1,wtfLeave(scope)}},ApplicationRef_.prototype.ngOnDestroy=function(){this._rootComponents.slice().forEach(function(component){return component.destroy()})},Object.defineProperty(ApplicationRef_.prototype,"componentTypes",{get:function(){return this._rootComponentTypes},enumerable:!0,configurable:!0}),Object.defineProperty(ApplicationRef_.prototype,"components",{get:function(){return this._rootComponents},enumerable:!0,configurable:!0}),ApplicationRef_._tickScope=wtfCreateScope("ApplicationRef#tick()"),ApplicationRef_.decorators=[{type:Injectable}],ApplicationRef_.ctorParameters=[{type:NgZone},{type:Console},{type:Injector},{type:ErrorHandler},{type:ComponentFactoryResolver},{type:ApplicationInitStatus},{type:TestabilityRegistry,decorators:[{type:Optional}]},{type:Testability,decorators:[{type:Optional}]}],ApplicationRef_}(ApplicationRef),__extends$9=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},NgModuleRef=function(){function NgModuleRef(){}return Object.defineProperty(NgModuleRef.prototype,"injector",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(NgModuleRef.prototype,"componentFactoryResolver",{
get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(NgModuleRef.prototype,"instance",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),NgModuleRef}(),NgModuleFactory=function(){function NgModuleFactory(_injectorClass,_moduleType){this._injectorClass=_injectorClass,this._moduleType=_moduleType}return Object.defineProperty(NgModuleFactory.prototype,"moduleType",{get:function(){return this._moduleType},enumerable:!0,configurable:!0}),NgModuleFactory.prototype.create=function(parentInjector){parentInjector||(parentInjector=Injector.NULL);var instance=new this._injectorClass(parentInjector);return instance.create(),instance},NgModuleFactory}(),_UNDEFINED=new Object,NgModuleInjector=function(_super){function NgModuleInjector(parent,factories,bootstrapFactories){_super.call(this,factories,parent.get(ComponentFactoryResolver,ComponentFactoryResolver.NULL)),this.parent=parent,this.bootstrapFactories=bootstrapFactories,this._destroyListeners=[],this._destroyed=!1}return __extends$9(NgModuleInjector,_super),NgModuleInjector.prototype.create=function(){this.instance=this.createInternal()},NgModuleInjector.prototype.get=function(token,notFoundValue){if(void 0===notFoundValue&&(notFoundValue=THROW_IF_NOT_FOUND),token===Injector||token===ComponentFactoryResolver)return this;var result=this.getInternal(token,_UNDEFINED);return result===_UNDEFINED?this.parent.get(token,notFoundValue):result},Object.defineProperty(NgModuleInjector.prototype,"injector",{get:function(){return this},enumerable:!0,configurable:!0}),Object.defineProperty(NgModuleInjector.prototype,"componentFactoryResolver",{get:function(){return this},enumerable:!0,configurable:!0}),NgModuleInjector.prototype.destroy=function(){if(this._destroyed)throw new Error("The ng module "+stringify(this.instance.constructor)+" has already been destroyed.");this._destroyed=!0,this.destroyInternal(),this._destroyListeners.forEach(function(listener){return listener()})},NgModuleInjector.prototype.onDestroy=function(callback){this._destroyListeners.push(callback)},NgModuleInjector}(CodegenComponentFactoryResolver),NgModuleFactoryLoader=function(){function NgModuleFactoryLoader(){}return NgModuleFactoryLoader}(),moduleFactories=new Map,QueryList=function(){function QueryList(){this._dirty=!0,this._results=[],this._emitter=new EventEmitter}return Object.defineProperty(QueryList.prototype,"changes",{get:function(){return this._emitter},enumerable:!0,configurable:!0}),Object.defineProperty(QueryList.prototype,"length",{get:function(){return this._results.length},enumerable:!0,configurable:!0}),Object.defineProperty(QueryList.prototype,"first",{get:function(){return this._results[0]},enumerable:!0,configurable:!0}),Object.defineProperty(QueryList.prototype,"last",{get:function(){return this._results[this.length-1]},enumerable:!0,configurable:!0}),QueryList.prototype.map=function(fn){return this._results.map(fn)},QueryList.prototype.filter=function(fn){return this._results.filter(fn)},QueryList.prototype.reduce=function(fn,init){return this._results.reduce(fn,init)},QueryList.prototype.forEach=function(fn){this._results.forEach(fn)},QueryList.prototype.some=function(fn){return this._results.some(fn)},QueryList.prototype.toArray=function(){return this._results.slice()},QueryList.prototype[getSymbolIterator()]=function(){return this._results[getSymbolIterator()]()},QueryList.prototype.toString=function(){return this._results.toString()},QueryList.prototype.reset=function(res){this._results=ListWrapper.flatten(res),this._dirty=!1},QueryList.prototype.notifyOnChanges=function(){this._emitter.emit(this)},QueryList.prototype.setDirty=function(){this._dirty=!0},Object.defineProperty(QueryList.prototype,"dirty",{get:function(){return this._dirty},enumerable:!0,configurable:!0}),QueryList}(),_SEPARATOR="#",FACTORY_CLASS_SUFFIX="NgFactory",SystemJsNgModuleLoaderConfig=function(){function SystemJsNgModuleLoaderConfig(){}return SystemJsNgModuleLoaderConfig}(),DEFAULT_CONFIG={factoryPathPrefix:"",factoryPathSuffix:".ngfactory"},SystemJsNgModuleLoader=function(){function SystemJsNgModuleLoader(_compiler,config){this._compiler=_compiler,this._config=config||DEFAULT_CONFIG}return SystemJsNgModuleLoader.prototype.load=function(path){var offlineMode=this._compiler instanceof Compiler;return offlineMode?this.loadFactory(path):this.loadAndCompile(path)},SystemJsNgModuleLoader.prototype.loadAndCompile=function(path){var _this=this,_a=path.split(_SEPARATOR),module=_a[0],exportName=_a[1];return void 0===exportName&&(exportName="default"),System.import(module).then(function(module){return module[exportName]}).then(function(type){return checkNotEmpty(type,module,exportName)}).then(function(type){return _this._compiler.compileModuleAsync(type)})},SystemJsNgModuleLoader.prototype.loadFactory=function(path){var _a=path.split(_SEPARATOR),module=_a[0],exportName=_a[1],factoryClassSuffix=FACTORY_CLASS_SUFFIX;return void 0===exportName&&(exportName="default",factoryClassSuffix=""),System.import(this._config.factoryPathPrefix+module+this._config.factoryPathSuffix).then(function(module){return module[exportName+factoryClassSuffix]}).then(function(factory){return checkNotEmpty(factory,module,exportName)})},SystemJsNgModuleLoader.decorators=[{type:Injectable}],SystemJsNgModuleLoader.ctorParameters=[{type:Compiler},{type:SystemJsNgModuleLoaderConfig,decorators:[{type:Optional}]}],SystemJsNgModuleLoader}(),__extends$10=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},TemplateRef=function(){function TemplateRef(){}return Object.defineProperty(TemplateRef.prototype,"elementRef",{get:function(){return null},enumerable:!0,configurable:!0}),TemplateRef}(),TemplateRef_=function(_super){function TemplateRef_(_appElement,_viewFactory){_super.call(this),this._appElement=_appElement,this._viewFactory=_viewFactory}return __extends$10(TemplateRef_,_super),TemplateRef_.prototype.createEmbeddedView=function(context){var view=this._viewFactory(this._appElement.parentView.viewUtils,this._appElement.parentInjector,this._appElement);return view.create(context||{},null,null),view.ref},Object.defineProperty(TemplateRef_.prototype,"elementRef",{get:function(){return this._appElement.elementRef},enumerable:!0,configurable:!0}),TemplateRef_}(TemplateRef),_queuedAnimations=[],__extends$11=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ViewRef=function(){function ViewRef(){}return Object.defineProperty(ViewRef.prototype,"destroyed",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),ViewRef}(),EmbeddedViewRef=function(_super){function EmbeddedViewRef(){_super.apply(this,arguments)}return __extends$11(EmbeddedViewRef,_super),Object.defineProperty(EmbeddedViewRef.prototype,"context",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),Object.defineProperty(EmbeddedViewRef.prototype,"rootNodes",{get:function(){return unimplemented()},enumerable:!0,configurable:!0}),EmbeddedViewRef}(ViewRef),ViewRef_=function(){function ViewRef_(_view){this._view=_view,this._view=_view,this._originalMode=this._view.cdMode}return Object.defineProperty(ViewRef_.prototype,"internalView",{get:function(){return this._view},enumerable:!0,configurable:!0}),Object.defineProperty(ViewRef_.prototype,"rootNodes",{get:function(){return this._view.flatRootNodes},enumerable:!0,configurable:!0}),Object.defineProperty(ViewRef_.prototype,"context",{get:function(){return this._view.context},enumerable:!0,configurable:!0}),Object.defineProperty(ViewRef_.prototype,"destroyed",{get:function(){return this._view.destroyed},enumerable:!0,configurable:!0}),ViewRef_.prototype.markForCheck=function(){this._view.markPathToRootAsCheckOnce()},ViewRef_.prototype.detach=function(){this._view.cdMode=ChangeDetectorStatus.Detached},ViewRef_.prototype.detectChanges=function(){this._view.detectChanges(!1),triggerQueuedAnimations()},ViewRef_.prototype.checkNoChanges=function(){this._view.detectChanges(!0)},ViewRef_.prototype.reattach=function(){this._view.cdMode=this._originalMode,this.markForCheck()},ViewRef_.prototype.onDestroy=function(callback){this._view.disposables.push(callback)},ViewRef_.prototype.destroy=function(){this._view.destroy()},ViewRef_}(),__extends$12=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},EventListener=function(){function EventListener(name,callback){this.name=name,this.callback=callback}return EventListener}(),DebugNode=function(){function DebugNode(nativeNode,parent,_debugInfo){this._debugInfo=_debugInfo,this.nativeNode=nativeNode,isPresent(parent)&&parent instanceof DebugElement?parent.addChild(this):this.parent=null,this.listeners=[]}return Object.defineProperty(DebugNode.prototype,"injector",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.injector:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugNode.prototype,"componentInstance",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.component:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugNode.prototype,"context",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.context:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugNode.prototype,"references",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.references:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugNode.prototype,"providerTokens",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.providerTokens:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugNode.prototype,"source",{get:function(){return isPresent(this._debugInfo)?this._debugInfo.source:null},enumerable:!0,configurable:!0}),DebugNode}(),DebugElement=function(_super){function DebugElement(nativeNode,parent,_debugInfo){_super.call(this,nativeNode,parent,_debugInfo),this.properties={},this.attributes={},this.classes={},this.styles={},this.childNodes=[],this.nativeElement=nativeNode}return __extends$12(DebugElement,_super),DebugElement.prototype.addChild=function(child){isPresent(child)&&(this.childNodes.push(child),child.parent=this)},DebugElement.prototype.removeChild=function(child){var childIndex=this.childNodes.indexOf(child);childIndex!==-1&&(child.parent=null,this.childNodes.splice(childIndex,1))},DebugElement.prototype.insertChildrenAfter=function(child,newChildren){var siblingIndex=this.childNodes.indexOf(child);if(siblingIndex!==-1){var previousChildren=this.childNodes.slice(0,siblingIndex+1),nextChildren=this.childNodes.slice(siblingIndex+1);this.childNodes=ListWrapper.concat(ListWrapper.concat(previousChildren,newChildren),nextChildren);for(var i=0;i<newChildren.length;++i){var newChild=newChildren[i];isPresent(newChild.parent)&&newChild.parent.removeChild(newChild),newChild.parent=this}}},DebugElement.prototype.query=function(predicate){var results=this.queryAll(predicate);return results.length>0?results[0]:null},DebugElement.prototype.queryAll=function(predicate){var matches=[];return _queryElementChildren(this,predicate,matches),matches},DebugElement.prototype.queryAllNodes=function(predicate){var matches=[];return _queryNodeChildren(this,predicate,matches),matches},Object.defineProperty(DebugElement.prototype,"children",{get:function(){var children=[];return this.childNodes.forEach(function(node){node instanceof DebugElement&&children.push(node)}),children},enumerable:!0,configurable:!0}),DebugElement.prototype.triggerEventHandler=function(eventName,eventObj){this.listeners.forEach(function(listener){listener.name==eventName&&listener.callback(eventObj)})},DebugElement}(DebugNode),_nativeNodeToDebugNode=new Map,_CORE_PLATFORM_PROVIDERS=[PlatformRef_,{provide:PlatformRef,useExisting:PlatformRef_},{provide:Reflector,useFactory:_reflector,deps:[]},{provide:ReflectorReader,useExisting:Reflector},TestabilityRegistry,Console],platformCore=createPlatformFactory(null,"core",_CORE_PLATFORM_PROVIDERS),LOCALE_ID=new OpaqueToken("LocaleId"),TRANSLATIONS=new OpaqueToken("Translations"),TRANSLATIONS_FORMAT=new OpaqueToken("TranslationsFormat"),ApplicationModule=function(){function ApplicationModule(){}return ApplicationModule.decorators=[{type:NgModule,args:[{providers:[ApplicationRef_,{provide:ApplicationRef,useExisting:ApplicationRef_},ApplicationInitStatus,Compiler,APP_ID_RANDOM_PROVIDER,ViewUtils,{provide:IterableDiffers,useFactory:_iterableDiffersFactory},{provide:KeyValueDiffers,useFactory:_keyValueDiffersFactory},{provide:LOCALE_ID,useValue:"en-US"}]}]}],ApplicationModule.ctorParameters=[],ApplicationModule}(),FILL_STYLE_FLAG="true",ANY_STATE="*",DEFAULT_STATE="*",EMPTY_STATE="void",Math$1=global$1.Math,AnimationGroupPlayer=function(){function AnimationGroupPlayer(_players){var _this=this;this._players=_players,this._onDoneFns=[],this._onStartFns=[],this._finished=!1,this._started=!1,this.parentPlayer=null;var count=0,total=this._players.length;0==total?scheduleMicroTask(function(){return _this._onFinish()}):this._players.forEach(function(player){player.parentPlayer=_this,player.onDone(function(){++count>=total&&_this._onFinish()})})}return AnimationGroupPlayer.prototype._onFinish=function(){this._finished||(this._finished=!0,isPresent(this.parentPlayer)||this.destroy(),this._onDoneFns.forEach(function(fn){return fn()}),this._onDoneFns=[])},AnimationGroupPlayer.prototype.init=function(){this._players.forEach(function(player){return player.init()})},AnimationGroupPlayer.prototype.onStart=function(fn){this._onStartFns.push(fn)},AnimationGroupPlayer.prototype.onDone=function(fn){this._onDoneFns.push(fn)},AnimationGroupPlayer.prototype.hasStarted=function(){return this._started},AnimationGroupPlayer.prototype.play=function(){isPresent(this.parentPlayer)||this.init(),this.hasStarted()||(this._onStartFns.forEach(function(fn){return fn()}),this._onStartFns=[],this._started=!0),this._players.forEach(function(player){return player.play()})},AnimationGroupPlayer.prototype.pause=function(){this._players.forEach(function(player){return player.pause()})},AnimationGroupPlayer.prototype.restart=function(){this._players.forEach(function(player){return player.restart()})},AnimationGroupPlayer.prototype.finish=function(){this._onFinish(),this._players.forEach(function(player){return player.finish()})},AnimationGroupPlayer.prototype.destroy=function(){this._onFinish(),this._players.forEach(function(player){return player.destroy()})},AnimationGroupPlayer.prototype.reset=function(){this._players.forEach(function(player){return player.reset()})},AnimationGroupPlayer.prototype.setPosition=function(p){this._players.forEach(function(player){player.setPosition(p)})},AnimationGroupPlayer.prototype.getPosition=function(){var min=0;return this._players.forEach(function(player){var p=player.getPosition();min=Math$1.min(p,min)}),min},AnimationGroupPlayer}(),AnimationKeyframe=function(){function AnimationKeyframe(offset,styles){this.offset=offset,this.styles=styles}return AnimationKeyframe}(),AnimationOutput=function(){function AnimationOutput(name,phase,fullPropertyName){this.name=name,this.phase=phase,this.fullPropertyName=fullPropertyName}return AnimationOutput}(),AnimationPlayer=function(){function AnimationPlayer(){}return Object.defineProperty(AnimationPlayer.prototype,"parentPlayer",{get:function(){throw new Error("NOT IMPLEMENTED: Base Class")},set:function(player){throw new Error("NOT IMPLEMENTED: Base Class")},enumerable:!0,configurable:!0}),AnimationPlayer}(),NoOpAnimationPlayer=function(){function NoOpAnimationPlayer(){var _this=this;this._onDoneFns=[],this._onStartFns=[],this._started=!1,this.parentPlayer=null,scheduleMicroTask(function(){return _this._onFinish()})}return NoOpAnimationPlayer.prototype._onFinish=function(){this._onDoneFns.forEach(function(fn){return fn()}),this._onDoneFns=[]},NoOpAnimationPlayer.prototype.onStart=function(fn){this._onStartFns.push(fn)},NoOpAnimationPlayer.prototype.onDone=function(fn){this._onDoneFns.push(fn)},NoOpAnimationPlayer.prototype.hasStarted=function(){return this._started},NoOpAnimationPlayer.prototype.init=function(){},NoOpAnimationPlayer.prototype.play=function(){this.hasStarted()||(this._onStartFns.forEach(function(fn){return fn()}),this._onStartFns=[]),this._started=!0},NoOpAnimationPlayer.prototype.pause=function(){},NoOpAnimationPlayer.prototype.restart=function(){},NoOpAnimationPlayer.prototype.finish=function(){this._onFinish()},NoOpAnimationPlayer.prototype.destroy=function(){},NoOpAnimationPlayer.prototype.reset=function(){},NoOpAnimationPlayer.prototype.setPosition=function(p){},NoOpAnimationPlayer.prototype.getPosition=function(){return 0},NoOpAnimationPlayer}(),AnimationSequencePlayer=function(){function AnimationSequencePlayer(_players){var _this=this;this._players=_players,this._currentIndex=0,this._onDoneFns=[],this._onStartFns=[],this._finished=!1,this._started=!1,this.parentPlayer=null,this._players.forEach(function(player){player.parentPlayer=_this}),this._onNext(!1)}return AnimationSequencePlayer.prototype._onNext=function(start){var _this=this;if(!this._finished)if(0==this._players.length)this._activePlayer=new NoOpAnimationPlayer,scheduleMicroTask(function(){return _this._onFinish()});else if(this._currentIndex>=this._players.length)this._activePlayer=new NoOpAnimationPlayer,this._onFinish();else{var player=this._players[this._currentIndex++];player.onDone(function(){return _this._onNext(!0)}),this._activePlayer=player,start&&player.play()}},AnimationSequencePlayer.prototype._onFinish=function(){this._finished||(this._finished=!0,isPresent(this.parentPlayer)||this.destroy(),this._onDoneFns.forEach(function(fn){return fn()}),this._onDoneFns=[])},AnimationSequencePlayer.prototype.init=function(){this._players.forEach(function(player){return player.init()})},AnimationSequencePlayer.prototype.onStart=function(fn){this._onStartFns.push(fn)},AnimationSequencePlayer.prototype.onDone=function(fn){this._onDoneFns.push(fn)},AnimationSequencePlayer.prototype.hasStarted=function(){return this._started},AnimationSequencePlayer.prototype.play=function(){isPresent(this.parentPlayer)||this.init(),this.hasStarted()||(this._onStartFns.forEach(function(fn){return fn()}),this._onStartFns=[],this._started=!0),this._activePlayer.play()},AnimationSequencePlayer.prototype.pause=function(){this._activePlayer.pause()},AnimationSequencePlayer.prototype.restart=function(){this._players.length>0&&(this.reset(),this._players[0].restart())},AnimationSequencePlayer.prototype.reset=function(){this._players.forEach(function(player){return player.reset()})},AnimationSequencePlayer.prototype.finish=function(){this._onFinish(),this._players.forEach(function(player){return player.finish()})},AnimationSequencePlayer.prototype.destroy=function(){this._onFinish(),this._players.forEach(function(player){return player.destroy()})},AnimationSequencePlayer.prototype.setPosition=function(p){this._players[0].setPosition(p)},AnimationSequencePlayer.prototype.getPosition=function(){return this._players[0].getPosition()},AnimationSequencePlayer}(),__extends$13=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},AUTO_STYLE="*",AnimationEntryMetadata=function(){function AnimationEntryMetadata(name,definitions){this.name=name,this.definitions=definitions}return AnimationEntryMetadata}(),AnimationStateMetadata=function(){function AnimationStateMetadata(){}return AnimationStateMetadata}(),AnimationStateDeclarationMetadata=function(_super){function AnimationStateDeclarationMetadata(stateNameExpr,styles){_super.call(this),this.stateNameExpr=stateNameExpr,this.styles=styles}return __extends$13(AnimationStateDeclarationMetadata,_super),AnimationStateDeclarationMetadata}(AnimationStateMetadata),AnimationStateTransitionMetadata=function(_super){function AnimationStateTransitionMetadata(stateChangeExpr,steps){_super.call(this),this.stateChangeExpr=stateChangeExpr,this.steps=steps}return __extends$13(AnimationStateTransitionMetadata,_super),AnimationStateTransitionMetadata}(AnimationStateMetadata),AnimationMetadata=function(){function AnimationMetadata(){}return AnimationMetadata}(),AnimationKeyframesSequenceMetadata=function(_super){function AnimationKeyframesSequenceMetadata(steps){_super.call(this),this.steps=steps}return __extends$13(AnimationKeyframesSequenceMetadata,_super),AnimationKeyframesSequenceMetadata}(AnimationMetadata),AnimationStyleMetadata=function(_super){function AnimationStyleMetadata(styles,offset){void 0===offset&&(offset=null),_super.call(this),this.styles=styles,this.offset=offset}return __extends$13(AnimationStyleMetadata,_super),AnimationStyleMetadata}(AnimationMetadata),AnimationAnimateMetadata=function(_super){function AnimationAnimateMetadata(timings,styles){_super.call(this),this.timings=timings,this.styles=styles}return __extends$13(AnimationAnimateMetadata,_super),AnimationAnimateMetadata}(AnimationMetadata),AnimationWithStepsMetadata=function(_super){function AnimationWithStepsMetadata(){_super.call(this)}return __extends$13(AnimationWithStepsMetadata,_super),Object.defineProperty(AnimationWithStepsMetadata.prototype,"steps",{get:function(){throw new Error("NOT IMPLEMENTED: Base Class")},enumerable:!0,configurable:!0}),AnimationWithStepsMetadata}(AnimationMetadata),AnimationSequenceMetadata=function(_super){function AnimationSequenceMetadata(_steps){_super.call(this),this._steps=_steps}return __extends$13(AnimationSequenceMetadata,_super),Object.defineProperty(AnimationSequenceMetadata.prototype,"steps",{get:function(){return this._steps},enumerable:!0,configurable:!0}),AnimationSequenceMetadata}(AnimationWithStepsMetadata),AnimationGroupMetadata=function(_super){function AnimationGroupMetadata(_steps){_super.call(this),this._steps=_steps}return __extends$13(AnimationGroupMetadata,_super),Object.defineProperty(AnimationGroupMetadata.prototype,"steps",{get:function(){return this._steps},enumerable:!0,configurable:!0}),AnimationGroupMetadata}(AnimationWithStepsMetadata),AnimationStyles=function(){function AnimationStyles(styles){this.styles=styles}return AnimationStyles}(),DebugDomRootRenderer=function(){function DebugDomRootRenderer(_delegate){this._delegate=_delegate}return DebugDomRootRenderer.prototype.renderComponent=function(componentProto){return new DebugDomRenderer(this._delegate.renderComponent(componentProto))},DebugDomRootRenderer}(),DebugDomRenderer=function(){function DebugDomRenderer(_delegate){this._delegate=_delegate}return DebugDomRenderer.prototype.selectRootElement=function(selectorOrNode,debugInfo){var nativeEl=this._delegate.selectRootElement(selectorOrNode,debugInfo),debugEl=new DebugElement(nativeEl,null,debugInfo);return indexDebugNode(debugEl),nativeEl},DebugDomRenderer.prototype.createElement=function(parentElement,name,debugInfo){var nativeEl=this._delegate.createElement(parentElement,name,debugInfo),debugEl=new DebugElement(nativeEl,getDebugNode(parentElement),debugInfo);return debugEl.name=name,indexDebugNode(debugEl),nativeEl},DebugDomRenderer.prototype.createViewRoot=function(hostElement){return this._delegate.createViewRoot(hostElement)},DebugDomRenderer.prototype.createTemplateAnchor=function(parentElement,debugInfo){var comment=this._delegate.createTemplateAnchor(parentElement,debugInfo),debugEl=new DebugNode(comment,getDebugNode(parentElement),debugInfo);return indexDebugNode(debugEl),comment},DebugDomRenderer.prototype.createText=function(parentElement,value,debugInfo){var text=this._delegate.createText(parentElement,value,debugInfo),debugEl=new DebugNode(text,getDebugNode(parentElement),debugInfo);return indexDebugNode(debugEl),text},DebugDomRenderer.prototype.projectNodes=function(parentElement,nodes){var debugParent=getDebugNode(parentElement);if(isPresent(debugParent)&&debugParent instanceof DebugElement){var debugElement_1=debugParent;nodes.forEach(function(node){debugElement_1.addChild(getDebugNode(node))})}this._delegate.projectNodes(parentElement,nodes)},DebugDomRenderer.prototype.attachViewAfter=function(node,viewRootNodes){var debugNode=getDebugNode(node);if(isPresent(debugNode)){var debugParent=debugNode.parent;if(viewRootNodes.length>0&&isPresent(debugParent)){var debugViewRootNodes=[];viewRootNodes.forEach(function(rootNode){return debugViewRootNodes.push(getDebugNode(rootNode))}),debugParent.insertChildrenAfter(debugNode,debugViewRootNodes)}}this._delegate.attachViewAfter(node,viewRootNodes)},DebugDomRenderer.prototype.detachView=function(viewRootNodes){viewRootNodes.forEach(function(node){var debugNode=getDebugNode(node);isPresent(debugNode)&&isPresent(debugNode.parent)&&debugNode.parent.removeChild(debugNode)}),this._delegate.detachView(viewRootNodes)},DebugDomRenderer.prototype.destroyView=function(hostElement,viewAllNodes){viewAllNodes.forEach(function(node){removeDebugNodeFromIndex(getDebugNode(node))}),this._delegate.destroyView(hostElement,viewAllNodes)},DebugDomRenderer.prototype.listen=function(renderElement,name,callback){var debugEl=getDebugNode(renderElement);return isPresent(debugEl)&&debugEl.listeners.push(new EventListener(name,callback)),this._delegate.listen(renderElement,name,callback)},DebugDomRenderer.prototype.listenGlobal=function(target,name,callback){return this._delegate.listenGlobal(target,name,callback)},DebugDomRenderer.prototype.setElementProperty=function(renderElement,propertyName,propertyValue){var debugEl=getDebugNode(renderElement);isPresent(debugEl)&&debugEl instanceof DebugElement&&(debugEl.properties[propertyName]=propertyValue),this._delegate.setElementProperty(renderElement,propertyName,propertyValue)},DebugDomRenderer.prototype.setElementAttribute=function(renderElement,attributeName,attributeValue){var debugEl=getDebugNode(renderElement);isPresent(debugEl)&&debugEl instanceof DebugElement&&(debugEl.attributes[attributeName]=attributeValue),this._delegate.setElementAttribute(renderElement,attributeName,attributeValue)},DebugDomRenderer.prototype.setBindingDebugInfo=function(renderElement,propertyName,propertyValue){this._delegate.setBindingDebugInfo(renderElement,propertyName,propertyValue)},DebugDomRenderer.prototype.setElementClass=function(renderElement,className,isAdd){var debugEl=getDebugNode(renderElement);isPresent(debugEl)&&debugEl instanceof DebugElement&&(debugEl.classes[className]=isAdd),this._delegate.setElementClass(renderElement,className,isAdd)},DebugDomRenderer.prototype.setElementStyle=function(renderElement,styleName,styleValue){var debugEl=getDebugNode(renderElement);isPresent(debugEl)&&debugEl instanceof DebugElement&&(debugEl.styles[styleName]=styleValue),this._delegate.setElementStyle(renderElement,styleName,styleValue)},DebugDomRenderer.prototype.invokeElementMethod=function(renderElement,methodName,args){this._delegate.invokeElementMethod(renderElement,methodName,args)},DebugDomRenderer.prototype.setText=function(renderNode,text){this._delegate.setText(renderNode,text)},DebugDomRenderer.prototype.animate=function(element,startingStyles,keyframes,duration,delay,easing){return this._delegate.animate(element,startingStyles,keyframes,duration,delay,easing)},DebugDomRenderer}(),StaticNodeDebugInfo=function(){function StaticNodeDebugInfo(providerTokens,componentToken,refTokens){this.providerTokens=providerTokens,this.componentToken=componentToken,this.refTokens=refTokens}return StaticNodeDebugInfo}(),DebugContext=function(){function DebugContext(_view,_nodeIndex,_tplRow,_tplCol){this._view=_view,this._nodeIndex=_nodeIndex,this._tplRow=_tplRow,this._tplCol=_tplCol}return Object.defineProperty(DebugContext.prototype,"_staticNodeInfo",{get:function(){return isPresent(this._nodeIndex)?this._view.staticNodeDebugInfos[this._nodeIndex]:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"context",{get:function(){return this._view.context},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"component",{get:function(){var staticNodeInfo=this._staticNodeInfo;return isPresent(staticNodeInfo)&&isPresent(staticNodeInfo.componentToken)?this.injector.get(staticNodeInfo.componentToken):null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"componentRenderElement",{get:function(){for(var componentView=this._view;isPresent(componentView.declarationAppElement)&&componentView.type!==ViewType.COMPONENT;)componentView=componentView.declarationAppElement.parentView;return isPresent(componentView.declarationAppElement)?componentView.declarationAppElement.nativeElement:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"injector",{get:function(){return this._view.injector(this._nodeIndex)},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"renderNode",{get:function(){return isPresent(this._nodeIndex)&&this._view.allNodes?this._view.allNodes[this._nodeIndex]:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"providerTokens",{get:function(){var staticNodeInfo=this._staticNodeInfo;return isPresent(staticNodeInfo)?staticNodeInfo.providerTokens:null},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"source",{get:function(){return this._view.componentType.templateUrl+":"+this._tplRow+":"+this._tplCol},enumerable:!0,configurable:!0}),Object.defineProperty(DebugContext.prototype,"references",{get:function(){var _this=this,varValues={},staticNodeInfo=this._staticNodeInfo;if(isPresent(staticNodeInfo)){var refs=staticNodeInfo.refTokens;StringMapWrapper.forEach(refs,function(refToken,refName){var varValue;varValue=isBlank(refToken)?_this._view.allNodes?_this._view.allNodes[_this._nodeIndex]:null:_this._view.injectorGet(refToken,_this._nodeIndex,null),varValues[refName]=varValue})}return varValues},enumerable:!0,configurable:!0}),DebugContext}(),AnimationTransitionEvent=function(){function AnimationTransitionEvent(_a){var fromState=_a.fromState,toState=_a.toState,totalTime=_a.totalTime;this.fromState=fromState,this.toState=toState,this.totalTime=totalTime}return AnimationTransitionEvent}(),ViewAnimationMap=function(){function ViewAnimationMap(){this._map=new Map,this._allPlayers=[]}return Object.defineProperty(ViewAnimationMap.prototype,"length",{get:function(){return this.getAllPlayers().length},enumerable:!0,configurable:!0}),ViewAnimationMap.prototype.find=function(element,animationName){var playersByAnimation=this._map.get(element);if(isPresent(playersByAnimation))return playersByAnimation[animationName]},ViewAnimationMap.prototype.findAllPlayersByElement=function(element){var el=this._map.get(element);return el?StringMapWrapper.values(el):[]},ViewAnimationMap.prototype.set=function(element,animationName,player){var playersByAnimation=this._map.get(element);isPresent(playersByAnimation)||(playersByAnimation={});var existingEntry=playersByAnimation[animationName];isPresent(existingEntry)&&this.remove(element,animationName),playersByAnimation[animationName]=player,this._allPlayers.push(player),this._map.set(element,playersByAnimation)},ViewAnimationMap.prototype.getAllPlayers=function(){return this._allPlayers},ViewAnimationMap.prototype.remove=function(element,animationName){var playersByAnimation=this._map.get(element);if(playersByAnimation){var player=playersByAnimation[animationName];delete playersByAnimation[animationName];var index=this._allPlayers.indexOf(player);this._allPlayers.splice(index,1),StringMapWrapper.isEmpty(playersByAnimation)&&this._map.delete(element)}},ViewAnimationMap}(),__extends$15=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);
d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_UNDEFINED$1=new Object,ElementInjector=function(_super){function ElementInjector(_view,_nodeIndex){_super.call(this),this._view=_view,this._nodeIndex=_nodeIndex}return __extends$15(ElementInjector,_super),ElementInjector.prototype.get=function(token,notFoundValue){void 0===notFoundValue&&(notFoundValue=THROW_IF_NOT_FOUND);var result=_UNDEFINED$1;return result===_UNDEFINED$1&&(result=this._view.injectorGet(token,this._nodeIndex,_UNDEFINED$1)),result===_UNDEFINED$1&&(result=this._view.parentInjector.get(token,notFoundValue)),result},ElementInjector}(Injector),__extends$14=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_scope_check=wtfCreateScope("AppView#check(ascii id)"),AppView=function(){function AppView(clazz,componentType,type,viewUtils,parentInjector,declarationAppElement,cdMode){this.clazz=clazz,this.componentType=componentType,this.type=type,this.viewUtils=viewUtils,this.parentInjector=parentInjector,this.declarationAppElement=declarationAppElement,this.cdMode=cdMode,this.contentChildren=[],this.viewChildren=[],this.viewContainerElement=null,this.numberOfChecks=0,this.animationPlayers=new ViewAnimationMap,this._animationListeners=new Map,this.ref=new ViewRef_(this),type===ViewType.COMPONENT||type===ViewType.HOST?this.renderer=viewUtils.renderComponent(componentType):this.renderer=declarationAppElement.parentView.renderer}return Object.defineProperty(AppView.prototype,"destroyed",{get:function(){return this.cdMode===ChangeDetectorStatus.Destroyed},enumerable:!0,configurable:!0}),AppView.prototype.cancelActiveAnimation=function(element,animationName,removeAllAnimations){if(void 0===removeAllAnimations&&(removeAllAnimations=!1),removeAllAnimations)this.animationPlayers.findAllPlayersByElement(element).forEach(function(player){return player.destroy()});else{var player=this.animationPlayers.find(element,animationName);isPresent(player)&&player.destroy()}},AppView.prototype.queueAnimation=function(element,animationName,player,totalTime,fromState,toState){var _this=this;queueAnimation(player);var event=new AnimationTransitionEvent({fromState:fromState,toState:toState,totalTime:totalTime});this.animationPlayers.set(element,animationName,player),player.onDone(function(){_this.triggerAnimationOutput(element,animationName,"done",event),_this.animationPlayers.remove(element,animationName)}),player.onStart(function(){_this.triggerAnimationOutput(element,animationName,"start",event)})},AppView.prototype.triggerAnimationOutput=function(element,animationName,phase,event){var listeners=this._animationListeners.get(element);if(isPresent(listeners)&&listeners.length)for(var i=0;i<listeners.length;i++){var listener=listeners[i];if(listener.output.name==animationName&&listener.output.phase==phase){listener.handler(event);break}}},AppView.prototype.registerAnimationOutput=function(element,outputEvent,eventHandler){var entry=new _AnimationOutputWithHandler(outputEvent,eventHandler),animations=this._animationListeners.get(element);isPresent(animations)||this._animationListeners.set(element,animations=[]),animations.push(entry)},AppView.prototype.create=function(context,givenProjectableNodes,rootSelectorOrNode){this.context=context;var projectableNodes;switch(this.type){case ViewType.COMPONENT:projectableNodes=ensureSlotCount(givenProjectableNodes,this.componentType.slotCount);break;case ViewType.EMBEDDED:projectableNodes=this.declarationAppElement.parentView.projectableNodes;break;case ViewType.HOST:projectableNodes=givenProjectableNodes}return this._hasExternalHostElement=isPresent(rootSelectorOrNode),this.projectableNodes=projectableNodes,this.createInternal(rootSelectorOrNode)},AppView.prototype.createInternal=function(rootSelectorOrNode){return null},AppView.prototype.init=function(rootNodesOrAppElements,allNodes,disposables,subscriptions){this.rootNodesOrAppElements=rootNodesOrAppElements,this.allNodes=allNodes,this.disposables=disposables,this.subscriptions=subscriptions,this.type===ViewType.COMPONENT&&(this.declarationAppElement.parentView.viewChildren.push(this),this.dirtyParentQueriesInternal())},AppView.prototype.selectOrCreateHostElement=function(elementName,rootSelectorOrNode,debugInfo){var hostElement;return hostElement=isPresent(rootSelectorOrNode)?this.renderer.selectRootElement(rootSelectorOrNode,debugInfo):this.renderer.createElement(null,elementName,debugInfo)},AppView.prototype.injectorGet=function(token,nodeIndex,notFoundResult){return this.injectorGetInternal(token,nodeIndex,notFoundResult)},AppView.prototype.injectorGetInternal=function(token,nodeIndex,notFoundResult){return notFoundResult},AppView.prototype.injector=function(nodeIndex){return isPresent(nodeIndex)?new ElementInjector(this,nodeIndex):this.parentInjector},AppView.prototype.destroy=function(){this._hasExternalHostElement?this.renderer.detachView(this.flatRootNodes):isPresent(this.viewContainerElement)&&this.viewContainerElement.detachView(this.viewContainerElement.nestedViews.indexOf(this)),this._destroyRecurse()},AppView.prototype._destroyRecurse=function(){if(this.cdMode!==ChangeDetectorStatus.Destroyed){for(var children=this.contentChildren,i=0;i<children.length;i++)children[i]._destroyRecurse();children=this.viewChildren;for(var i=0;i<children.length;i++)children[i]._destroyRecurse();this.destroyLocal(),this.cdMode=ChangeDetectorStatus.Destroyed}},AppView.prototype.destroyLocal=function(){for(var _this=this,hostElement=this.type===ViewType.COMPONENT?this.declarationAppElement.nativeElement:null,i=0;i<this.disposables.length;i++)this.disposables[i]();for(var i=0;i<this.subscriptions.length;i++)this.subscriptions[i].unsubscribe();if(this.destroyInternal(),this.dirtyParentQueriesInternal(),0==this.animationPlayers.length)this.renderer.destroyView(hostElement,this.allNodes);else{var player=new AnimationGroupPlayer(this.animationPlayers.getAllPlayers());player.onDone(function(){_this.renderer.destroyView(hostElement,_this.allNodes)})}},AppView.prototype.destroyInternal=function(){},AppView.prototype.detachInternal=function(){},AppView.prototype.detach=function(){var _this=this;if(this.detachInternal(),0==this.animationPlayers.length)this.renderer.detachView(this.flatRootNodes);else{var player=new AnimationGroupPlayer(this.animationPlayers.getAllPlayers());player.onDone(function(){_this.renderer.detachView(_this.flatRootNodes)})}},Object.defineProperty(AppView.prototype,"changeDetectorRef",{get:function(){return this.ref},enumerable:!0,configurable:!0}),Object.defineProperty(AppView.prototype,"parent",{get:function(){return isPresent(this.declarationAppElement)?this.declarationAppElement.parentView:null},enumerable:!0,configurable:!0}),Object.defineProperty(AppView.prototype,"flatRootNodes",{get:function(){return flattenNestedViewRenderNodes(this.rootNodesOrAppElements)},enumerable:!0,configurable:!0}),Object.defineProperty(AppView.prototype,"lastRootNode",{get:function(){var lastNode=this.rootNodesOrAppElements.length>0?this.rootNodesOrAppElements[this.rootNodesOrAppElements.length-1]:null;return _findLastRenderNode(lastNode)},enumerable:!0,configurable:!0}),AppView.prototype.dirtyParentQueriesInternal=function(){},AppView.prototype.detectChanges=function(throwOnChange){var s=_scope_check(this.clazz);this.cdMode!==ChangeDetectorStatus.Checked&&this.cdMode!==ChangeDetectorStatus.Errored&&(this.cdMode===ChangeDetectorStatus.Destroyed&&this.throwDestroyedError("detectChanges"),this.detectChangesInternal(throwOnChange),this.cdMode===ChangeDetectorStatus.CheckOnce&&(this.cdMode=ChangeDetectorStatus.Checked),this.numberOfChecks++,wtfLeave(s))},AppView.prototype.detectChangesInternal=function(throwOnChange){this.detectContentChildrenChanges(throwOnChange),this.detectViewChildrenChanges(throwOnChange)},AppView.prototype.detectContentChildrenChanges=function(throwOnChange){for(var i=0;i<this.contentChildren.length;++i){var child=this.contentChildren[i];child.cdMode!==ChangeDetectorStatus.Detached&&child.detectChanges(throwOnChange)}},AppView.prototype.detectViewChildrenChanges=function(throwOnChange){for(var i=0;i<this.viewChildren.length;++i){var child=this.viewChildren[i];child.cdMode!==ChangeDetectorStatus.Detached&&child.detectChanges(throwOnChange)}},AppView.prototype.markContentChildAsMoved=function(renderAppElement){this.dirtyParentQueriesInternal()},AppView.prototype.addToContentChildren=function(renderAppElement){renderAppElement.parentView.contentChildren.push(this),this.viewContainerElement=renderAppElement,this.dirtyParentQueriesInternal()},AppView.prototype.removeFromContentChildren=function(renderAppElement){ListWrapper.remove(renderAppElement.parentView.contentChildren,this),this.dirtyParentQueriesInternal(),this.viewContainerElement=null},AppView.prototype.markAsCheckOnce=function(){this.cdMode=ChangeDetectorStatus.CheckOnce},AppView.prototype.markPathToRootAsCheckOnce=function(){for(var c=this;isPresent(c)&&c.cdMode!==ChangeDetectorStatus.Detached;){c.cdMode===ChangeDetectorStatus.Checked&&(c.cdMode=ChangeDetectorStatus.CheckOnce);var parentEl=c.type===ViewType.COMPONENT?c.declarationAppElement:c.viewContainerElement;c=isPresent(parentEl)?parentEl.parentView:null}},AppView.prototype.eventHandler=function(cb){return cb},AppView.prototype.throwDestroyedError=function(details){throw new ViewDestroyedError(details)},AppView}(),DebugAppView=function(_super){function DebugAppView(clazz,componentType,type,viewUtils,parentInjector,declarationAppElement,cdMode,staticNodeDebugInfos){_super.call(this,clazz,componentType,type,viewUtils,parentInjector,declarationAppElement,cdMode),this.staticNodeDebugInfos=staticNodeDebugInfos,this._currentDebugContext=null}return __extends$14(DebugAppView,_super),DebugAppView.prototype.create=function(context,givenProjectableNodes,rootSelectorOrNode){this._resetDebug();try{return _super.prototype.create.call(this,context,givenProjectableNodes,rootSelectorOrNode)}catch(e){throw this._rethrowWithContext(e),e}},DebugAppView.prototype.injectorGet=function(token,nodeIndex,notFoundResult){this._resetDebug();try{return _super.prototype.injectorGet.call(this,token,nodeIndex,notFoundResult)}catch(e){throw this._rethrowWithContext(e),e}},DebugAppView.prototype.detach=function(){this._resetDebug();try{_super.prototype.detach.call(this)}catch(e){throw this._rethrowWithContext(e),e}},DebugAppView.prototype.destroyLocal=function(){this._resetDebug();try{_super.prototype.destroyLocal.call(this)}catch(e){throw this._rethrowWithContext(e),e}},DebugAppView.prototype.detectChanges=function(throwOnChange){this._resetDebug();try{_super.prototype.detectChanges.call(this,throwOnChange)}catch(e){throw this._rethrowWithContext(e),e}},DebugAppView.prototype._resetDebug=function(){this._currentDebugContext=null},DebugAppView.prototype.debug=function(nodeIndex,rowNum,colNum){return this._currentDebugContext=new DebugContext(this,nodeIndex,rowNum,colNum)},DebugAppView.prototype._rethrowWithContext=function(e){if(!(e instanceof ViewWrappedError)&&(e instanceof ExpressionChangedAfterItHasBeenCheckedError||(this.cdMode=ChangeDetectorStatus.Errored),isPresent(this._currentDebugContext)))throw new ViewWrappedError(e,this._currentDebugContext)},DebugAppView.prototype.eventHandler=function(cb){var _this=this,superHandler=_super.prototype.eventHandler.call(this,cb);return function(event){_this._resetDebug();try{return superHandler(event)}catch(e){throw _this._rethrowWithContext(e),e}}},DebugAppView}(AppView),_AnimationOutputWithHandler=function(){function _AnimationOutputWithHandler(output,handler){this.output=output,this.handler=handler}return _AnimationOutputWithHandler}(),__core_private__={isDefaultChangeDetectionStrategy:isDefaultChangeDetectionStrategy,ChangeDetectorStatus:ChangeDetectorStatus,CHANGE_DETECTION_STRATEGY_VALUES:CHANGE_DETECTION_STRATEGY_VALUES,constructDependencies:constructDependencies,LifecycleHooks:LifecycleHooks,LIFECYCLE_HOOKS_VALUES:LIFECYCLE_HOOKS_VALUES,ReflectorReader:ReflectorReader,CodegenComponentFactoryResolver:CodegenComponentFactoryResolver,AppElement:AppElement,AppView:AppView,DebugAppView:DebugAppView,NgModuleInjector:NgModuleInjector,registerModuleFactory:registerModuleFactory,ViewType:ViewType,MAX_INTERPOLATION_VALUES:MAX_INTERPOLATION_VALUES,checkBinding:checkBinding,flattenNestedViewRenderNodes:flattenNestedViewRenderNodes,interpolate:interpolate,ViewUtils:ViewUtils,VIEW_ENCAPSULATION_VALUES:VIEW_ENCAPSULATION_VALUES,ViewMetadata:ViewMetadata,DebugContext:DebugContext,StaticNodeDebugInfo:StaticNodeDebugInfo,devModeEqual:devModeEqual,UNINITIALIZED:UNINITIALIZED,ValueUnwrapper:ValueUnwrapper,RenderDebugInfo:RenderDebugInfo,TemplateRef_:TemplateRef_,ReflectionCapabilities:ReflectionCapabilities,makeDecorator:makeDecorator,DebugDomRootRenderer:DebugDomRootRenderer,EMPTY_ARRAY:EMPTY_ARRAY,EMPTY_MAP:EMPTY_MAP,pureProxy1:pureProxy1,pureProxy2:pureProxy2,pureProxy3:pureProxy3,pureProxy4:pureProxy4,pureProxy5:pureProxy5,pureProxy6:pureProxy6,pureProxy7:pureProxy7,pureProxy8:pureProxy8,pureProxy9:pureProxy9,pureProxy10:pureProxy10,castByValue:castByValue,Console:Console,reflector:reflector,Reflector:Reflector,NoOpAnimationPlayer:NoOpAnimationPlayer,AnimationPlayer:AnimationPlayer,AnimationSequencePlayer:AnimationSequencePlayer,AnimationGroupPlayer:AnimationGroupPlayer,AnimationKeyframe:AnimationKeyframe,prepareFinalAnimationStyles:prepareFinalAnimationStyles,balanceAnimationKeyframes:balanceAnimationKeyframes,flattenStyles:flattenStyles,clearStyles:clearStyles,renderStyles:renderStyles,collectAndResolveStyles:collectAndResolveStyles,AnimationStyles:AnimationStyles,AnimationOutput:AnimationOutput,ANY_STATE:ANY_STATE,DEFAULT_STATE:DEFAULT_STATE,EMPTY_STATE:EMPTY_STATE,FILL_STYLE_FLAG:FILL_STYLE_FLAG,ComponentStillLoadingError:ComponentStillLoadingError,isPromise:isPromise};exports.createPlatform=createPlatform,exports.assertPlatform=assertPlatform,exports.destroyPlatform=destroyPlatform,exports.getPlatform=getPlatform,exports.PlatformRef=PlatformRef,exports.ApplicationRef=ApplicationRef,exports.enableProdMode=enableProdMode,exports.isDevMode=isDevMode,exports.createPlatformFactory=createPlatformFactory,exports.APP_ID=APP_ID,exports.PACKAGE_ROOT_URL=PACKAGE_ROOT_URL,exports.PLATFORM_INITIALIZER=PLATFORM_INITIALIZER,exports.APP_BOOTSTRAP_LISTENER=APP_BOOTSTRAP_LISTENER,exports.APP_INITIALIZER=APP_INITIALIZER,exports.ApplicationInitStatus=ApplicationInitStatus,exports.DebugElement=DebugElement,exports.DebugNode=DebugNode,exports.asNativeElements=asNativeElements,exports.getDebugNode=getDebugNode,exports.Testability=Testability,exports.TestabilityRegistry=TestabilityRegistry,exports.setTestabilityGetter=setTestabilityGetter,exports.TRANSLATIONS=TRANSLATIONS,exports.TRANSLATIONS_FORMAT=TRANSLATIONS_FORMAT,exports.LOCALE_ID=LOCALE_ID,exports.ApplicationModule=ApplicationModule,exports.wtfCreateScope=wtfCreateScope,exports.wtfLeave=wtfLeave,exports.wtfStartTimeRange=wtfStartTimeRange,exports.wtfEndTimeRange=wtfEndTimeRange,exports.Type=Type,exports.EventEmitter=EventEmitter,exports.ErrorHandler=ErrorHandler,exports.AnimationTransitionEvent=AnimationTransitionEvent,exports.AnimationPlayer=AnimationPlayer,exports.Sanitizer=Sanitizer,exports.ANALYZE_FOR_ENTRY_COMPONENTS=ANALYZE_FOR_ENTRY_COMPONENTS,exports.Attribute=Attribute,exports.ContentChild=ContentChild,exports.ContentChildren=ContentChildren,exports.Query=Query,exports.ViewChild=ViewChild,exports.ViewChildren=ViewChildren,exports.Component=Component,exports.Directive=Directive,exports.HostBinding=HostBinding,exports.HostListener=HostListener,exports.Input=Input,exports.Output=Output,exports.Pipe=Pipe,exports.AfterContentChecked=AfterContentChecked,exports.AfterContentInit=AfterContentInit,exports.AfterViewChecked=AfterViewChecked,exports.AfterViewInit=AfterViewInit,exports.DoCheck=DoCheck,exports.OnChanges=OnChanges,exports.OnDestroy=OnDestroy,exports.OnInit=OnInit,exports.CUSTOM_ELEMENTS_SCHEMA=CUSTOM_ELEMENTS_SCHEMA,exports.NO_ERRORS_SCHEMA=NO_ERRORS_SCHEMA,exports.NgModule=NgModule,exports.Class=Class,exports.forwardRef=forwardRef,exports.resolveForwardRef=resolveForwardRef,exports.Injector=Injector,exports.ReflectiveInjector=ReflectiveInjector,exports.ResolvedReflectiveFactory=ResolvedReflectiveFactory,exports.ReflectiveKey=ReflectiveKey,exports.OpaqueToken=OpaqueToken,exports.Inject=Inject,exports.Optional=Optional,exports.Injectable=Injectable,exports.Self=Self,exports.SkipSelf=SkipSelf,exports.Host=Host,exports.NgZone=NgZone,exports.RenderComponentType=RenderComponentType,exports.Renderer=Renderer,exports.RootRenderer=RootRenderer,exports.COMPILER_OPTIONS=COMPILER_OPTIONS,exports.Compiler=Compiler,exports.CompilerFactory=CompilerFactory,exports.ModuleWithComponentFactories=ModuleWithComponentFactories,exports.ComponentFactory=ComponentFactory,exports.ComponentRef=ComponentRef,exports.ComponentFactoryResolver=ComponentFactoryResolver,exports.ElementRef=ElementRef,exports.NgModuleFactory=NgModuleFactory,exports.NgModuleRef=NgModuleRef,exports.NgModuleFactoryLoader=NgModuleFactoryLoader,exports.getModuleFactory=getModuleFactory,exports.QueryList=QueryList,exports.SystemJsNgModuleLoader=SystemJsNgModuleLoader,exports.SystemJsNgModuleLoaderConfig=SystemJsNgModuleLoaderConfig,exports.TemplateRef=TemplateRef,exports.ViewContainerRef=ViewContainerRef,exports.EmbeddedViewRef=EmbeddedViewRef,exports.ViewRef=ViewRef,exports.ChangeDetectorRef=ChangeDetectorRef,exports.CollectionChangeRecord=CollectionChangeRecord,exports.DefaultIterableDiffer=DefaultIterableDiffer,exports.IterableDiffers=IterableDiffers,exports.KeyValueChangeRecord=KeyValueChangeRecord,exports.KeyValueDiffers=KeyValueDiffers,exports.SimpleChange=SimpleChange,exports.WrappedValue=WrappedValue,exports.platformCore=platformCore,exports.__core_private__=__core_private__,exports.AUTO_STYLE=AUTO_STYLE,exports.AnimationEntryMetadata=AnimationEntryMetadata,exports.AnimationStateMetadata=AnimationStateMetadata,exports.AnimationStateDeclarationMetadata=AnimationStateDeclarationMetadata,exports.AnimationStateTransitionMetadata=AnimationStateTransitionMetadata,exports.AnimationMetadata=AnimationMetadata,exports.AnimationKeyframesSequenceMetadata=AnimationKeyframesSequenceMetadata,exports.AnimationStyleMetadata=AnimationStyleMetadata,exports.AnimationAnimateMetadata=AnimationAnimateMetadata,exports.AnimationWithStepsMetadata=AnimationWithStepsMetadata,exports.AnimationSequenceMetadata=AnimationSequenceMetadata,exports.AnimationGroupMetadata=AnimationGroupMetadata,exports.animate=animate,exports.group=group,exports.sequence=sequence,exports.style=style,exports.state=state,exports.keyframes=keyframes,exports.transition=transition,exports.trigger=trigger});
