/**
 * @license Angular v2.0.1
 * (c) 2010-2016 Google, Inc. https://angular.io/
 * License: MIT
 */
!function(global,factory){"object"==typeof exports&&"undefined"!=typeof module?factory(exports,require("@angular/common"),require("@angular/core")):"function"==typeof define&&define.amd?define(["exports","@angular/common","@angular/core"],factory):factory((global.ng=global.ng||{},global.ng.platformBrowser=global.ng.platformBrowser||{}),global.ng.common,global.ng.core)}(this,function(exports,_angular_common,_angular_core){"use strict";function isPresent(obj){return void 0!==obj&&null!==obj}function isBlank(obj){return void 0===obj||null===obj}function isNumber(obj){return"number"==typeof obj}function isString(obj){return"string"==typeof obj}function isFunction(obj){return"function"==typeof obj}function isArray(obj){return Array.isArray(obj)}function stringify(token){if("string"==typeof token)return token;if(void 0===token||null===token)return""+token;if(token.overriddenName)return token.overriddenName;if(token.name)return token.name;var res=token.toString(),newLineIndex=res.indexOf("\n");return newLineIndex===-1?res:res.substring(0,newLineIndex)}function setValueOnPath(global,path,value){for(var parts=path.split("."),obj=global;parts.length>1;){var name=parts.shift();obj=obj.hasOwnProperty(name)&&isPresent(obj[name])?obj[name]:obj[name]={}}void 0!==obj&&null!==obj||(obj={}),obj[parts.shift()]=value}function _flattenArray(source,target){if(isPresent(source))for(var i=0;i<source.length;i++){var item=source[i];isArray(item)?_flattenArray(item,target):target.push(item)}return target}function camelCaseToDashCase(input){return StringWrapper.replaceAllMapped(input,CAMEL_CASE_REGEXP,function(m){return"-"+m[1].toLowerCase()})}function dashCaseToCamelCase(input){return StringWrapper.replaceAllMapped(input,DASH_CASE_REGEXP,function(m){return m[1].toUpperCase()})}function getDOM(){return _DOM}function setRootDomAdapter(adapter){isBlank(_DOM)&&(_DOM=adapter)}function _computeStyle(element,prop){return getDOM().getComputedStyle(element)[prop]}function _populateStyles(element,styles,defaultStyles){var data={};return styles.styles.forEach(function(entry){StringMapWrapper.forEach(entry,function(val,prop){var formattedProp=dashCaseToCamelCase(prop);data[formattedProp]=val==_angular_core.AUTO_STYLE?val:val.toString()+_resolveStyleUnit(val,prop,formattedProp)})}),StringMapWrapper.forEach(defaultStyles,function(value,prop){isPresent(data[prop])||(data[prop]=value)}),data}function _resolveStyleUnit(val,userProvidedProp,formattedProp){var unit="";if(_isPixelDimensionStyle(formattedProp)&&0!=val&&"0"!=val)if(isNumber(val))unit="px";else if(0==_findDimensionalSuffix(val.toString()).length)throw new Error("Please provide a CSS unit value for "+userProvidedProp+":"+val);return unit}function _findDimensionalSuffix(value){for(var i=0;i<value.length;i++){var c=StringWrapper.charCodeAt(value,i);if(!(c>=_$0&&c<=_$9||c==_$PERIOD))return value.substring(i,value.length)}return""}function _isPixelDimensionStyle(prop){switch(prop){case"width":case"height":case"minWidth":case"minHeight":case"maxWidth":case"maxHeight":case"left":case"top":case"bottom":case"right":case"fontSize":case"outlineWidth":case"outlineOffset":case"paddingTop":case"paddingLeft":case"paddingBottom":case"paddingRight":case"marginTop":case"marginLeft":case"marginBottom":case"marginRight":case"borderRadius":case"borderWidth":case"borderTopWidth":case"borderLeftWidth":case"borderRightWidth":case"borderBottomWidth":case"textIndent":return!0;default:return!1}}function getBaseElementHref(){return isBlank(baseElement)&&(baseElement=document.querySelector("base"),isBlank(baseElement))?null:baseElement.getAttribute("href")}function relativePath(url){return isBlank(urlParsingNode)&&(urlParsingNode=document.createElement("a")),urlParsingNode.setAttribute("href",url),"/"===urlParsingNode.pathname.charAt(0)?urlParsingNode.pathname:"/"+urlParsingNode.pathname}function parseCookieValue(cookieStr,name){name=encodeURIComponent(name);for(var _i=0,_a=cookieStr.split(";");_i<_a.length;_i++){var cookie=_a[_i],eqIndex=cookie.indexOf("="),_b=eqIndex==-1?[cookie,""]:[cookie.slice(0,eqIndex),cookie.slice(eqIndex+1)],cookieName=_b[0],cookieValue=_b[1];if(cookieName.trim()===name)return decodeURIComponent(cookieValue)}return null}/**
     * @license
     * Copyright Google Inc. All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
function supportsState(){return!!window.history.pushState}function moveNodesAfterSibling(sibling,nodes){var parent=getDOM().parentElement(sibling);if(nodes.length>0&&isPresent(parent)){var nextSibling=getDOM().nextSibling(sibling);if(isPresent(nextSibling))for(var i=0;i<nodes.length;i++)getDOM().insertBefore(nextSibling,nodes[i]);else for(var i=0;i<nodes.length;i++)getDOM().appendChild(parent,nodes[i])}}function appendNodes(parent,nodes){for(var i=0;i<nodes.length;i++)getDOM().appendChild(parent,nodes[i])}function decoratePreventDefault(eventHandler){return function(event){var allowDefaultBehavior=eventHandler(event);allowDefaultBehavior===!1&&getDOM().preventDefault(event)}}function _shimContentAttribute(componentShortId){return StringWrapper.replaceAll(CONTENT_ATTR,COMPONENT_REGEX,componentShortId)}function _shimHostAttribute(componentShortId){return StringWrapper.replaceAll(HOST_ATTR,COMPONENT_REGEX,componentShortId)}function _flattenStyles(compId,styles,target){for(var i=0;i<styles.length;i++){var style=styles[i];isArray(style)?_flattenStyles(compId,style,target):(style=StringWrapper.replaceAll(style,COMPONENT_REGEX,compId),target.push(style))}return target}function splitNamespace(name){if(":"!=name[0])return[null,name];var match=name.match(NS_PREFIX_RE);return[match[1],match[2]]}function inspectNativeElement(element){return _angular_core.getDebugNode(element)}function _createConditionalRootRenderer(rootRenderer,extraTokens){return _angular_core.isDevMode()?_createRootRenderer(rootRenderer,extraTokens):rootRenderer}function _createRootRenderer(rootRenderer,extraTokens){return getDOM().setGlobalVar(INSPECT_GLOBAL_NAME,inspectNativeElement),getDOM().setGlobalVar(CORE_TOKENS_GLOBAL_NAME,StringMapWrapper.merge(CORE_TOKENS,_ngProbeTokensToMap(extraTokens||[]))),new DebugDomRootRenderer(rootRenderer)}function _ngProbeTokensToMap(tokens){return tokens.reduce(function(prev,t){return prev[t.name]=t.token,prev},{})}function sanitizeUrl(url){return url=String(url),url.match(SAFE_URL_PATTERN)||url.match(DATA_URL_PATTERN)?url:(_angular_core.isDevMode()&&getDOM().log("WARNING: sanitizing unsafe URL value "+url+" (see http://g.co/ng/security#xss)"),"unsafe:"+url)}function sanitizeSrcset(srcset){return srcset=String(srcset),srcset.split(",").map(function(srcset){return sanitizeUrl(srcset.trim())}).join(", ")}function getInertElement(){if(inertElement)return inertElement;DOM=getDOM();var templateEl=DOM.createElement("template");if("content"in templateEl)return templateEl;var doc=DOM.createHtmlDocument();if(inertElement=DOM.querySelector(doc,"body"),null==inertElement){var html=DOM.createElement("html",doc);inertElement=DOM.createElement("body",doc),DOM.appendChild(html,inertElement),DOM.appendChild(doc,html)}return inertElement}function tagSet(tags){for(var res={},_i=0,_a=tags.split(",");_i<_a.length;_i++){var t=_a[_i];res[t]=!0}return res}function merge(){for(var sets=[],_i=0;_i<arguments.length;_i++)sets[_i-0]=arguments[_i];for(var res={},_a=0,sets_1=sets;_a<sets_1.length;_a++){var s=sets_1[_a];for(var v in s)s.hasOwnProperty(v)&&(res[v]=!0)}return res}function encodeEntities(value){return value.replace(/&/g,"&amp;").replace(SURROGATE_PAIR_REGEXP,function(match){var hi=match.charCodeAt(0),low=match.charCodeAt(1);return"&#"+(1024*(hi-55296)+(low-56320)+65536)+";"}).replace(NON_ALPHANUMERIC_REGEXP,function(match){return"&#"+match.charCodeAt(0)+";"}).replace(/</g,"&lt;").replace(/>/g,"&gt;")}function stripCustomNsAttrs(el){DOM.attributeMap(el).forEach(function(_,attrName){"xmlns:ns1"!==attrName&&0!==attrName.indexOf("ns1:")||DOM.removeAttribute(el,attrName)});for(var _i=0,_a=DOM.childNodesAsList(el);_i<_a.length;_i++){var n=_a[_i];DOM.isElementNode(n)&&stripCustomNsAttrs(n)}}function sanitizeHtml(unsafeHtmlInput){try{var containerEl=getInertElement(),unsafeHtml=unsafeHtmlInput?String(unsafeHtmlInput):"",mXSSAttempts=5,parsedHtml=unsafeHtml;do{if(0===mXSSAttempts)throw new Error("Failed to sanitize html because the input is unstable");mXSSAttempts--,unsafeHtml=parsedHtml,DOM.setInnerHTML(containerEl,unsafeHtml),DOM.defaultDoc().documentMode&&stripCustomNsAttrs(containerEl),parsedHtml=DOM.getInnerHTML(containerEl)}while(unsafeHtml!==parsedHtml);for(var sanitizer=new SanitizingHtmlSerializer,safeHtml=sanitizer.sanitizeChildren(DOM.getTemplateContent(containerEl)||containerEl),parent_1=DOM.getTemplateContent(containerEl)||containerEl,_i=0,_a=DOM.childNodesAsList(parent_1);_i<_a.length;_i++){var child=_a[_i];DOM.removeChild(parent_1,child)}return _angular_core.isDevMode()&&sanitizer.sanitizedSomething&&DOM.log("WARNING: sanitizing HTML stripped some content (see http://g.co/ng/security#xss)."),safeHtml}catch(e){throw inertElement=null,e}}function hasBalancedQuotes(value){for(var outsideSingle=!0,outsideDouble=!0,i=0;i<value.length;i++){var c=value.charAt(i);"'"===c&&outsideDouble?outsideSingle=!outsideSingle:'"'===c&&outsideSingle&&(outsideDouble=!outsideDouble)}return outsideSingle&&outsideDouble}function sanitizeStyle(value){if(value=String(value).trim(),!value)return"";var urlMatch=value.match(URL_RE);return urlMatch&&sanitizeUrl(urlMatch[1])===urlMatch[1]||value.match(SAFE_STYLE_VALUE)&&hasBalancedQuotes(value)?value:(_angular_core.isDevMode()&&getDOM().log("WARNING: sanitizing unsafe style value "+value+" (see http://g.co/ng/security#xss)."),"unsafe")}function initDomAdapter(){BrowserDomAdapter.makeCurrent(),BrowserGetTestability.init()}function errorHandler(){return new _angular_core.ErrorHandler}function _document(){return getDOM().defaultDoc()}function _resolveDefaultAnimationDriver(){return getDOM().supportsWebAnimation()?new WebAnimationsDriver:AnimationDriver.NOOP}function enableDebugTools(ref){return context.ng=new AngularTools(ref),ref}function disableDebugTools(){delete context.ng}var globalScope,DebugDomRootRenderer=_angular_core.__core_private__.DebugDomRootRenderer,NoOpAnimationPlayer=_angular_core.__core_private__.NoOpAnimationPlayer,_NoOpAnimationDriver=function(){function _NoOpAnimationDriver(){}return _NoOpAnimationDriver.prototype.animate=function(element,startingStyles,keyframes,duration,delay,easing){return new NoOpAnimationPlayer},_NoOpAnimationDriver}(),AnimationDriver=function(){function AnimationDriver(){}return AnimationDriver.NOOP=new _NoOpAnimationDriver,AnimationDriver}();globalScope="undefined"==typeof window?"undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope?self:global:window;var global$1=globalScope,Date=global$1.Date;global$1.assert=function(condition){};var StringWrapper=function(){function StringWrapper(){}return StringWrapper.fromCharCode=function(code){return String.fromCharCode(code)},StringWrapper.charCodeAt=function(s,index){return s.charCodeAt(index)},StringWrapper.split=function(s,regExp){return s.split(regExp)},StringWrapper.equals=function(s,s2){return s===s2},StringWrapper.stripLeft=function(s,charVal){if(s&&s.length){for(var pos=0,i=0;i<s.length&&s[i]==charVal;i++)pos++;s=s.substring(pos)}return s},StringWrapper.stripRight=function(s,charVal){if(s&&s.length){for(var pos=s.length,i=s.length-1;i>=0&&s[i]==charVal;i--)pos--;s=s.substring(0,pos)}return s},StringWrapper.replace=function(s,from,replace){return s.replace(from,replace)},StringWrapper.replaceAll=function(s,from,replace){return s.replace(from,replace)},StringWrapper.slice=function(s,from,to){return void 0===from&&(from=0),void 0===to&&(to=null),s.slice(from,null===to?void 0:to)},StringWrapper.replaceAllMapped=function(s,from,cb){return s.replace(from,function(){for(var matches=[],_i=0;_i<arguments.length;_i++)matches[_i-0]=arguments[_i];return matches.splice(-2,2),cb(matches)})},StringWrapper.contains=function(s,substr){return s.indexOf(substr)!=-1},StringWrapper.compare=function(a,b){return a<b?-1:a>b?1:0},StringWrapper}(),NumberWrapper=function(){function NumberWrapper(){}return NumberWrapper.toFixed=function(n,fractionDigits){return n.toFixed(fractionDigits)},NumberWrapper.equal=function(a,b){return a===b},NumberWrapper.parseIntAutoRadix=function(text){var result=parseInt(text);if(isNaN(result))throw new Error("Invalid integer literal when parsing "+text);return result},NumberWrapper.parseInt=function(text,radix){if(10==radix){if(/^(\-|\+)?[0-9]+$/.test(text))return parseInt(text,radix)}else if(16==radix){if(/^(\-|\+)?[0-9ABCDEFabcdef]+$/.test(text))return parseInt(text,radix)}else{var result=parseInt(text,radix);if(!isNaN(result))return result}throw new Error("Invalid integer literal when parsing "+text+" in base "+radix)},Object.defineProperty(NumberWrapper,"NaN",{get:function(){return NaN},enumerable:!0,configurable:!0}),NumberWrapper.isNumeric=function(value){return!isNaN(value-parseFloat(value))},NumberWrapper.isNaN=function(value){return isNaN(value)},NumberWrapper.isInteger=function(value){return Number.isInteger(value)},NumberWrapper}(),Json=function(){function Json(){}return Json.parse=function(s){return global$1.JSON.parse(s)},Json.stringify=function(data){return global$1.JSON.stringify(data,null,2)},Json}(),DateWrapper=function(){function DateWrapper(){}return DateWrapper.create=function(year,month,day,hour,minutes,seconds,milliseconds){return void 0===month&&(month=1),void 0===day&&(day=1),void 0===hour&&(hour=0),void 0===minutes&&(minutes=0),void 0===seconds&&(seconds=0),void 0===milliseconds&&(milliseconds=0),new Date(year,month-1,day,hour,minutes,seconds,milliseconds)},DateWrapper.fromISOString=function(str){return new Date(str)},DateWrapper.fromMillis=function(ms){return new Date(ms)},DateWrapper.toMillis=function(date){return date.getTime()},DateWrapper.now=function(){return new Date},DateWrapper.toJson=function(date){return date.toJSON()},DateWrapper}(),StringMapWrapper=(function(){return(new Map).keys().next?function(m){for(var k,keyIterator=m.keys();!(k=keyIterator.next()).done;)m.set(k.value,null)}:function(m){m.forEach(function(v,k){m.set(k,null)})}}(),function(){try{if((new Map).values().next)return function(m,getValues){return getValues?Array.from(m.values()):Array.from(m.keys())}}catch(e){}return function(m,getValues){var res=new Array(m.size),i=0;return m.forEach(function(v,k){res[i]=getValues?v:k,i++}),res}}(),function(){function StringMapWrapper(){}return StringMapWrapper.get=function(map,key){return map.hasOwnProperty(key)?map[key]:void 0},StringMapWrapper.set=function(map,key,value){map[key]=value},StringMapWrapper.keys=function(map){return Object.keys(map)},StringMapWrapper.values=function(map){return Object.keys(map).map(function(k){return map[k]})},StringMapWrapper.isEmpty=function(map){for(var prop in map)return!1;return!0},StringMapWrapper.forEach=function(map,callback){for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var k=_a[_i];callback(map[k],k)}},StringMapWrapper.merge=function(m1,m2){for(var m={},_i=0,_a=Object.keys(m1);_i<_a.length;_i++){var k=_a[_i];m[k]=m1[k]}for(var _b=0,_c=Object.keys(m2);_b<_c.length;_b++){var k=_c[_b];m[k]=m2[k]}return m},StringMapWrapper.equals=function(m1,m2){var k1=Object.keys(m1),k2=Object.keys(m2);if(k1.length!=k2.length)return!1;for(var i=0;i<k1.length;i++){var key=k1[i];if(m1[key]!==m2[key])return!1}return!0},StringMapWrapper}()),ListWrapper=function(){function ListWrapper(){}return ListWrapper.createFixedSize=function(size){return new Array(size)},ListWrapper.createGrowableSize=function(size){return new Array(size)},ListWrapper.clone=function(array){return array.slice(0)},ListWrapper.forEachWithIndex=function(array,fn){for(var i=0;i<array.length;i++)fn(array[i],i)},ListWrapper.first=function(array){return array?array[0]:null},ListWrapper.last=function(array){return array&&0!=array.length?array[array.length-1]:null},ListWrapper.indexOf=function(array,value,startIndex){return void 0===startIndex&&(startIndex=0),array.indexOf(value,startIndex)},ListWrapper.contains=function(list,el){return list.indexOf(el)!==-1},ListWrapper.reversed=function(array){var a=ListWrapper.clone(array);return a.reverse()},ListWrapper.concat=function(a,b){return a.concat(b)},ListWrapper.insert=function(list,index,value){list.splice(index,0,value)},ListWrapper.removeAt=function(list,index){var res=list[index];return list.splice(index,1),res},ListWrapper.removeAll=function(list,items){for(var i=0;i<items.length;++i){var index=list.indexOf(items[i]);list.splice(index,1)}},ListWrapper.remove=function(list,el){var index=list.indexOf(el);return index>-1&&(list.splice(index,1),!0)},ListWrapper.clear=function(list){list.length=0},ListWrapper.isEmpty=function(list){return 0==list.length},ListWrapper.fill=function(list,value,start,end){void 0===start&&(start=0),void 0===end&&(end=null),list.fill(value,start,null===end?list.length:end)},ListWrapper.equals=function(a,b){if(a.length!=b.length)return!1;for(var i=0;i<a.length;++i)if(a[i]!==b[i])return!1;return!0},ListWrapper.slice=function(l,from,to){return void 0===from&&(from=0),void 0===to&&(to=null),l.slice(from,null===to?void 0:to)},ListWrapper.splice=function(l,from,length){return l.splice(from,length)},ListWrapper.sort=function(l,compareFn){isPresent(compareFn)?l.sort(compareFn):l.sort()},ListWrapper.toString=function(l){return l.toString()},ListWrapper.toJSON=function(l){return JSON.stringify(l)},ListWrapper.maximum=function(list,predicate){if(0==list.length)return null;for(var solution=null,maxValue=-(1/0),index=0;index<list.length;index++){var candidate=list[index];if(!isBlank(candidate)){var candidateValue=predicate(candidate);candidateValue>maxValue&&(solution=candidate,maxValue=candidateValue)}}return solution},ListWrapper.flatten=function(list){var target=[];return _flattenArray(list,target),target},ListWrapper.addAll=function(list,source){for(var i=0;i<source.length;i++)list.push(source[i])},ListWrapper}(),CAMEL_CASE_REGEXP=/([A-Z])/g,DASH_CASE_REGEXP=/-([a-z])/g,_DOM=null,DomAdapter=function(){function DomAdapter(){this.resourceLoaderType=null}return Object.defineProperty(DomAdapter.prototype,"attrToPropMap",{get:function(){return this._attrToPropMap},set:function(value){this._attrToPropMap=value},enumerable:!0,configurable:!0}),DomAdapter}(),WebAnimationsPlayer=function(){function WebAnimationsPlayer(element,keyframes,options){this.element=element,this.keyframes=keyframes,this.options=options,this._onDoneFns=[],this._onStartFns=[],this._finished=!1,this._initialized=!1,this._started=!1,this.parentPlayer=null,this._duration=options.duration}return WebAnimationsPlayer.prototype._onFinish=function(){this._finished||(this._finished=!0,isPresent(this.parentPlayer)||this.destroy(),this._onDoneFns.forEach(function(fn){return fn()}),this._onDoneFns=[])},WebAnimationsPlayer.prototype.init=function(){var _this=this;if(!this._initialized){this._initialized=!0;var keyframes=this.keyframes.map(function(styles){var formattedKeyframe={};return StringMapWrapper.forEach(styles,function(value,prop){formattedKeyframe[prop]=value==_angular_core.AUTO_STYLE?_computeStyle(_this.element,prop):value}),formattedKeyframe});this._player=this._triggerWebAnimation(this.element,keyframes,this.options),this.reset(),this._player.onfinish=function(){return _this._onFinish()}}},WebAnimationsPlayer.prototype._triggerWebAnimation=function(element,keyframes,options){return element.animate(keyframes,options)},WebAnimationsPlayer.prototype.onStart=function(fn){this._onStartFns.push(fn)},WebAnimationsPlayer.prototype.onDone=function(fn){this._onDoneFns.push(fn)},WebAnimationsPlayer.prototype.play=function(){this.init(),this.hasStarted()||(this._onStartFns.forEach(function(fn){return fn()}),this._onStartFns=[],this._started=!0),this._player.play()},WebAnimationsPlayer.prototype.pause=function(){this.init(),this._player.pause()},WebAnimationsPlayer.prototype.finish=function(){this.init(),this._onFinish(),this._player.finish()},WebAnimationsPlayer.prototype.reset=function(){this._player.cancel()},WebAnimationsPlayer.prototype.restart=function(){this.reset(),this.play()},WebAnimationsPlayer.prototype.hasStarted=function(){return this._started},WebAnimationsPlayer.prototype.destroy=function(){this.reset(),this._onFinish()},Object.defineProperty(WebAnimationsPlayer.prototype,"totalTime",{get:function(){return this._duration},enumerable:!0,configurable:!0}),WebAnimationsPlayer.prototype.setPosition=function(p){this._player.currentTime=p*this.totalTime},WebAnimationsPlayer.prototype.getPosition=function(){return this._player.currentTime/this.totalTime},WebAnimationsPlayer}(),WebAnimationsDriver=function(){function WebAnimationsDriver(){}return WebAnimationsDriver.prototype.animate=function(element,startingStyles,keyframes,duration,delay,easing){var formattedSteps=[],startingStyleLookup={};if(isPresent(startingStyles)&&startingStyles.styles.length>0&&(startingStyleLookup=_populateStyles(element,startingStyles,{}),startingStyleLookup.offset=0,formattedSteps.push(startingStyleLookup)),keyframes.forEach(function(keyframe){var data=_populateStyles(element,keyframe.styles,startingStyleLookup);data.offset=keyframe.offset,formattedSteps.push(data)}),1==formattedSteps.length){var start=formattedSteps[0];start.offset=null,formattedSteps=[start,start]}var playerOptions={duration:duration,delay:delay,fill:"both"};return easing&&(playerOptions.easing=easing),new WebAnimationsPlayer(element,formattedSteps,playerOptions)},WebAnimationsDriver}(),_$0=48,_$9=57,_$PERIOD=46,__extends$1=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},GenericBrowserDomAdapter=function(_super){function GenericBrowserDomAdapter(){var _this=this;_super.call(this),this._animationPrefix=null,this._transitionEnd=null;try{var element=this.createElement("div",this.defaultDoc());if(isPresent(this.getStyle(element,"animationName")))this._animationPrefix="";else for(var domPrefixes=["Webkit","Moz","O","ms"],i=0;i<domPrefixes.length;i++)if(isPresent(this.getStyle(element,domPrefixes[i]+"AnimationName"))){this._animationPrefix="-"+domPrefixes[i].toLowerCase()+"-";break}var transEndEventNames={WebkitTransition:"webkitTransitionEnd",MozTransition:"transitionend",OTransition:"oTransitionEnd otransitionend",transition:"transitionend"};StringMapWrapper.forEach(transEndEventNames,function(value,key){isPresent(_this.getStyle(element,key))&&(_this._transitionEnd=value)})}catch(e){this._animationPrefix=null,this._transitionEnd=null}}return __extends$1(GenericBrowserDomAdapter,_super),GenericBrowserDomAdapter.prototype.getDistributedNodes=function(el){return el.getDistributedNodes()},GenericBrowserDomAdapter.prototype.resolveAndSetHref=function(el,baseUrl,href){el.href=null==href?baseUrl:baseUrl+"/../"+href},GenericBrowserDomAdapter.prototype.supportsDOMEvents=function(){return!0},GenericBrowserDomAdapter.prototype.supportsNativeShadowDOM=function(){return isFunction(this.defaultDoc().body.createShadowRoot)},GenericBrowserDomAdapter.prototype.getAnimationPrefix=function(){return isPresent(this._animationPrefix)?this._animationPrefix:""},GenericBrowserDomAdapter.prototype.getTransitionEnd=function(){return isPresent(this._transitionEnd)?this._transitionEnd:""},GenericBrowserDomAdapter.prototype.supportsAnimation=function(){return isPresent(this._animationPrefix)&&isPresent(this._transitionEnd)},GenericBrowserDomAdapter}(DomAdapter),__extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_attrToPropMap={class:"className",innerHtml:"innerHTML",readonly:"readOnly",tabindex:"tabIndex"},DOM_KEY_LOCATION_NUMPAD=3,_keyMap={"\b":"Backspace","\t":"Tab","":"Delete","":"Escape",Del:"Delete",Esc:"Escape",Left:"ArrowLeft",Right:"ArrowRight",Up:"ArrowUp",Down:"ArrowDown",Menu:"ContextMenu",Scroll:"ScrollLock",Win:"OS"},_chromeNumKeyPadMap={A:"1",B:"2",C:"3",D:"4",E:"5",F:"6",G:"7",H:"8",I:"9",J:"*",K:"+",M:"-",N:".",O:"/","`":"0","":"NumLock"},BrowserDomAdapter=function(_super){function BrowserDomAdapter(){_super.apply(this,arguments)}return __extends(BrowserDomAdapter,_super),BrowserDomAdapter.prototype.parse=function(templateHtml){throw new Error("parse not implemented")},BrowserDomAdapter.makeCurrent=function(){setRootDomAdapter(new BrowserDomAdapter)},BrowserDomAdapter.prototype.hasProperty=function(element,name){return name in element},BrowserDomAdapter.prototype.setProperty=function(el,name,value){el[name]=value},BrowserDomAdapter.prototype.getProperty=function(el,name){return el[name]},BrowserDomAdapter.prototype.invoke=function(el,methodName,args){el[methodName].apply(el,args)},BrowserDomAdapter.prototype.logError=function(error){window.console.error?window.console.error(error):window.console.log(error)},BrowserDomAdapter.prototype.log=function(error){window.console.log(error)},BrowserDomAdapter.prototype.logGroup=function(error){window.console.group?(window.console.group(error),this.logError(error)):window.console.log(error)},BrowserDomAdapter.prototype.logGroupEnd=function(){window.console.groupEnd&&window.console.groupEnd()},Object.defineProperty(BrowserDomAdapter.prototype,"attrToPropMap",{get:function(){return _attrToPropMap},enumerable:!0,configurable:!0}),BrowserDomAdapter.prototype.query=function(selector){return document.querySelector(selector)},BrowserDomAdapter.prototype.querySelector=function(el,selector){return el.querySelector(selector)},BrowserDomAdapter.prototype.querySelectorAll=function(el,selector){return el.querySelectorAll(selector)},BrowserDomAdapter.prototype.on=function(el,evt,listener){el.addEventListener(evt,listener,!1)},BrowserDomAdapter.prototype.onAndCancel=function(el,evt,listener){return el.addEventListener(evt,listener,!1),function(){el.removeEventListener(evt,listener,!1)}},BrowserDomAdapter.prototype.dispatchEvent=function(el,evt){el.dispatchEvent(evt)},BrowserDomAdapter.prototype.createMouseEvent=function(eventType){var evt=document.createEvent("MouseEvent");return evt.initEvent(eventType,!0,!0),evt},BrowserDomAdapter.prototype.createEvent=function(eventType){var evt=document.createEvent("Event");return evt.initEvent(eventType,!0,!0),evt},BrowserDomAdapter.prototype.preventDefault=function(evt){evt.preventDefault(),evt.returnValue=!1},BrowserDomAdapter.prototype.isPrevented=function(evt){return evt.defaultPrevented||isPresent(evt.returnValue)&&!evt.returnValue},BrowserDomAdapter.prototype.getInnerHTML=function(el){return el.innerHTML},BrowserDomAdapter.prototype.getTemplateContent=function(el){return"content"in el&&el instanceof HTMLTemplateElement?el.content:null},BrowserDomAdapter.prototype.getOuterHTML=function(el){return el.outerHTML},BrowserDomAdapter.prototype.nodeName=function(node){return node.nodeName},BrowserDomAdapter.prototype.nodeValue=function(node){return node.nodeValue},BrowserDomAdapter.prototype.type=function(node){return node.type},BrowserDomAdapter.prototype.content=function(node){return this.hasProperty(node,"content")?node.content:node},BrowserDomAdapter.prototype.firstChild=function(el){return el.firstChild},BrowserDomAdapter.prototype.nextSibling=function(el){return el.nextSibling},BrowserDomAdapter.prototype.parentElement=function(el){return el.parentNode},BrowserDomAdapter.prototype.childNodes=function(el){return el.childNodes},BrowserDomAdapter.prototype.childNodesAsList=function(el){for(var childNodes=el.childNodes,res=new Array(childNodes.length),i=0;i<childNodes.length;i++)res[i]=childNodes[i];return res},BrowserDomAdapter.prototype.clearNodes=function(el){for(;el.firstChild;)el.removeChild(el.firstChild)},BrowserDomAdapter.prototype.appendChild=function(el,node){el.appendChild(node)},BrowserDomAdapter.prototype.removeChild=function(el,node){el.removeChild(node)},BrowserDomAdapter.prototype.replaceChild=function(el,newChild,oldChild){el.replaceChild(newChild,oldChild)},BrowserDomAdapter.prototype.remove=function(node){return node.parentNode&&node.parentNode.removeChild(node),node},BrowserDomAdapter.prototype.insertBefore=function(el,node){el.parentNode.insertBefore(node,el)},BrowserDomAdapter.prototype.insertAllBefore=function(el,nodes){nodes.forEach(function(n){return el.parentNode.insertBefore(n,el)})},BrowserDomAdapter.prototype.insertAfter=function(el,node){el.parentNode.insertBefore(node,el.nextSibling)},BrowserDomAdapter.prototype.setInnerHTML=function(el,value){el.innerHTML=value},BrowserDomAdapter.prototype.getText=function(el){return el.textContent},BrowserDomAdapter.prototype.setText=function(el,value){el.textContent=value},BrowserDomAdapter.prototype.getValue=function(el){return el.value},BrowserDomAdapter.prototype.setValue=function(el,value){el.value=value},BrowserDomAdapter.prototype.getChecked=function(el){return el.checked},BrowserDomAdapter.prototype.setChecked=function(el,value){el.checked=value},BrowserDomAdapter.prototype.createComment=function(text){return document.createComment(text)},BrowserDomAdapter.prototype.createTemplate=function(html){var t=document.createElement("template");return t.innerHTML=html,t},BrowserDomAdapter.prototype.createElement=function(tagName,doc){return void 0===doc&&(doc=document),doc.createElement(tagName)},BrowserDomAdapter.prototype.createElementNS=function(ns,tagName,doc){return void 0===doc&&(doc=document),doc.createElementNS(ns,tagName)},BrowserDomAdapter.prototype.createTextNode=function(text,doc){return void 0===doc&&(doc=document),doc.createTextNode(text)},BrowserDomAdapter.prototype.createScriptTag=function(attrName,attrValue,doc){void 0===doc&&(doc=document);var el=doc.createElement("SCRIPT");return el.setAttribute(attrName,attrValue),el},BrowserDomAdapter.prototype.createStyleElement=function(css,doc){void 0===doc&&(doc=document);var style=doc.createElement("style");return this.appendChild(style,this.createTextNode(css)),style},BrowserDomAdapter.prototype.createShadowRoot=function(el){return el.createShadowRoot()},BrowserDomAdapter.prototype.getShadowRoot=function(el){return el.shadowRoot},BrowserDomAdapter.prototype.getHost=function(el){return el.host},BrowserDomAdapter.prototype.clone=function(node){return node.cloneNode(!0)},BrowserDomAdapter.prototype.getElementsByClassName=function(element,name){return element.getElementsByClassName(name)},BrowserDomAdapter.prototype.getElementsByTagName=function(element,name){return element.getElementsByTagName(name)},BrowserDomAdapter.prototype.classList=function(element){return Array.prototype.slice.call(element.classList,0)},BrowserDomAdapter.prototype.addClass=function(element,className){element.classList.add(className)},BrowserDomAdapter.prototype.removeClass=function(element,className){element.classList.remove(className)},BrowserDomAdapter.prototype.hasClass=function(element,className){return element.classList.contains(className)},BrowserDomAdapter.prototype.setStyle=function(element,styleName,styleValue){element.style[styleName]=styleValue},BrowserDomAdapter.prototype.removeStyle=function(element,stylename){element.style[stylename]=null},BrowserDomAdapter.prototype.getStyle=function(element,stylename){return element.style[stylename]},BrowserDomAdapter.prototype.hasStyle=function(element,styleName,styleValue){void 0===styleValue&&(styleValue=null);var value=this.getStyle(element,styleName)||"";return styleValue?value==styleValue:value.length>0},BrowserDomAdapter.prototype.tagName=function(element){return element.tagName},BrowserDomAdapter.prototype.attributeMap=function(element){for(var res=new Map,elAttrs=element.attributes,i=0;i<elAttrs.length;i++){var attrib=elAttrs[i];res.set(attrib.name,attrib.value)}return res},BrowserDomAdapter.prototype.hasAttribute=function(element,attribute){return element.hasAttribute(attribute)},BrowserDomAdapter.prototype.hasAttributeNS=function(element,ns,attribute){return element.hasAttributeNS(ns,attribute)},BrowserDomAdapter.prototype.getAttribute=function(element,attribute){return element.getAttribute(attribute)},BrowserDomAdapter.prototype.getAttributeNS=function(element,ns,name){return element.getAttributeNS(ns,name)},BrowserDomAdapter.prototype.setAttribute=function(element,name,value){element.setAttribute(name,value)},BrowserDomAdapter.prototype.setAttributeNS=function(element,ns,name,value){element.setAttributeNS(ns,name,value)},BrowserDomAdapter.prototype.removeAttribute=function(element,attribute){element.removeAttribute(attribute)},BrowserDomAdapter.prototype.removeAttributeNS=function(element,ns,name){element.removeAttributeNS(ns,name)},BrowserDomAdapter.prototype.templateAwareRoot=function(el){return this.isTemplateElement(el)?this.content(el):el},BrowserDomAdapter.prototype.createHtmlDocument=function(){return document.implementation.createHTMLDocument("fakeTitle")},BrowserDomAdapter.prototype.defaultDoc=function(){return document},BrowserDomAdapter.prototype.getBoundingClientRect=function(el){try{return el.getBoundingClientRect()}catch(e){return{top:0,bottom:0,left:0,right:0,width:0,height:0}}},BrowserDomAdapter.prototype.getTitle=function(){return document.title},BrowserDomAdapter.prototype.setTitle=function(newTitle){document.title=newTitle||""},BrowserDomAdapter.prototype.elementMatches=function(n,selector){var matches=!1;return n instanceof HTMLElement&&(n.matches?matches=n.matches(selector):n.msMatchesSelector?matches=n.msMatchesSelector(selector):n.webkitMatchesSelector&&(matches=n.webkitMatchesSelector(selector))),matches},BrowserDomAdapter.prototype.isTemplateElement=function(el){return el instanceof HTMLElement&&"TEMPLATE"==el.nodeName},BrowserDomAdapter.prototype.isTextNode=function(node){return node.nodeType===Node.TEXT_NODE},BrowserDomAdapter.prototype.isCommentNode=function(node){return node.nodeType===Node.COMMENT_NODE},BrowserDomAdapter.prototype.isElementNode=function(node){return node.nodeType===Node.ELEMENT_NODE},BrowserDomAdapter.prototype.hasShadowRoot=function(node){return isPresent(node.shadowRoot)&&node instanceof HTMLElement},BrowserDomAdapter.prototype.isShadowRoot=function(node){return node instanceof DocumentFragment},BrowserDomAdapter.prototype.importIntoDoc=function(node){var toImport=node;return this.isTemplateElement(node)&&(toImport=this.content(node)),document.importNode(toImport,!0)},BrowserDomAdapter.prototype.adoptNode=function(node){return document.adoptNode(node)},BrowserDomAdapter.prototype.getHref=function(el){return el.href},BrowserDomAdapter.prototype.getEventKey=function(event){var key=event.key;if(isBlank(key)){if(key=event.keyIdentifier,isBlank(key))return"Unidentified";key.startsWith("U+")&&(key=String.fromCharCode(parseInt(key.substring(2),16)),event.location===DOM_KEY_LOCATION_NUMPAD&&_chromeNumKeyPadMap.hasOwnProperty(key)&&(key=_chromeNumKeyPadMap[key]))}return _keyMap.hasOwnProperty(key)&&(key=_keyMap[key]),key},BrowserDomAdapter.prototype.getGlobalEventTarget=function(target){return"window"==target?window:"document"==target?document:"body"==target?document.body:void 0},BrowserDomAdapter.prototype.getHistory=function(){return window.history},BrowserDomAdapter.prototype.getLocation=function(){return window.location},BrowserDomAdapter.prototype.getBaseHref=function(){var href=getBaseElementHref();return isBlank(href)?null:relativePath(href)},BrowserDomAdapter.prototype.resetBaseElement=function(){baseElement=null},BrowserDomAdapter.prototype.getUserAgent=function(){return window.navigator.userAgent},BrowserDomAdapter.prototype.setData=function(element,name,value){this.setAttribute(element,"data-"+name,value)},BrowserDomAdapter.prototype.getData=function(element,name){return this.getAttribute(element,"data-"+name)},BrowserDomAdapter.prototype.getComputedStyle=function(element){return getComputedStyle(element)},BrowserDomAdapter.prototype.setGlobalVar=function(path,value){setValueOnPath(global$1,path,value)},BrowserDomAdapter.prototype.supportsWebAnimation=function(){return isFunction(Element.prototype.animate)},BrowserDomAdapter.prototype.performanceNow=function(){return isPresent(window.performance)&&isPresent(window.performance.now)?window.performance.now():DateWrapper.toMillis(DateWrapper.now())},BrowserDomAdapter.prototype.supportsCookies=function(){
return!0},BrowserDomAdapter.prototype.getCookie=function(name){return parseCookieValue(document.cookie,name)},BrowserDomAdapter.prototype.setCookie=function(name,value){document.cookie=encodeURIComponent(name)+"="+encodeURIComponent(value)},BrowserDomAdapter}(GenericBrowserDomAdapter),baseElement=null,urlParsingNode=null,__extends$2=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},BrowserPlatformLocation=function(_super){function BrowserPlatformLocation(){_super.call(this),this._init()}return __extends$2(BrowserPlatformLocation,_super),BrowserPlatformLocation.prototype._init=function(){this._location=getDOM().getLocation(),this._history=getDOM().getHistory()},Object.defineProperty(BrowserPlatformLocation.prototype,"location",{get:function(){return this._location},enumerable:!0,configurable:!0}),BrowserPlatformLocation.prototype.getBaseHrefFromDOM=function(){return getDOM().getBaseHref()},BrowserPlatformLocation.prototype.onPopState=function(fn){getDOM().getGlobalEventTarget("window").addEventListener("popstate",fn,!1)},BrowserPlatformLocation.prototype.onHashChange=function(fn){getDOM().getGlobalEventTarget("window").addEventListener("hashchange",fn,!1)},Object.defineProperty(BrowserPlatformLocation.prototype,"pathname",{get:function(){return this._location.pathname},set:function(newPath){this._location.pathname=newPath},enumerable:!0,configurable:!0}),Object.defineProperty(BrowserPlatformLocation.prototype,"search",{get:function(){return this._location.search},enumerable:!0,configurable:!0}),Object.defineProperty(BrowserPlatformLocation.prototype,"hash",{get:function(){return this._location.hash},enumerable:!0,configurable:!0}),BrowserPlatformLocation.prototype.pushState=function(state,title,url){supportsState()?this._history.pushState(state,title,url):this._location.hash=url},BrowserPlatformLocation.prototype.replaceState=function(state,title,url){supportsState()?this._history.replaceState(state,title,url):this._location.hash=url},BrowserPlatformLocation.prototype.forward=function(){this._history.forward()},BrowserPlatformLocation.prototype.back=function(){this._history.back()},BrowserPlatformLocation.decorators=[{type:_angular_core.Injectable}],BrowserPlatformLocation.ctorParameters=[],BrowserPlatformLocation}(_angular_common.PlatformLocation),BrowserGetTestability=function(){function BrowserGetTestability(){}return BrowserGetTestability.init=function(){_angular_core.setTestabilityGetter(new BrowserGetTestability)},BrowserGetTestability.prototype.addToWindow=function(registry){global$1.getAngularTestability=function(elem,findInAncestors){void 0===findInAncestors&&(findInAncestors=!0);var testability=registry.findTestabilityInTree(elem,findInAncestors);if(null==testability)throw new Error("Could not find testability for element.");return testability},global$1.getAllAngularTestabilities=function(){return registry.getAllTestabilities()},global$1.getAllAngularRootElements=function(){return registry.getAllRootElements()};var whenAllStable=function(callback){var testabilities=global$1.getAllAngularTestabilities(),count=testabilities.length,didWork=!1,decrement=function(didWork_){didWork=didWork||didWork_,count--,0==count&&callback(didWork)};testabilities.forEach(function(testability){testability.whenStable(decrement)})};global$1.frameworkStabilizers||(global$1.frameworkStabilizers=ListWrapper.createGrowableSize(0)),global$1.frameworkStabilizers.push(whenAllStable)},BrowserGetTestability.prototype.findTestabilityInTree=function(registry,elem,findInAncestors){if(null==elem)return null;var t=registry.getTestability(elem);return isPresent(t)?t:findInAncestors?getDOM().isShadowRoot(elem)?this.findTestabilityInTree(registry,getDOM().getHost(elem),!0):this.findTestabilityInTree(registry,getDOM().parentElement(elem),!0):null},BrowserGetTestability}(),Title=function(){function Title(){}return Title.prototype.getTitle=function(){return getDOM().getTitle()},Title.prototype.setTitle=function(newTitle){getDOM().setTitle(newTitle)},Title}(),DOCUMENT=new _angular_core.OpaqueToken("DocumentToken"),EVENT_MANAGER_PLUGINS=new _angular_core.OpaqueToken("EventManagerPlugins"),EventManager=function(){function EventManager(plugins,_zone){var _this=this;this._zone=_zone,plugins.forEach(function(p){return p.manager=_this}),this._plugins=plugins.slice().reverse()}return EventManager.prototype.addEventListener=function(element,eventName,handler){var plugin=this._findPluginFor(eventName);return plugin.addEventListener(element,eventName,handler)},EventManager.prototype.addGlobalEventListener=function(target,eventName,handler){var plugin=this._findPluginFor(eventName);return plugin.addGlobalEventListener(target,eventName,handler)},EventManager.prototype.getZone=function(){return this._zone},EventManager.prototype._findPluginFor=function(eventName){for(var plugins=this._plugins,i=0;i<plugins.length;i++){var plugin=plugins[i];if(plugin.supports(eventName))return plugin}throw new Error("No event manager plugin found for event "+eventName)},EventManager.decorators=[{type:_angular_core.Injectable}],EventManager.ctorParameters=[{type:Array,decorators:[{type:_angular_core.Inject,args:[EVENT_MANAGER_PLUGINS]}]},{type:_angular_core.NgZone}],EventManager}(),EventManagerPlugin=function(){function EventManagerPlugin(){}return EventManagerPlugin.prototype.supports=function(eventName){return!1},EventManagerPlugin.prototype.addEventListener=function(element,eventName,handler){throw"not implemented"},EventManagerPlugin.prototype.addGlobalEventListener=function(element,eventName,handler){throw"not implemented"},EventManagerPlugin}(),__extends$4=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},SharedStylesHost=function(){function SharedStylesHost(){this._styles=[],this._stylesSet=new Set}return SharedStylesHost.prototype.addStyles=function(styles){var _this=this,additions=[];styles.forEach(function(style){_this._stylesSet.has(style)||(_this._stylesSet.add(style),_this._styles.push(style),additions.push(style))}),this.onStylesAdded(additions)},SharedStylesHost.prototype.onStylesAdded=function(additions){},SharedStylesHost.prototype.getAllStyles=function(){return this._styles},SharedStylesHost.decorators=[{type:_angular_core.Injectable}],SharedStylesHost.ctorParameters=[],SharedStylesHost}(),DomSharedStylesHost=function(_super){function DomSharedStylesHost(doc){_super.call(this),this._hostNodes=new Set,this._hostNodes.add(doc.head)}return __extends$4(DomSharedStylesHost,_super),DomSharedStylesHost.prototype._addStylesToHost=function(styles,host){for(var i=0;i<styles.length;i++){var style=styles[i];getDOM().appendChild(host,getDOM().createStyleElement(style))}},DomSharedStylesHost.prototype.addHost=function(hostNode){this._addStylesToHost(this._styles,hostNode),this._hostNodes.add(hostNode)},DomSharedStylesHost.prototype.removeHost=function(hostNode){this._hostNodes.delete(hostNode)},DomSharedStylesHost.prototype.onStylesAdded=function(additions){var _this=this;this._hostNodes.forEach(function(hostNode){_this._addStylesToHost(additions,hostNode)})},DomSharedStylesHost.decorators=[{type:_angular_core.Injectable}],DomSharedStylesHost.ctorParameters=[{type:void 0,decorators:[{type:_angular_core.Inject,args:[DOCUMENT]}]}],DomSharedStylesHost}(SharedStylesHost),__extends$3=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},NAMESPACE_URIS={xlink:"http://www.w3.org/1999/xlink",svg:"http://www.w3.org/2000/svg",xhtml:"http://www.w3.org/1999/xhtml"},TEMPLATE_COMMENT_TEXT="template bindings={}",TEMPLATE_BINDINGS_EXP=/^template bindings=(.*)$/,DomRootRenderer=function(){function DomRootRenderer(document,eventManager,sharedStylesHost,animationDriver){this.document=document,this.eventManager=eventManager,this.sharedStylesHost=sharedStylesHost,this.animationDriver=animationDriver,this.registeredComponents=new Map}return DomRootRenderer.prototype.renderComponent=function(componentProto){var renderer=this.registeredComponents.get(componentProto.id);return isBlank(renderer)&&(renderer=new DomRenderer(this,componentProto,this.animationDriver),this.registeredComponents.set(componentProto.id,renderer)),renderer},DomRootRenderer}(),DomRootRenderer_=function(_super){function DomRootRenderer_(_document,_eventManager,sharedStylesHost,animationDriver){_super.call(this,_document,_eventManager,sharedStylesHost,animationDriver)}return __extends$3(DomRootRenderer_,_super),DomRootRenderer_.decorators=[{type:_angular_core.Injectable}],DomRootRenderer_.ctorParameters=[{type:void 0,decorators:[{type:_angular_core.Inject,args:[DOCUMENT]}]},{type:EventManager},{type:DomSharedStylesHost},{type:AnimationDriver}],DomRootRenderer_}(DomRootRenderer),DomRenderer=function(){function DomRenderer(_rootRenderer,componentProto,_animationDriver){this._rootRenderer=_rootRenderer,this.componentProto=componentProto,this._animationDriver=_animationDriver,this._styles=_flattenStyles(componentProto.id,componentProto.styles,[]),componentProto.encapsulation!==_angular_core.ViewEncapsulation.Native&&this._rootRenderer.sharedStylesHost.addStyles(this._styles),this.componentProto.encapsulation===_angular_core.ViewEncapsulation.Emulated?(this._contentAttr=_shimContentAttribute(componentProto.id),this._hostAttr=_shimHostAttribute(componentProto.id)):(this._contentAttr=null,this._hostAttr=null)}return DomRenderer.prototype.selectRootElement=function(selectorOrNode,debugInfo){var el;if(isString(selectorOrNode)){if(el=getDOM().querySelector(this._rootRenderer.document,selectorOrNode),isBlank(el))throw new Error('The selector "'+selectorOrNode+'" did not match any elements')}else el=selectorOrNode;return getDOM().clearNodes(el),el},DomRenderer.prototype.createElement=function(parent,name,debugInfo){var nsAndName=splitNamespace(name),el=isPresent(nsAndName[0])?getDOM().createElementNS(NAMESPACE_URIS[nsAndName[0]],nsAndName[1]):getDOM().createElement(nsAndName[1]);return isPresent(this._contentAttr)&&getDOM().setAttribute(el,this._contentAttr,""),isPresent(parent)&&getDOM().appendChild(parent,el),el},DomRenderer.prototype.createViewRoot=function(hostElement){var nodesParent;if(this.componentProto.encapsulation===_angular_core.ViewEncapsulation.Native){nodesParent=getDOM().createShadowRoot(hostElement),this._rootRenderer.sharedStylesHost.addHost(nodesParent);for(var i=0;i<this._styles.length;i++)getDOM().appendChild(nodesParent,getDOM().createStyleElement(this._styles[i]))}else isPresent(this._hostAttr)&&getDOM().setAttribute(hostElement,this._hostAttr,""),nodesParent=hostElement;return nodesParent},DomRenderer.prototype.createTemplateAnchor=function(parentElement,debugInfo){var comment=getDOM().createComment(TEMPLATE_COMMENT_TEXT);return isPresent(parentElement)&&getDOM().appendChild(parentElement,comment),comment},DomRenderer.prototype.createText=function(parentElement,value,debugInfo){var node=getDOM().createTextNode(value);return isPresent(parentElement)&&getDOM().appendChild(parentElement,node),node},DomRenderer.prototype.projectNodes=function(parentElement,nodes){isBlank(parentElement)||appendNodes(parentElement,nodes)},DomRenderer.prototype.attachViewAfter=function(node,viewRootNodes){moveNodesAfterSibling(node,viewRootNodes)},DomRenderer.prototype.detachView=function(viewRootNodes){for(var i=0;i<viewRootNodes.length;i++)getDOM().remove(viewRootNodes[i])},DomRenderer.prototype.destroyView=function(hostElement,viewAllNodes){this.componentProto.encapsulation===_angular_core.ViewEncapsulation.Native&&isPresent(hostElement)&&this._rootRenderer.sharedStylesHost.removeHost(getDOM().getShadowRoot(hostElement))},DomRenderer.prototype.listen=function(renderElement,name,callback){return this._rootRenderer.eventManager.addEventListener(renderElement,name,decoratePreventDefault(callback))},DomRenderer.prototype.listenGlobal=function(target,name,callback){return this._rootRenderer.eventManager.addGlobalEventListener(target,name,decoratePreventDefault(callback))},DomRenderer.prototype.setElementProperty=function(renderElement,propertyName,propertyValue){getDOM().setProperty(renderElement,propertyName,propertyValue)},DomRenderer.prototype.setElementAttribute=function(renderElement,attributeName,attributeValue){var attrNs,nsAndName=splitNamespace(attributeName);isPresent(nsAndName[0])&&(attributeName=nsAndName[0]+":"+nsAndName[1],attrNs=NAMESPACE_URIS[nsAndName[0]]),isPresent(attributeValue)?isPresent(attrNs)?getDOM().setAttributeNS(renderElement,attrNs,attributeName,attributeValue):getDOM().setAttribute(renderElement,attributeName,attributeValue):isPresent(attrNs)?getDOM().removeAttributeNS(renderElement,attrNs,nsAndName[1]):getDOM().removeAttribute(renderElement,attributeName)},DomRenderer.prototype.setBindingDebugInfo=function(renderElement,propertyName,propertyValue){var dashCasedPropertyName=camelCaseToDashCase(propertyName);if(getDOM().isCommentNode(renderElement)){var existingBindings=StringWrapper.replaceAll(getDOM().getText(renderElement),/\n/g,"").match(TEMPLATE_BINDINGS_EXP),parsedBindings=Json.parse(existingBindings[1]);parsedBindings[dashCasedPropertyName]=propertyValue,getDOM().setText(renderElement,StringWrapper.replace(TEMPLATE_COMMENT_TEXT,"{}",Json.stringify(parsedBindings)))}else this.setElementAttribute(renderElement,propertyName,propertyValue)},DomRenderer.prototype.setElementClass=function(renderElement,className,isAdd){isAdd?getDOM().addClass(renderElement,className):getDOM().removeClass(renderElement,className)},DomRenderer.prototype.setElementStyle=function(renderElement,styleName,styleValue){isPresent(styleValue)?getDOM().setStyle(renderElement,styleName,stringify(styleValue)):getDOM().removeStyle(renderElement,styleName)},DomRenderer.prototype.invokeElementMethod=function(renderElement,methodName,args){getDOM().invoke(renderElement,methodName,args)},DomRenderer.prototype.setText=function(renderNode,text){getDOM().setText(renderNode,text)},DomRenderer.prototype.animate=function(element,startingStyles,keyframes,duration,delay,easing){return this._animationDriver.animate(element,startingStyles,keyframes,duration,delay,easing)},DomRenderer}(),COMPONENT_REGEX=/%COMP%/g,COMPONENT_VARIABLE="%COMP%",HOST_ATTR="_nghost-"+COMPONENT_VARIABLE,CONTENT_ATTR="_ngcontent-"+COMPONENT_VARIABLE,NS_PREFIX_RE=/^:([^:]+):(.+)$/,CORE_TOKENS={ApplicationRef:_angular_core.ApplicationRef,NgZone:_angular_core.NgZone},INSPECT_GLOBAL_NAME="ng.probe",CORE_TOKENS_GLOBAL_NAME="ng.coreTokens",NgProbeToken=function(){function NgProbeToken(name,token){this.name=name,this.token=token}return NgProbeToken}(),ELEMENT_PROBE_PROVIDERS=[{provide:_angular_core.RootRenderer,useFactory:_createConditionalRootRenderer,deps:[DomRootRenderer,[NgProbeToken,new _angular_core.Optional]]}],__extends$5=([{provide:_angular_core.RootRenderer,useFactory:_createRootRenderer,deps:[DomRootRenderer,[NgProbeToken,new _angular_core.Optional]]}],this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}),DomEventsPlugin=function(_super){function DomEventsPlugin(){_super.apply(this,arguments)}return __extends$5(DomEventsPlugin,_super),DomEventsPlugin.prototype.supports=function(eventName){return!0},DomEventsPlugin.prototype.addEventListener=function(element,eventName,handler){var zone=this.manager.getZone(),outsideHandler=function(event){return zone.runGuarded(function(){return handler(event)})};return this.manager.getZone().runOutsideAngular(function(){return getDOM().onAndCancel(element,eventName,outsideHandler)})},DomEventsPlugin.prototype.addGlobalEventListener=function(target,eventName,handler){var element=getDOM().getGlobalEventTarget(target),zone=this.manager.getZone(),outsideHandler=function(event){return zone.runGuarded(function(){return handler(event)})};return this.manager.getZone().runOutsideAngular(function(){return getDOM().onAndCancel(element,eventName,outsideHandler)})},DomEventsPlugin.decorators=[{type:_angular_core.Injectable}],DomEventsPlugin.ctorParameters=[],DomEventsPlugin}(EventManagerPlugin),__extends$7=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_eventNames={pan:!0,panstart:!0,panmove:!0,panend:!0,pancancel:!0,panleft:!0,panright:!0,panup:!0,pandown:!0,pinch:!0,pinchstart:!0,pinchmove:!0,pinchend:!0,pinchcancel:!0,pinchin:!0,pinchout:!0,press:!0,pressup:!0,rotate:!0,rotatestart:!0,rotatemove:!0,rotateend:!0,rotatecancel:!0,swipe:!0,swipeleft:!0,swiperight:!0,swipeup:!0,swipedown:!0,tap:!0},HammerGesturesPluginCommon=function(_super){function HammerGesturesPluginCommon(){_super.call(this)}return __extends$7(HammerGesturesPluginCommon,_super),HammerGesturesPluginCommon.prototype.supports=function(eventName){return _eventNames.hasOwnProperty(eventName.toLowerCase())},HammerGesturesPluginCommon}(EventManagerPlugin),__extends$6=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},HAMMER_GESTURE_CONFIG=new _angular_core.OpaqueToken("HammerGestureConfig"),HammerGestureConfig=function(){function HammerGestureConfig(){this.events=[],this.overrides={}}return HammerGestureConfig.prototype.buildHammer=function(element){var mc=new Hammer(element);mc.get("pinch").set({enable:!0}),mc.get("rotate").set({enable:!0});for(var eventName in this.overrides)mc.get(eventName).set(this.overrides[eventName]);return mc},HammerGestureConfig.decorators=[{type:_angular_core.Injectable}],HammerGestureConfig.ctorParameters=[],HammerGestureConfig}(),HammerGesturesPlugin=function(_super){function HammerGesturesPlugin(_config){_super.call(this),this._config=_config}return __extends$6(HammerGesturesPlugin,_super),HammerGesturesPlugin.prototype.supports=function(eventName){if(!_super.prototype.supports.call(this,eventName)&&!this.isCustomEvent(eventName))return!1;if(!isPresent(window.Hammer))throw new Error("Hammer.js is not loaded, can not bind "+eventName+" event");return!0},HammerGesturesPlugin.prototype.addEventListener=function(element,eventName,handler){var _this=this,zone=this.manager.getZone();return eventName=eventName.toLowerCase(),zone.runOutsideAngular(function(){var mc=_this._config.buildHammer(element),callback=function(eventObj){zone.runGuarded(function(){handler(eventObj)})};return mc.on(eventName,callback),function(){mc.off(eventName,callback)}})},HammerGesturesPlugin.prototype.isCustomEvent=function(eventName){return this._config.events.indexOf(eventName)>-1},HammerGesturesPlugin.decorators=[{type:_angular_core.Injectable}],HammerGesturesPlugin.ctorParameters=[{type:HammerGestureConfig,decorators:[{type:_angular_core.Inject,args:[HAMMER_GESTURE_CONFIG]}]}],HammerGesturesPlugin}(HammerGesturesPluginCommon),__extends$8=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},modifierKeys=["alt","control","meta","shift"],modifierKeyGetters={alt:function(event){return event.altKey},control:function(event){return event.ctrlKey},meta:function(event){return event.metaKey},shift:function(event){return event.shiftKey}},KeyEventsPlugin=function(_super){function KeyEventsPlugin(){_super.call(this)}return __extends$8(KeyEventsPlugin,_super),KeyEventsPlugin.prototype.supports=function(eventName){return isPresent(KeyEventsPlugin.parseEventName(eventName))},KeyEventsPlugin.prototype.addEventListener=function(element,eventName,handler){var parsedEvent=KeyEventsPlugin.parseEventName(eventName),outsideHandler=KeyEventsPlugin.eventCallback(element,StringMapWrapper.get(parsedEvent,"fullKey"),handler,this.manager.getZone());return this.manager.getZone().runOutsideAngular(function(){return getDOM().onAndCancel(element,StringMapWrapper.get(parsedEvent,"domEventName"),outsideHandler)})},KeyEventsPlugin.parseEventName=function(eventName){var parts=eventName.toLowerCase().split("."),domEventName=parts.shift();if(0===parts.length||!StringWrapper.equals(domEventName,"keydown")&&!StringWrapper.equals(domEventName,"keyup"))return null;var key=KeyEventsPlugin._normalizeKey(parts.pop()),fullKey="";if(modifierKeys.forEach(function(modifierName){ListWrapper.contains(parts,modifierName)&&(ListWrapper.remove(parts,modifierName),fullKey+=modifierName+".")}),fullKey+=key,0!=parts.length||0===key.length)return null;var result={};return StringMapWrapper.set(result,"domEventName",domEventName),StringMapWrapper.set(result,"fullKey",fullKey),result},KeyEventsPlugin.getEventFullKey=function(event){var fullKey="",key=getDOM().getEventKey(event);return key=key.toLowerCase(),StringWrapper.equals(key," ")?key="space":StringWrapper.equals(key,".")&&(key="dot"),modifierKeys.forEach(function(modifierName){if(modifierName!=key){var modifierGetter=StringMapWrapper.get(modifierKeyGetters,modifierName);modifierGetter(event)&&(fullKey+=modifierName+".")}}),fullKey+=key},KeyEventsPlugin.eventCallback=function(element,fullKey,handler,zone){return function(event){StringWrapper.equals(KeyEventsPlugin.getEventFullKey(event),fullKey)&&zone.runGuarded(function(){return handler(event)})}},KeyEventsPlugin._normalizeKey=function(keyName){switch(keyName){case"esc":return"escape";default:return keyName}},KeyEventsPlugin.decorators=[{type:_angular_core.Injectable}],KeyEventsPlugin.ctorParameters=[],KeyEventsPlugin}(EventManagerPlugin),SAFE_URL_PATTERN=/^(?:(?:https?|mailto|ftp|tel|file):|[^&:\/?#]*(?:[\/?#]|$))/gi,DATA_URL_PATTERN=/^data:(?:image\/(?:bmp|gif|jpeg|jpg|png|tiff|webp)|video\/(?:mpeg|mp4|ogg|webm)|audio\/(?:mp3|oga|ogg|opus));base64,[a-z0-9+\/]+=*$/i,inertElement=null,DOM=null,VOID_ELEMENTS=tagSet("area,br,col,hr,img,wbr"),OPTIONAL_END_TAG_BLOCK_ELEMENTS=tagSet("colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr"),OPTIONAL_END_TAG_INLINE_ELEMENTS=tagSet("rp,rt"),OPTIONAL_END_TAG_ELEMENTS=merge(OPTIONAL_END_TAG_INLINE_ELEMENTS,OPTIONAL_END_TAG_BLOCK_ELEMENTS),BLOCK_ELEMENTS=merge(OPTIONAL_END_TAG_BLOCK_ELEMENTS,tagSet("address,article,aside,blockquote,caption,center,del,details,dialog,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,h6,header,hgroup,hr,ins,main,map,menu,nav,ol,pre,section,summary,table,ul")),INLINE_ELEMENTS=merge(OPTIONAL_END_TAG_INLINE_ELEMENTS,tagSet("a,abbr,acronym,audio,b,bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,picture,q,ruby,rp,rt,s,samp,small,source,span,strike,strong,sub,sup,time,track,tt,u,var,video")),VALID_ELEMENTS=merge(VOID_ELEMENTS,BLOCK_ELEMENTS,INLINE_ELEMENTS,OPTIONAL_END_TAG_ELEMENTS),URI_ATTRS=tagSet("background,cite,href,itemtype,longdesc,poster,src,xlink:href"),SRCSET_ATTRS=tagSet("srcset"),HTML_ATTRS=tagSet("abbr,accesskey,align,alt,autoplay,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,compact,controls,coords,datetime,default,dir,download,face,headers,height,hidden,hreflang,hspace,ismap,itemscope,itemprop,kind,label,lang,language,loop,media,muted,nohref,nowrap,open,preload,rel,rev,role,rows,rowspan,rules,scope,scrolling,shape,size,sizes,span,srclang,start,summary,tabindex,target,title,translate,type,usemap,valign,value,vspace,width"),VALID_ATTRS=merge(URI_ATTRS,SRCSET_ATTRS,HTML_ATTRS),SanitizingHtmlSerializer=function(){function SanitizingHtmlSerializer(){this.sanitizedSomething=!1,this.buf=[]}return SanitizingHtmlSerializer.prototype.sanitizeChildren=function(el){for(var current=el.firstChild;current;)if(DOM.isElementNode(current)?this.startElement(current):DOM.isTextNode(current)?this.chars(DOM.nodeValue(current)):this.sanitizedSomething=!0,DOM.firstChild(current))current=DOM.firstChild(current);else for(;current;){if(DOM.isElementNode(current)&&this.endElement(current),DOM.nextSibling(current)){current=DOM.nextSibling(current);break}current=DOM.parentElement(current)}return this.buf.join("")},SanitizingHtmlSerializer.prototype.startElement=function(element){var _this=this,tagName=DOM.nodeName(element).toLowerCase();return VALID_ELEMENTS.hasOwnProperty(tagName)?(this.buf.push("<"),this.buf.push(tagName),DOM.attributeMap(element).forEach(function(value,attrName){var lower=attrName.toLowerCase();return VALID_ATTRS.hasOwnProperty(lower)?(URI_ATTRS[lower]&&(value=sanitizeUrl(value)),SRCSET_ATTRS[lower]&&(value=sanitizeSrcset(value)),_this.buf.push(" "),_this.buf.push(attrName),_this.buf.push('="'),_this.buf.push(encodeEntities(value)),void _this.buf.push('"')):void(_this.sanitizedSomething=!0)}),void this.buf.push(">")):void(this.sanitizedSomething=!0)},SanitizingHtmlSerializer.prototype.endElement=function(current){var tagName=DOM.nodeName(current).toLowerCase();VALID_ELEMENTS.hasOwnProperty(tagName)&&!VOID_ELEMENTS.hasOwnProperty(tagName)&&(this.buf.push("</"),this.buf.push(tagName),this.buf.push(">"))},SanitizingHtmlSerializer.prototype.chars=function(chars){this.buf.push(encodeEntities(chars))},SanitizingHtmlSerializer}(),SURROGATE_PAIR_REGEXP=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g,NON_ALPHANUMERIC_REGEXP=/([^\#-~ |!])/g,VALUES="[-,.\"'%_!# a-zA-Z0-9]+",TRANSFORMATION_FNS="(?:matrix|translate|scale|rotate|skew|perspective)(?:X|Y|3d)?",COLOR_FNS="(?:rgb|hsl)a?",FN_ARGS="\\([-0-9.%, a-zA-Z]+\\)",SAFE_STYLE_VALUE=new RegExp("^("+VALUES+"|(?:"+TRANSFORMATION_FNS+"|"+COLOR_FNS+")"+FN_ARGS+")$","g"),URL_RE=/^url\(([^)]+)\)$/,__extends$9=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},DomSanitizer=function(){function DomSanitizer(){}return DomSanitizer}(),DomSanitizerImpl=function(_super){function DomSanitizerImpl(){_super.apply(this,arguments)}return __extends$9(DomSanitizerImpl,_super),DomSanitizerImpl.prototype.sanitize=function(ctx,value){if(null==value)return null;switch(ctx){case _angular_core.SecurityContext.NONE:return value;case _angular_core.SecurityContext.HTML:return value instanceof SafeHtmlImpl?value.changingThisBreaksApplicationSecurity:(this.checkNotSafeValue(value,"HTML"),sanitizeHtml(String(value)));case _angular_core.SecurityContext.STYLE:return value instanceof SafeStyleImpl?value.changingThisBreaksApplicationSecurity:(this.checkNotSafeValue(value,"Style"),sanitizeStyle(value));case _angular_core.SecurityContext.SCRIPT:if(value instanceof SafeScriptImpl)return value.changingThisBreaksApplicationSecurity;throw this.checkNotSafeValue(value,"Script"),new Error("unsafe value used in a script context");case _angular_core.SecurityContext.URL:return value instanceof SafeResourceUrlImpl||value instanceof SafeUrlImpl?value.changingThisBreaksApplicationSecurity:(this.checkNotSafeValue(value,"URL"),sanitizeUrl(String(value)));case _angular_core.SecurityContext.RESOURCE_URL:if(value instanceof SafeResourceUrlImpl)return value.changingThisBreaksApplicationSecurity;throw this.checkNotSafeValue(value,"ResourceURL"),new Error("unsafe value used in a resource URL context (see http://g.co/ng/security#xss)");default:throw new Error("Unexpected SecurityContext "+ctx+" (see http://g.co/ng/security#xss)")}},DomSanitizerImpl.prototype.checkNotSafeValue=function(value,expectedType){if(value instanceof SafeValueImpl)throw new Error("Required a safe "+expectedType+", got a "+value.getTypeName()+" (see http://g.co/ng/security#xss)")},DomSanitizerImpl.prototype.bypassSecurityTrustHtml=function(value){return new SafeHtmlImpl(value)},DomSanitizerImpl.prototype.bypassSecurityTrustStyle=function(value){return new SafeStyleImpl(value)},DomSanitizerImpl.prototype.bypassSecurityTrustScript=function(value){return new SafeScriptImpl(value)},DomSanitizerImpl.prototype.bypassSecurityTrustUrl=function(value){return new SafeUrlImpl(value)},DomSanitizerImpl.prototype.bypassSecurityTrustResourceUrl=function(value){return new SafeResourceUrlImpl(value)},DomSanitizerImpl.decorators=[{type:_angular_core.Injectable}],DomSanitizerImpl.ctorParameters=[],DomSanitizerImpl}(DomSanitizer),SafeValueImpl=function(){function SafeValueImpl(changingThisBreaksApplicationSecurity){this.changingThisBreaksApplicationSecurity=changingThisBreaksApplicationSecurity}return SafeValueImpl.prototype.toString=function(){return"SafeValue must use [property]=binding: "+this.changingThisBreaksApplicationSecurity+" (see http://g.co/ng/security#xss)"},SafeValueImpl}(),SafeHtmlImpl=function(_super){function SafeHtmlImpl(){_super.apply(this,arguments)}return __extends$9(SafeHtmlImpl,_super),SafeHtmlImpl.prototype.getTypeName=function(){return"HTML"},SafeHtmlImpl}(SafeValueImpl),SafeStyleImpl=function(_super){function SafeStyleImpl(){_super.apply(this,arguments)}return __extends$9(SafeStyleImpl,_super),SafeStyleImpl.prototype.getTypeName=function(){return"Style"},SafeStyleImpl}(SafeValueImpl),SafeScriptImpl=function(_super){function SafeScriptImpl(){_super.apply(this,arguments)}return __extends$9(SafeScriptImpl,_super),SafeScriptImpl.prototype.getTypeName=function(){return"Script"},SafeScriptImpl}(SafeValueImpl),SafeUrlImpl=function(_super){function SafeUrlImpl(){_super.apply(this,arguments)}return __extends$9(SafeUrlImpl,_super),SafeUrlImpl.prototype.getTypeName=function(){return"URL"},SafeUrlImpl}(SafeValueImpl),SafeResourceUrlImpl=function(_super){function SafeResourceUrlImpl(){_super.apply(this,arguments)}return __extends$9(SafeResourceUrlImpl,_super),SafeResourceUrlImpl.prototype.getTypeName=function(){return"ResourceURL"},SafeResourceUrlImpl}(SafeValueImpl),INTERNAL_BROWSER_PLATFORM_PROVIDERS=[{provide:_angular_core.PLATFORM_INITIALIZER,useValue:initDomAdapter,multi:!0},{provide:_angular_common.PlatformLocation,useClass:BrowserPlatformLocation}],BROWSER_SANITIZATION_PROVIDERS=[{provide:_angular_core.Sanitizer,useExisting:DomSanitizer},{provide:DomSanitizer,useClass:DomSanitizerImpl}],platformBrowser=_angular_core.createPlatformFactory(_angular_core.platformCore,"browser",INTERNAL_BROWSER_PLATFORM_PROVIDERS),BrowserModule=function(){function BrowserModule(parentModule){if(parentModule)throw new Error("BrowserModule has already been loaded. If you need access to common directives such as NgIf and NgFor from a lazy loaded module, import CommonModule instead.")}return BrowserModule.decorators=[{type:_angular_core.NgModule,args:[{providers:[BROWSER_SANITIZATION_PROVIDERS,{provide:_angular_core.ErrorHandler,useFactory:errorHandler,deps:[]},{provide:DOCUMENT,useFactory:_document,deps:[]},{provide:EVENT_MANAGER_PLUGINS,useClass:DomEventsPlugin,multi:!0},{provide:EVENT_MANAGER_PLUGINS,useClass:KeyEventsPlugin,multi:!0},{provide:EVENT_MANAGER_PLUGINS,useClass:HammerGesturesPlugin,multi:!0},{provide:HAMMER_GESTURE_CONFIG,useClass:HammerGestureConfig},{provide:DomRootRenderer,useClass:DomRootRenderer_},{provide:_angular_core.RootRenderer,useExisting:DomRootRenderer},{provide:SharedStylesHost,useExisting:DomSharedStylesHost},{provide:AnimationDriver,useFactory:_resolveDefaultAnimationDriver},DomSharedStylesHost,_angular_core.Testability,EventManager,ELEMENT_PROBE_PROVIDERS,Title],exports:[_angular_common.CommonModule,_angular_core.ApplicationModule]}]}],BrowserModule.ctorParameters=[{type:BrowserModule,decorators:[{type:_angular_core.Optional},{type:_angular_core.SkipSelf}]}],BrowserModule}(),win="undefined"!=typeof window&&window||{},ChangeDetectionPerfRecord=function(){function ChangeDetectionPerfRecord(msPerTick,numTicks){this.msPerTick=msPerTick,this.numTicks=numTicks}return ChangeDetectionPerfRecord}(),AngularTools=function(){function AngularTools(ref){this.profiler=new AngularProfiler(ref)}return AngularTools}(),AngularProfiler=function(){function AngularProfiler(ref){this.appRef=ref.injector.get(_angular_core.ApplicationRef);
}return AngularProfiler.prototype.timeChangeDetection=function(config){var record=isPresent(config)&&config.record,profileName="Change Detection",isProfilerAvailable=isPresent(win.console.profile);record&&isProfilerAvailable&&win.console.profile(profileName);for(var start=getDOM().performanceNow(),numTicks=0;numTicks<5||getDOM().performanceNow()-start<500;)this.appRef.tick(),numTicks++;var end=getDOM().performanceNow();record&&isProfilerAvailable&&win.console.profileEnd(profileName);var msPerTick=(end-start)/numTicks;return win.console.log("ran "+numTicks+" change detection cycles"),win.console.log(NumberWrapper.toFixed(msPerTick,2)+" ms per check"),new ChangeDetectionPerfRecord(msPerTick,numTicks)},AngularProfiler}(),context=global$1,By=function(){function By(){}return By.all=function(){return function(debugElement){return!0}},By.css=function(selector){return function(debugElement){return!!isPresent(debugElement.nativeElement)&&getDOM().elementMatches(debugElement.nativeElement,selector)}},By.directive=function(type){return function(debugElement){return debugElement.providerTokens.indexOf(type)!==-1}},By}(),__platform_browser_private__={BrowserPlatformLocation:BrowserPlatformLocation,DomAdapter:DomAdapter,BrowserDomAdapter:BrowserDomAdapter,BrowserGetTestability:BrowserGetTestability,getDOM:getDOM,setRootDomAdapter:setRootDomAdapter,DomRootRenderer_:DomRootRenderer_,DomRootRenderer:DomRootRenderer,DomSharedStylesHost:DomSharedStylesHost,SharedStylesHost:SharedStylesHost,ELEMENT_PROBE_PROVIDERS:ELEMENT_PROBE_PROVIDERS,DomEventsPlugin:DomEventsPlugin,KeyEventsPlugin:KeyEventsPlugin,HammerGesturesPlugin:HammerGesturesPlugin,initDomAdapter:initDomAdapter,INTERNAL_BROWSER_PLATFORM_PROVIDERS:INTERNAL_BROWSER_PLATFORM_PROVIDERS,BROWSER_SANITIZATION_PROVIDERS:BROWSER_SANITIZATION_PROVIDERS};exports.BrowserModule=BrowserModule,exports.platformBrowser=platformBrowser,exports.Title=Title,exports.disableDebugTools=disableDebugTools,exports.enableDebugTools=enableDebugTools,exports.AnimationDriver=AnimationDriver,exports.By=By,exports.NgProbeToken=NgProbeToken,exports.DOCUMENT=DOCUMENT,exports.EVENT_MANAGER_PLUGINS=EVENT_MANAGER_PLUGINS,exports.EventManager=EventManager,exports.HAMMER_GESTURE_CONFIG=HAMMER_GESTURE_CONFIG,exports.HammerGestureConfig=HammerGestureConfig,exports.DomSanitizer=DomSanitizer,exports.__platform_browser_private__=__platform_browser_private__});
